function a=qq_eval(an)

global metset quantset resolveset fileset loadset locset
qq_message(2);

% String
if strcmp(an,'str')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 eval([varname '=''' string ''';']); end
end

% Any number
if strcmp(an,'an')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 oldval=eval([varname ';']); else oldval=1; end
    a=str2num(string); 
    if isempty(a) t_message(1,'|r|Numeric input only'); a=oldval; end
    string=num2str(a); set(gcbo,'String',string);
    if isempty(varname)==0 eval([varname '=' string ';']); end
end

% Any integer
if strcmp(an,'ai')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 oldval=eval([varname ';']); else oldval=1; end 
    a=round(str2num(string)); 
    if isempty(a) qq_message(1,'|r|Integer input only'); a=oldval; end
    string=num2str(a); set(gcbo,'String',string);
    if isempty(varname)==0 eval([varname '=' string ';']); end
end    

% Positive integer
if strcmp(an,'pi')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 oldval=eval([varname ';']); else oldval=1; end 
    a=str2num(string); 
    if isempty(a) qq_message(1,'|r|Integer input only'); a=oldval; end
    if a>floor(a) qq_message(1,'|r|Integer input only'); a=oldval; end
    if a<1 qq_message(1,'|r|Positive integer input only'); a=oldval; end 
    string=num2str(a); set(gcbo,'String',string);
    if isempty(varname)==0 eval([varname '=' string ';']); end
    
end

% Positive integer (incl 0)
if strcmp(an,'pi0')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 oldval=eval([varname ';']); else oldval=0; end 
    a=str2num(string); 
    if isempty(a) qq_message(1,'|r|Integer input only'); a=oldval; end
    if a>floor(a); qq_message(1,'|r|Integer input only'); a=oldval; end
    if a<0 qq_message(1,'|r|Positive integer input only'); a=oldval; end 
    string=num2str(a); set(gcbo,'String',string);
    if isempty(varname)==0 eval([varname '=' string ';']); end
end

% Positive number
if strcmp(an,'pn')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 oldval=eval([varname ';']); else oldval=1; end
    a=str2num(string); 
    if isempty(a) qq_message(1,'|r|Numeric input only'); a=oldval; end
    if a<=0 qq_message(1,'|r|Positive input only'); a=oldval; end
    string=num2str(a); set(gcbo,'String',string);
    if isempty(varname)==0 eval([varname '=' string ';']); end  
end

% Positive number including 0
if strcmp(an,'pn0')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 oldval=eval([varname ';']); else oldval=1; end
    a=str2num(string); 
    if isempty(a) qq_message(1,'|r|Numeric input only'); a=oldval; end
    if a<0 qq_message(1,'|r|Positive input only (including 0)'); a=oldval; end
    string=num2str(a); set(gcbo,'String',string);
    if isempty(varname)==0 eval([varname '=' string ';']); end  
end

% Positive number, non-numeric set to []
if strcmp(an,'pn-')
    varname=get(gcbo,'Tag'); string=get(gcbo,'String'); 
    if isempty(varname)==0 oldval=eval([varname ';']); else oldval=1; end
    a=str2num(string);
    if a<=0 qq_message(1,'|r|Positive input only'); a=oldval; end
    string=num2str(a); if isempty(a) string='[]'; end
    if isempty(varname)==0 eval([varname '=' string ';']); end
    if isempty(a) string=''; end; set(gcbo,'String',string); 
end

% Radiobuttons
if strcmp(an,'rb')
    varname=get(gcbo,'Tag'); h=findobj('Tag',varname); set(h,'Value',0); set(gcbo,'Value',1);
end

% Checkbox
if strcmp(an,'ch')
    varname=get(gcbo,'Tag'); val=get(gcbo,'Value'); eval([varname '=' num2str(val) ';']);   
end

    