function qq_extcall(call)
% function qq_extcall(call)
% Funksjon koblet til hovedvinduet


global XBL XR fileset metset CL RE fonts locset
%global status

if nargin<1 call=0; end

if call==0
    openwin
end

qq_message(2); % Blanker ut meldinger
   

% BATCH
if call==8 
    save('c:\qq\qq_batchtempsave','CL','XBL','XR','RE','fileset');
    qq_batchcall(0); 
end


% -------------------------------------------------------------------------
% ----------------- S U B F U N C T I O N S -------------------------------
% -------------------------------------------------------------------------



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset locset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height
o1=bw*3+bw/2; % Offset for gruppe 2

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='AddWin'; winpar{2}='Q: Addons';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');

% BATCH
p=p+1;[ui{p,1:7}] = deal('Batch1','Pushbutton',colors.btn{1},[x(1) y(10) bw bh],'qq_extcall(8)',2,'FButton');
% UCM-quant
p=p+1;[ui{p,1:7}] = deal('UCM-Quant','Pushbutton',colors.btn{1},[x(1) y(11) bw bh],'qq_ucmcall(0)',2,'UCMButton');

% 2D-FARI
p=p+1;[ui{p,1:7}] = deal('2D-FARI','Pushbutton',colors.btn{5},[x(1) y(12) bw bh],'qq_2dfari(0)',2,'2DFARIButton');

% CHECK SPECTRA
p=p+1;[ui{p,1:7}] = deal('Check Spectr','Pushbutton',colors.btn{5},[x(1) y(13) bw bh],'qq_checkspectra(0)',2,'FButton');

% LIBRARY
p=p+1;[ui{p,1:7}] = deal('Libr. Manager','Pushbutton',colors.btn{2},[x(1) y(15) bw bh],'qq_libmanager(0)',2,'');



updfcn='qq_extcall(100)'; 
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_extcall(96)')
set(h0,'CloseRequestFcn','qq_extcall(99)')

if locset.tracker==0
    h=findobj('Tag','UCMButton'); set(h,'Enable','off')
    h=findobj('Tag','2DFARIButton'); set(h,'Enable','off')
end
%










   



        












