function qq_lib_search(an,peaknr)

global fileset metset RE locset 
persistent TEST list_nr testpeak Searchres n_entries Library 

%if nargin<2; peaknr=0; end; peaknr % TEMP

if locset.tracker==1 disp(['--- qq_lib_search(an) --- ' num2str(an)]); end
if isfield(metset,'library_ramstore')==0 metset.library_ramstore=0; end

qq_message(2)
updlist=0; updplot=1;
%if an==1 updplot=0; end % TEMP

if isempty(metset.library_search) qq_message(1,'|r|No library selected'); end

% Frste call pner vindu , Initial settings
if an==1 && ~isempty(metset.library_search)
    % Definerer testspektrum
    testpeak=peaknr;
    TEST.S=RE(testpeak).S;             % Spektrum
    TEST.pn=testpeak;                  % Peak number  
    TEST.rt=RE(testpeak).rt;           % Retensjonstid
    TEST.clunr=RE(testpeak).clu_nr;    % cluster nr
    TEST.single='Extracted'; if RE(testpeak).peaksincl==1 TEST.single='Single'; end
    TEST.ions=fileset.ions;
    TEST.ri_calc=RE(testpeak).ri_calc; % Beregnet retensjonsindex
    % vrige settings
    list_nr=1;                         % Posisjon i resultatliste
    if isfield(metset,'library_root')==0; metset.library_root=1; end
    %if isfield(metset,'library_ramstore')==0 metset.library_ramstore=1; end
    updlist=1;   
    updplot=0; 
    openwin;
end

% NYTT NAVN
if an == 2 && ~isempty(metset.library_search)
    LibraryEdit=findobj('Tag','LibraryEdit'); metset.library_name=get(LibraryEdit,'String');
    updlist=1;
end
    
% Oppdaterer n_entries, Sjekker om bibliotek finnes og leser til minnet
if (an==1 || an==2) && ~isempty(metset.library_search)
    if isempty(n_entries) || n_entries==0 || metset.library_ramstore==0
        [n_entries,Library]=getlib2; 
    end
    [m,n_libs]=size(metset.library_search); 
    EntriesTxt=findobj('Tag','EntriesTxt');
    set(EntriesTxt,'String',[num2str(n_libs),' Active Libraries.  ',num2str(n_entries),' Entries']);
    if n_entries==0; qq_message(1,'|r|No libraries found. Check library settings'); end
    
end

% Set RI parametre
if an>6.0 && an<7.0
     h=findobj('Tag','RiCheckRadio'); set(h,'Value',0); set(gcbo,'Value',1)
     if an==6.1 metset.library_rimatch=1; end
     if an==6.2 metset.library_rimatch=2; end
     if an==6.3 metset.library_rimatch=3; end
     updlist=1;
end

% Set root spectrum
if an==7.1 
    h=findobj('Tag','RootEdit');  metset.library_root=round(str2num(get(h,'string'))); 
    if metset.library_root<1 metset.library_root=1; set(h,'String',num2str(metset.library_root)); end
    updlist=1; updplot=1;
end

% Set match function
if an==8.1 || an==8.2
    h=findobj('Tag','MfCheckRadio'); set(h,'Value',0); 
    if an==8.1 metset.library_mf=1; set(gcbo,'Value',1); end
    if an==8.2 metset.library_mf=2; set(gcbo,'Value',1); end
    updlist=1;
end

if an==8.3 
    h=findobj('Tag','MatchIonsCheck'); metset.library_ionsinboth=get(h,'Value'); updlist=1;
end
    
if an==4
    BestMatchEdit=findobj('Tag','BestMatchEdit');
    val=str2double(get(BestMatchEdit,'String')); 
    if isnan(val) val=20; set(BestMatchEdit,'String','20'); end
    metset.library_showentr=str2double(get(BestMatchEdit,'String'));
    updlist=1;
end

% ACCEPT ID
if an==5 && list_nr==0 
    qq_message(1,'|r|No reference spectrum')
    updplot=0;
end
if an==5 && list_nr>0
    RE(testpeak).cmp_name=Searchres(list_nr).cmp_name;
    RE(testpeak).cmp_shortname=Searchres(list_nr).cmp_shortname;
    RE(testpeak).cmp_code=Searchres(list_nr).cmp_code;
    if isfield(Searchres,'ri_def') && ~isempty(Searchres(list_nr).ri_def)
        RE(testpeak).ri_def=Searchres(list_nr).ri_def;  
    else
        RE(testpeak).ri_def=NaN;
    end
    RE(testpeak).identified=1;
    qq_closewin;
    qq_resultscall(99);
    updplot=0;
end

% CLEAR ID
if an==11
    RE(testpeak).cmp_name=[];
    RE(testpeak).cmp_shortname=[];
    RE(testpeak).cmp_code=[];
    RE(testpeak).ri_def=[];
    RE(testpeak).identified=0;
    qq_closewin;
    qq_resultscall(99);
    updplot=0;
end
    
 % CLOSE
 if an==8
     qq_closewin;
     updplot=0;
 end

% Identify all 
if an==10 && ~isempty(metset.library_search)
    set(gcbo,'interruptible','off','HitTest','off')
    identifyall
    updplot=0;
end

if an==80
    %disp('--- qq_libsearch(80) ---') % TEMP
    %searchlibs=metset.library_search % TEMP
    qq_busy(1.1)
    [n_entries,Library]=getlib2; [m,n_libs]=size(metset.library_search); 
    updlist=0; updplot=0;
    qq_busy(0.1)
end

% UPDATE LIST
if updlist==1;
    Searchres=compare(TEST,Library);
    comparelist2(Searchres);
    if length(Searchres)>0 && Searchres(1).matchval<metset.library_treshold
        qq_message(1,['|r|Warning: Score lower than treshold (',num2str(metset.library_treshold),')'])
    end
    if an~=10 && length(Searchres)==0
        qq_message(1,['|r|Warning: Score lower than treshold (',num2str(metset.library_treshold),')'])
    end
    if length(Searchres)<1
        qq_message(1,'|r|Search gave no results. Check library settings')
    end
    updplot=1; % alltid oppdatere plot nr listen oppdateres
end

% UPDATE PLOTS
if updplot==1 && ~isempty(metset.library_search)
    %disp('--- plotupdate ---') % TEMP
    ResultsList1=findobj('Tag','ResultsList1'); list_nr=get(ResultsList1,'value');
    if length(Searchres)>0
        spectrum(Searchres(list_nr),TEST);
        referenceinfo(Searchres,list_nr);
        corrplot(Searchres(list_nr),TEST);
        ri_info(Searchres(list_nr),TEST);
    else
        h=findobj('Tag','Spectrumplot'); 
        if isempty(h)==0 h2=get(h(1),'parent'); h3=get(h2,'children'); delete(h3); end
        h=findobj('Tag','Corrplot'); 
        if isempty(h)==0 h2=get(h(1),'Parent'); h3=get(h2,'children'); delete(h3); end
        %qq_message(1,'|r|Search gave no results. Check library settings')
        InfoTxt=findobj('Tag','InfoTxt'); set(InfoTxt,'String',' ');
    end
end

% Key press
if an==96
   kp=double(get(gcf,'CurrentCharacter'));
   listh=findobj('Tag','ResultsList1');
   val=get(listh,'Value'); le=length(get(listh,'String'));
    if kp==31 val=val+1; if val>le val=le; end; end  % Arrow down   
    if kp==30 val=val-1; if val==0; val=1; end; end; % Arrow up
    set(listh,'Value',val);
end

% UPDATE
if an==100
    %
end

% Clear libraries on close
if an==5 || an==8 || an==11   
    if metset.library_ramstore==0
        n_entries=[]; Library=[];
    end
    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            S U B F U N C T I O N S
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% ------------- FUNCTION: RI_INFO ------------------------------------------
function ri_info(Libentry,TEST)

str{1}=['Test Rt: ' num2str(TEST.rt,'%-1.3f')];
if isfield(Libentry,'rt')
     str{1}=[str{1} ' (Diff: ' num2str(TEST.rt-Libentry.rt,'%-1.3f') ')'];
end
str{2}=['Test RI: ' num2str(TEST.ri_calc,'%-1.3f')];
if isfield(Libentry,'ri_calc') & ~isnan(Libentry.ri_calc)
    str{2}=[str{2} ' (Diff: ' num2str(TEST.ri_calc-Libentry.ri_calc,'%-1.3f') ')'];
    str{2}=[str{2} '  Score: ' num2str(Libentry.retentionmatch,'%-1.3f')];
end
h=findobj('Tag','InputTxt'); set(h,'String',str);


% ------------- FUNCTION: GETLIB2  ------------------------------------------
function [n_entries,CatLibrary]=getlib2
global metset locset

if locset.tracker disp('---- GETLIB2 / (qq_lib_search) ----'); end

n_entries=0; CatLibrary=[];
search_libs=metset.library_search;
[m,n_libs]=size(search_libs);

n_entries=0; em=[];
for x=1:n_libs
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',search_libs{x} '.mat'];
    if ~isempty(dir(filename)) % Checks that library exists
        load(filename,'Library')
        [Library.library_name]=deal(search_libs{x});
        n=length(Library);
        a=1:n; a=num2cell(a); a=cell2struct(a,'libentry',1); [Library(:).lib_entrynr]=deal(a(:).libentry);
        if x==1; 
            CatLibrary=Library;
        else
            Catfields=fieldnames(CatLibrary);
            for y=1:length(Catfields)
                if isfield(Library,Catfields{y})==0 [Library(:).(Catfields{y})]=deal(em); end
            end
            Libfields=fieldnames(Library);
            for y=1:length(Libfields)
                if isfield(CatLibrary,Libfields{y})==0 [CatLibrary(:).(Libfields{y})]=deal(em); end
            end
            CatLibrary=orderfields(CatLibrary);
            Library=orderfields(Library);
        end
        CatLibrary(n_entries+1:n_entries+n)=Library(1:n);
        n_entries=n_entries+n; 
    end
end


% ------------------- SUBFUNCTION: SPECTRUM3 -----------------------------
function spectrum(LIB,TEST)
global metset positions

if isequal(TEST.ions, LIB.ions) 
    SM(1,:)=TEST.ions; SM(2,:)=LIB.S; SM(3,:)=TEST.S;
    % disp('EQUAL IONS')
else
    % Finner alle ioner i LIB
    % disp('DIFFERENT IONS')
    for i1=1:length(LIB.ions)
        SM(1,i1)=LIB.ions(i1); SM(2,i1)=LIB.S(i1); pos=find(TEST.ions==LIB.ions(i1));
        if isempty(pos)==0 SM(3,i1)=TEST.S(pos); end
    end
    % Finner ioner i TEST som ikke er i LIB
    for i1=1:length(TEST.ions)
        t=find(LIB.ions==TEST.ions(i1)); if isempty(t); SM=[SM,[TEST.ions(i1);0;TEST.S(i1)]]; end
    end
    [dummy,sortind]=(sort(SM(1,:)));
    SM(:,:)=SM(:,sortind);
end

if isfield(metset,'library_root')==0 metset.library_root=1; end
if metset.library_root>1 SM(find(SM<0))=0; SM(2:3,:)=SM(2:3,:).^(1/metset.library_root); end

h=subplot('position',positions.smallplot); 
plot(0); 
h=bar(SM(1,:)',SM(2:3,:)'); set(h,'Tag','Spectrumplot');
minlim=min(min(SM(2:3,:))); maxlim=max(max(SM(2:3,:))); if minlim>0; minlim=0; end
ylim([minlim maxlim]); 
minx=min([TEST.ions LIB.ions]); maxx=max([TEST.ions LIB.ions]); xlim([minx-1 maxx+1]);  


% ----------------------------- SUBFUNCTION: CORRPLOT -------------------------------
function corrplot(LIB,TEST)
global metset positions

if isequal(TEST.ions, LIB.ions) 
    plotions=TEST.ions; lib_S=LIB.S; test_S=TEST.S;
    % disp('EQUAL IONS')
else
    % Finner alle ioner i LIB
    % disp('DIFFERENT IONS')
    p=0;
    for i1=1:length(TEST.ions)
        pos=find(LIB.ions==TEST.ions(i1));
        if isempty(pos)==0
            p=p+1; plotions(p)=TEST.ions(i1); test_S(p)=TEST.S(i1); lib_S(p)=LIB.S(pos); 
        end
    end
end

if metset.library_root>1 
    lib_S(find(lib_S<0.00001))=0; lib_S=lib_S.^(1/metset.library_root);
    test_S(find(test_S<0.00001))=0; test_S=test_S.^(1/metset.library_root);
end

h=subplot('position',positions.smallplot+[0 0.45 0 0]); 
plot(0); 
if length(lib_S)==length(test_S) && length(lib_S)>1
    h=plot(lib_S,test_S,'*r'); set(h,'Tag','Corrplot')
    %max_lib=max(lib_S); max_test=max(test_S);
    minlim=min([lib_S test_S]); maxlim=max([lib_S test_S]);
    xlim([minlim maxlim]); ylim([minlim maxlim]);
    line([minlim maxlim],[minlim maxlim]);
    for i1=1:length(plotions)
        text(lib_S(i1),test_S(i1),num2str(plotions(i1)))
    end

    % Beregner feilestimater
    mf1=corrcoef(lib_S,test_S); mf1=mf1(2,1); mf1=(mf1+1)*0.5; mf1=mf1*100;% Korrelasjonskoeffisient
    lib_S=lib_S/sum(lib_S); test_S=test_S/sum(test_S); % Normaliserer
    % mf2=((var(test_S)-var(lib_S-test_S))/var(test_S))^0.5; % forkl. var koeff.
    mf2=(var(test_S)-var(lib_S-test_S))/var(test_S); mf2=(mf2+1)*0.5; mf2=mf2*100;% forkl. var koeff.

    text(0.1,0.8,['MF1 (corrcoeff): ',num2str(mf1),'   MF2: ',num2str(mf2)],'units','normalized');
    text(0.05,0.95,'Testspectrum','units','normalized','fontweight','bold','horizontalalignment','left')
    text(0.95,0.05,'Library','units','normalized','fontweight','bold','horizontalalignment','right')
end


    
% --------- SUBFUNCTION: REFERENCEINFO ---------------------------------------------------------------------
function referenceinfo(Library,entry)

write{1}='-';
% Write{1}=['Library entry: ',num2str(entry,'%-1.0f')]; % lib_entrynr
if isfield(Library(entry),'library_name') Write{1}=['Library: ',Library(entry).library_name]; end
if isfield(Library(entry),'lib_entrynr')  Write{1}=[Write{1},'       Entry: ',num2str(Library(entry).lib_entrynr)]; end
if isfield(Library(entry),'file_name') Write{2}=['File Name: ',Library(entry).file_name]; end
if isfield(Library(entry),'rt') Write{3}=['Retention time: ',num2str(Library(entry).rt)]; end
%Write{4}=['Retention index (def): ',num2str(Library(entry).ri_def)];
if isfield(Library(entry),'ri_calc') Write{4}=['Retention index: ',num2str(Library(entry).ri_calc)]; end
if isfield(Library,'ri_def') && isempty(Library(entry).ri_def)==0 && isnan(Library(entry).ri_def)==0 
    Write{4}=[Write{4} ' (Def: ' num2str(Library(entry).ri_def) ')']; 
end
if isfield(Library(entry),'column') Write{5}=['Column: ',num2str(Library(entry).column)]; end
if isfield(Library(entry),'single') Write{6}=['Single/Extracted: ',Library(entry).single]; end
InfoTxt=findobj('Tag','InfoTxt'); set(InfoTxt,'String',Write);
if ischar(Library(entry).comments) set(InfoTxt,'TooltipString',Library(entry).comments); end


% ------------------ SUBFUNCTION: COLUMNFILTER ------------------------------
function Outlib=columnfilter(Inlib)
global metset

%disp('---- COLUMNFILTER ----')

Outlib=[];
if ~isempty(Inlib)

    n_entr=length(Inlib); [colcell{1:n_entr}] = deal(Inlib.column);
    allind=[];
    for x=1:length(metset.library_colsearch)
        selcol=metset.library_colsearch{x};
        ind=strmatch(selcol,colcell,'exact');
        allind=[allind; ind];
    end
    Outlib=Inlib(allind);
    
end


% ------------------ SUBFUNCTION: RIFILTER ------------------------------
function Outlib=rifilter(TEST,Inlib)
global metset

Outlib=[];

if ~isempty(Inlib) 

    if metset.library_rimatch==2 interval=metset.library_riinterval; end % Square
    if metset.library_rimatch==3 interval=metset.library_riinterval*3; end % Gaussian (3 times stdav)

    if metset.library_useri==1
        %disp('---- INDEX ----')
        rvect=cat(1,Inlib(:).ri_calc);
        rtest=TEST.ri_calc;   
    else
        %disp('---- TIME ----')
        rvect=cat(1,Inlib(:).rt);
        rtest=TEST.rt;
    end

    err=0;
    if isempty(rtest) err=1; disp('-- empty rtest --'); end
    if length(rvect) ~= length(Inlib) err=1; disp('-- vectors of different lengths --'); end

    if err==0
        resvect=abs(rvect-rtest(1)); ind=find(resvect<=interval); Outlib=Inlib(ind);
    else
        Outlib=Inlib;
    end

end


% ------------------ SUBFUNCTION: COMPARE ------------------------------
function Searchres=compare(TEST,Library)
global metset

metset.library_rimatch

if isfield(metset,'library_rimatch')==0 metset.library_rimatch=1; end
if isfield(metset,'library_skipcol')==0 metset.library_skipcol=1; end

if metset.library_skipcol==0 % Check column match
    Library=columnfilter(Library); % Removes fields with unmatching columns 
end

if metset.library_rimatch>1 % Check retention match
    Library=rifilter(TEST,Library);
end

% SETTER TOMME VARIABLER
match=[]; SMatch=[];
if metset.library_useri==1 testret=TEST.ri_calc; else testret=TEST.rt; end % Selects Time or index.

% Sammenligning vha korrelasjonskoeffisient
n_entries=length(Library);
for i1=1:n_entries
    
    %if metset.library_useri==1 libret=Library(i1).ri_calc; else libret=Library(i1).rt; end % Selects Time or index.
    
    % TEST FOR RETENSJONSINDEX (intervaltest)
    t=1;
    if metset.library_rimatch==2
       if metset.library_useri==1 libret=Library(i1).ri_calc; else libret=Library(i1).rt; end % Selects Time or index. 
       if isempty(libret) t=0; end
       if isempty(libret)==0 && abs(testret-libret)>metset.library_riinterval t=0; end
       %if sum(strcmp(Library(i1).column,metset.library_colsearch))==0 t=0; end
    end
    
    % TEST FOR RETENSJONSINDEX (GAUSSIAN)
    if metset.library_rimatch==3
        if metset.library_useri==1 libret=Library(i1).ri_calc; else libret=Library(i1).rt; end % Selects Time or index.
        if isempty(libret) %| sum(strcmp(Library(i1).column,metset.library_colsearch))==0 
            t=0; 
        else
            % Gaussfunksjon: Differanse lik grenseverdi (metset.library_riinterval)
            % gir t=0.01; differanse lik 0 gir t=1 
            t=exp(-((testret-libret)^2)/(0.2172*(metset.library_riinterval)^2)); 
        end
    end
    
    % SPECTRAL MATCH
    if length(Library(i1).ions) >= metset.library_minions && t>0.01; % Cutoff 0.01 ca 3*stdav (normalford.)
 
        % If same ions in Test and Lib
        if isequal(TEST.ions,Library(i1).ions) 
            %disp('---- Full match ----')
            testv=TEST.S; libv=Library(i1).S; 
        else 
            
            if metset.library_ionsinboth   
                
                tind=find(ismember(TEST.ions,Library(i1).ions)); testv=TEST.S(tind);          
                lind=find(ismember(Library(i1).ions,TEST.ions)); libv=Library(i1).S(lind);             
                
            else
                
                % Logical OR, ions present in one of the spectra are compared
                %disp('---- Ions in one (OR) -----')
                univect=unique([Library(i1).ions TEST.ions]);
                testv=zeros(1,length(univect)); libv=zeros(1,length(univect));
                for i2=1:length(univect)
                    tvi=find(TEST.ions==univect(i2));
                    if isempty(tvi)==0 testv(i2)=TEST.S(tvi); end
                    lvi=find(Library(i1).ions==univect(i2));
                    if isempty(lvi)==0 libv(i2)=Library(i1).S(lvi); end
                end   
                
            end % metset.library_ionsinboth       
 
        end

               
        if length(testv)>metset.library_minions     
            if metset.library_root>1
                testv(find(testv<0))=0; testv=testv.^(1/metset.library_root); %Sets negative to 0
                libv(find(libv<0))=0; libv=libv.^(1/metset.library_root); %Sets negative to 0
            end
                            
            % Beregner match
            if metset.library_mf==1; 
                m=corrcoef(libv,testv); m=m(2,1); % Korrelasjonskoeffisient
            else 
                testv=testv/sum(testv); libv=libv/sum(libv); % normaliserer
                m=(var(testv)-var(libv-testv))/var(testv); % forkl. var koeff.
            end
            m=(m+1)*0.5; m=m*100; m=m*t;
                  
            match(i1,1)=m; % Total match, max=100
            match(i1,2)=(i1);              % entry nr
            match(i1,3)=length(libv); % antall ioner sammenlignet
            match(i1,4)=length(Library(i1).ions); %length(lib_remn);  % antall ioner i bibl-spekter ikke testet
            match(i1,5)=t;                 % RI-match
        else
            match(i1,1)=0;
        end % if n_match>metset.library_minions     
    end % if length(library(i1).ions>metset.library_minions
end % for-slyfe

% SORTERER TRUNKERER, fjerner alle med match<=0 samt NaN
if isempty(match)==0
    a=find(match(:,1)>0); match=match(a,:);
    [sortv, ind]=sort(match(:,1)); ind=flipud(ind); SMatch(:,:)=match(ind,:); % Sorter etter correl.coeff.
end

[n_hits,n]=size(SMatch); n_hits=min(n_hits,metset.library_showentr); 
SMatch=SMatch(1:n_hits,:); % Viser de n beste

[n_results,n]=size(SMatch); Searchres=[];
for x=1:n_results
    fn=fieldnames(Library);
    for y=1:length(fn)
        Searchres(x).(fn{y})=Library(SMatch(x,2)).(fn{y});
    end
    Searchres(x).matchval=SMatch(x,1);
    Searchres(x).unused_libions=SMatch(x,4);
    Searchres(x).unused_specions=SMatch(x,3);
    Searchres(x).retentionmatch=SMatch(x,5);
end



% --------- SUBFUNCTION: COMPARELIST2 ------------------------------------------------------------------
function comparelist2(Searchres)

n_lines=length(Searchres);
for x=1:n_lines    
    %Searchres(x) % TEMP
    Str1=num2str(Searchres(x).matchval,'%-1.5f'); Str1=[Str1,blanks(10-length(Str1))];
    Str2=num2str(Searchres(x).unused_specions,'%-1.0f'); Str2=[Str2,blanks(5-length(Str2))];
    Str3=num2str(Searchres(x).unused_libions,'%-1.0f'); Str3=[Str3,blanks(6-length(Str3))];
    Str4=Searchres(x).cmp_code; Str4=[Str4,blanks(9-length(Str4))];
    Str5=Searchres(x).cmp_shortname; Str5=[Str5,blanks(15-length(Str5))];
    Str6=Searchres(x).cmp_name; Str6=[Str6,blanks(20-length(Str6))];
    ReM{x}=[Str1, Str2, Str3, Str4, Str5, Str6];
end

ResultsList1=findobj('Tag','ResultsList1');
if n_lines==0 
    ReM{1}=['------------------ SEARCH GAVE NO RESULTS ------------------']; 
    set(ResultsList1,'Value',1)
else
    val=get(ResultsList1,'Value'); 
    if val>n_lines set(ResultsList1,'Value',n_lines); end
end
set(ResultsList1,'String',ReM);


% --------- SUBFUNCTION: IDENTIFYALL -------------------------------------
function identifyall

global metset fileset RE locset %labels ions

% henter bibliotek
filename=[locset.path_library,'\class_',metset.global_class,'\lib_',metset.library_name];
[n_entries,Library]=getlib2; 
[m,n_libs]=size(metset.library_search); 
if n_entries==0; qq_message(1,'|r|Library not found'); end

% Identifiserer
for pn=1:fileset.results_npeaks
    % Definerer testspektrum
    TEST.S=RE(pn).S;             % Spektrum
    TEST.pn=pn;                  % Peak number  
    TEST.rt=RE(pn).rt; % Retensjonstid
    TEST.clunr=RE(pn).clu_nr;    % cluster nr
    TEST.single='Extracted'; if RE(pn).peaksincl==1 TEST.single='Single'; end
    TEST.ions=fileset.ions;
    TEST.ri_calc=RE(pn).ri_calc; % Beregnet retensjonsindex
    
    Searchres=compare(TEST,Library);

    if length(Searchres)>0 && Searchres(1).matchval>=metset.library_treshold
        RE(pn).cmp_name=Searchres(1).cmp_name;
        RE(pn).cmp_shortname=Searchres(1).cmp_shortname;
        RE(pn).cmp_code=Searchres(1).cmp_code;
        RE(pn).ri_def=Searchres(1).ri_def;
        RE(pn).identified=1;
    else
        RE(pn).cmp_name=[];
        RE(pn).cmp_shortname=[];
        RE(pn).cmp_code=[];
        RE(pn).ri_def=[];
        RE(pn).identified=0;        
    end
    

end

%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='SearchWin'; winpar{2}='Q: Search Libr';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Reset','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'qq_lib_search(11)',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(2) y(20) bw bh*1.5],'qq_lib_search(8)',3,'');
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(3) y(20) bw bh*1.5],'qq_lib_search(5)',3,'');

% Info box
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(16) bw*3 bh*3.75],'',2,'InfoTxt');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(18) bw*3 bh*2.2],'',2,'InputTxt');

% BEST MATCHES
p=p+1;[ui{p,1:7}] = deal('Show:','Text',colors.bc,[x(3) y(14) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.library_showentr,'Edit',[1 1 1],[x(3)+bw/2 y(14) bw/4 eh],'qq_lib_search(4)',2,'BestMatchEdit');
% MATCH RI
o=bw/3;
q=bh*0.8; 
p=p+1;[ui{p,1:7}] = deal('Retention Index:','Text',colors.bc,[x(4)+o y(14) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Exclude RI','Radiobutton',colors.bc,[x(4)+o y(14)-q bw*1.5 eh],'qq_lib_search(6.1)',2,'RiCheckRadio');
p=p+1;[ui{p,1:7}] = deal('Interval','Radiobutton',colors.bc,[x(4)+o y(14)-2*q bw*1.5 eh],'qq_lib_search(6.2)',2,'RiCheckRadio');
p=p+1;[ui{p,1:7}] = deal('Gaussian Funct.','Radiobutton',colors.bc,[x(4)+o y(14)-3*q bw*1.5 eh],'qq_lib_search(6.3)',2,'RiCheckRadio');
% Match function
p=p+1;[ui{p,1:7}] = deal('Match Function:','Text',colors.bc,[x(4)+o y(17) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('MF1: Correl. coeff.','Radiobutton',colors.bc,[x(4)+o y(17)-q bw*1.5 eh],'qq_lib_search(8.1)',2,'MfCheckRadio');
p=p+1;[ui{p,1:7}] = deal('MF2: Expl. var. coeff.','Radiobutton',colors.bc,[x(4)+o y(17)-2*q bw*1.5 eh],'qq_lib_search(8.2)',2,'MfCheckRadio');
p=p+1;[ui{p,1:7}] = deal('Match ions in both','Checkbox',colors.bc,[x(4)+o y(17)-3*q bw*1.5 eh],'qq_lib_search(8.3)',2,'MatchIonsCheck');
% Log spectr 
p=p+1;[ui{p,1:7}] = deal('Root','Text',colors.bc,[x(4)+2*o y(18)-3.2*q bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('1','Edit',[1 1 1],[x(4)+o y(18)-3.2*q bw/4 eh],'qq_lib_search(7.1)',2,'RootEdit');

% ENTRIES BOX
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(18)-bh/2 bw*3 bh],'',3,'EntriesTxt');
% RESULTS
lb=13; lt=1; 
p=p+1;[ui{p,1:7}] = deal('Score    NC   NL     Code     Short Name     Name','Text',[1 1 1],[x(1) y(lt) bw*5 eh],'',1,'Uniform');
p=p+1;[ui{p,1:7}] = deal('Searching...','Listbox',[1 1 1],[x(1) y(lb) bw*5 y(lt)-y(lb)],'qq_lib_search(3)',1,'ResultsList1');

updfcn=''; 
h0=qq_drawwin(winpar,ui,updfcn); 
set(h0,'KeyPressFcn','qq_lib_search(96)')

if isfield(metset,'library_ionsinboth')==0 metset.library_ionsinboth=0; end
h=findobj(h0,'Tag','MatchIonsCheck'); set(h,'Value',metset.library_ionsinboth);

h=findobj('Tag','Uniform'); set(h,'FontName','FixedWidth','FontWeight','normal'); 
h=findobj('Tag','ResultsList1'); set(h,'ButtonDownFcn','qq_lib_search(3)'); 

h=findobj('Tag','RiCheckRadio'); set(h,'Value',0);
if metset.library_rimatch==1; h=findobj(h,'String','Exclude RI'); set(h,'value',1); end
if metset.library_rimatch==2; h=findobj(h,'String','Interval'); set(h,'value',1); end
if metset.library_rimatch==3; h=findobj(h,'String','Gaussian Funct.'); set(h,'value',1); end

if isfield(metset,'library_mf')==0; metset.library_mf=1; end
h=findobj('Tag','MfCheckRadio'); set(h,'Value',0);
if metset.library_mf==1; h=findobj(h,'String','MF1: Correl. coeff.'); set(h,'value',1); end
if metset.library_mf==2; h=findobj(h,'String','MF2: Expl. var. coeff.'); set(h,'value',1); end

h=findobj('Tag','RootEdit'); set(h,'String',num2str(metset.library_root));

h=findobj('Tag','InfoTxt'); set(h,'ForegroundColor',[0 0 1]); 
h=findobj('Tag','InputTxt'); set(h,'ForegroundColor',[1 0 0]); 

drawnow