function qq_libmover(an)
global metset locset
persistent entries1 entries2 Library1 Library2 selected1 selected2

qq_message(2);

if nargin==0
    an=0;
end
if an==0
    openwin
    %h=findobj('Tag','SubWin');
    %set(h,'Visible','off')
    selected1=1;
    selected2=1;
    Library1=dummylib; entries1=0;
    Library2=dummylib; entries2=0;
end


% ---------------- LOAD HVIS TOM -------------
if an==1.1 & entries1==0 an=6.1; end
if an==1.2 & entries2==0 an=6.2; end    

%------------------- MOVE ------------------
% move right
if an==3.1 & entries1>0
    Library2=[Library2 Library1(selected1)]; entries2=entries2+1;
    Library1(selected1)=[]; entries1=entries1-1;
end
% move left
if an==3.2 & entries2>0
    Library1=[Library1 Library2(selected2)]; entries1=entries1+1;
    Library2(selected2)=[]; entries2=entries2-1;
end
if an>3 & an<4
    Library1=entrynr(Library1,entries1);
    Library2=entrynr(Library2,entries2);
    liblist(Library2,entries2,2);
    liblist(Library1,entries1,1);      
end

%------------------ ADD -----------------------
% add right
if an==4.1 & entries1>0
    Library2=[Library2 Library1(selected1)]; entries2=entries2+1;
    Library2=entrynr(Library2,entries2);
    liblist(Library2,entries2,2);
end
% add left
if an==4.2 & entries2>0
    Library1=[Library1 Library2(selected2)]; entries1=entries1+1;
    Library1=entrynr(Library1,entries1);
    liblist(Library1,entries1,1);      
end

% ----------------- DELETE ---------------------
% Delete left
if an==5.1 & entries1>0
    Library1(selected1)=[]; entries1=entries1-1;
    Library1=entrynr(Library1,entries1);
    liblist(Library1,entries1,1);     
end
% Delete right
if an==5.2 & entries2>0
    Library2(selected2)=[]; entries2=entries2-1;
    Library2=entrynr(Library2,entries2);
    liblist(Library2,entries2,2);
end

%---------------------- LOAD ----------------------
if an>6.0 & an<7
    if an==6.1 h=findobj('Tag','Libname1Edit'); end
    if an==6.2 h=findobj('Tag','Libname2Edit'); end
    libname=get(h,'String');
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',libname];
    [nn_entries,t_Library]=getlib(filename); 
    if nn_entries==0; qq_message(1,'r|Library not found'); t_library=dummylib; nn_entries=0; end
    
    if an==6.1 
        Library1=t_Library;
        entries1=nn_entries;
        Library1=entrynr(Library1,entries1); 
        liblist(Library1,entries1,1);
    end
    if an==6.2 
        Library2=t_Library;
        entries2=nn_entries;
        Library2=entrynr(Library2,entries2);
        liblist(Library2,entries2,2);
    end         
end
    

%---------------------- SAVE ----------------------
% save left
if an==7.1
    Library=Library1;
    Library=rmfield(Library,'entrynr');
    h=findobj('Tag','Libname1Edit');
end
if an==7.2
    Library=Library2;
    Library=rmfield(Library,'entrynr');
    h=findobj('Tag','Libname2Edit');
end
if an==7.1 | an==7.2
    libname=get(h,'String');
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',libname];
    %save(filename,'Library');
    qq_savefile(filename,Library,'-o');
end
    
    
% --------------------- UPDATE ----------------------   
LibList1=findobj('Tag','LibList1'); 
selected1=get(LibList1,'Value');
LibList2=findobj('Tag','LibList2'); 
selected2=get(LibList2,'Value');
EntriesTxt1=findobj('Tag','EntriesTxt1');
set(EntriesTxt1,'String',[num2str(entries1) ' Entries'])
EntriesTxt2=findobj('Tag','EntriesTxt2');
set(EntriesTxt2,'String',[num2str(entries2) ' Entries'])    

 % CLOSE
 if an==8
     qq_closewin;
     %h=findobj('Visible','off');
     %set(h,'Visible','on')
 end


%--------------------------------------------------------------------------
%------------------------ S U B F U N C T I O N S -------------------------
%--------------------------------------------------------------------------

% --------- SUBFUNCTION: LIBLIST ------------------------------------------------------------------

function liblist(lib,n_entries,libnr)

if libnr==1 LibList=findobj('Tag','LibList1'); end
if libnr==2 LibList=findobj('Tag','LibList2'); end

if n_entries>0
    % Skriver resultater
    for i1=1:n_entries
        Str1=num2str(lib(i1).entrynr); Str1=[Str1,blanks(10)]; Str1=Str1(1:5);
        Str2=lib(i1).cmp_code; Str2=[Str2,blanks(15)];Str2=Str2(1:12);
        Str3=num2str(length(lib(i1).ions));Str3=[Str3,blanks(10)];Str3=Str3(1:9); 
        Str4=lib(i1).cmp_shortname; Str4=[Str4,blanks(25)];Str4=Str4(1:18);
        ReM{i1}=[Str1,' ',Str2,' ',Str3,' ',Str4];
    end
    if n_entries==0 ReM=[]; end
    
    set(LibList,'String',ReM); set(LibList,'Enable','on');   
    if get(LibList,'Value')>n_entries set(LibList,'Value',n_entries); end
    
else
    set(LibList,'String',' '); set(LibList,'Enable','off');
end % if isstruct



% ------------- FUNCTION: GETLIB --------------------------------------------------------

function [n_entries,Library]=getlib(filename)

D=dir([filename,'.mat']);
DD=struct2cell(D);[m,n]=size(DD);
if n>0
    load(filename,'Library');
    d=struct2cell(Library);
    [m,n_entries]=size(d);
else
    n_entries=0; Library=[];
end
%if n_entries>0; Library=conv2numb(Library); end

%function Library=conv2numb(Library)
%n_entries=length(Library); 
%for i1=1:n_entries
%    if ischar(Library(i1).carbons) Library(i1).carbons=round(str2double(Library(i1).carbons)); end
%    if ischar(Library(i1).dbb) Library(i1).dbb=round(str2double(Library(i1).dbb)); end    
%    if ischar(Library(i1).ri_def) Library(i1).ri_def=str2double(Library(i1).ri_def); end
%end

% ------------- FUNCTION: DUMMYLIB --------------------------------------------------------
function lib=dummylib

lib.S=[];
lib.carbons=[];
lib.cmp_code=[];
lib.clunr=[];
lib.column=[];
lib.comments=[];
lib.cmp_shortname=[];
lib.cmp_name=[];
lib.dbb=[];
lib.file_name=[];
lib.ions=[];
lib.pn=[];
lib.ri_calc=[];
lib.ri_def=[];
lib.rt=[];
lib.single=[];
lib.entrynr=[];

lib(1)=[];


% ------------- FUNCTION: ENTRYNR --------------------------------------------------------
function Library=entrynr(Library,n_entries)

if n_entries>0
    entrynr=1:n_entries; 
    entrynr=num2cell(entrynr); 
    [Library(:).entrynr]=deal(entrynr{:});
end


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='LibMoveWin'; winpar{2}='Q:Move Spectra';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'',3,'');

% MOVE
p=p+1;[ui{p,1:7}] = deal('Move ->','Pushbutton',colors.reset,[x(5) y(3) bw bh],'qq_libmover(3.1)',3,'');
p=p+1;[ui{p,1:7}] = deal('<- Move','Pushbutton',colors.reset,[x(5) y(4) bw bh],'qq_libmover(3.2)',3,'');
% ADD
p=p+1;[ui{p,1:7}] = deal('Add ->','Pushbutton',colors.accept,[x(5) y(6) bw bh],'qq_libmover(4.1)',3,'');
p=p+1;[ui{p,1:7}] = deal('<- Add','Pushbutton',colors.accept,[x(5) y(7) bw bh],'qq_libmover(4.2)',3,'');
% DELETE
p=p+1;[ui{p,1:7}] = deal('Del.','Pushbutton',colors.reset,[x(5) y(9) bw/2 bh],'qq_libmover(5.1)',3,'');
p=p+1;[ui{p,1:7}] = deal('Del.','Pushbutton',colors.reset,[x(5)+bw/2 y(10) bw/2 bh],'qq_libmover(5.2)',3,'');
% Libname
p=p+1;[ui{p,1:7}] = deal('Library 1:','Text',colors.bc,[x(1) y(17) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Library 2:','Text',colors.bc,[x(6) y(17) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('No File','Edit',[1 1 1],[x(2) y(17) bw*2 eh],'qq_libmover(1.1)',3,'Libname1Edit');
p=p+1;[ui{p,1:7}] = deal('No File','Edit',[1 1 1],[x(7) y(17) bw*2 eh],'qq_libmover(1.1)',3,'Libname2Edit');
% Entries
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(4)+bw/4 y(17) bw eh],'',2,'EntriesTxt1');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(9)+bw/4 y(17) bw eh],'',2,'EntriesTxt2');
% Load/Save
p=p+1;[ui{p,1:7}] = deal('Load','Pushbutton',colors.accept,[x(1) y(18) bw bh],'qq_libmover(6.1)',3,'');
p=p+1;[ui{p,1:7}] = deal('Save','Pushbutton',colors.reset,[x(2) y(18) bw bh],'qq_libmover(7.1)',3,'');
p=p+1;[ui{p,1:7}] = deal('Load','Pushbutton',colors.accept,[x(6) y(18) bw bh],'qq_libmover(6.2)',3,'');
p=p+1;[ui{p,1:7}] = deal('Save','Pushbutton',colors.reset,[x(7) y(18) bw bh],'qq_libmover(7.2)',3,'');
% Lister
vp=16;
p=p+1;[ui{p,1:7}] = deal('No        Code                 n.ions          Shortname','Text',[1 1 1],[x(1) y(1) bw*4 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Searching...','Listbox',[1 1 1],[x(1) y(vp) bw*4 y(1)-y(vp)],'qq_libmover(2.1)',2,'LibList1');
p=p+1;[ui{p,1:7}] = deal('No        Code                 n.ions          Shortname','Text',[1 1 1],[x(6) y(1) bw*4 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Searching...','Listbox',[1 1 1],[x(6) y(vp) bw*4 y(1)-y(vp)],'qq_libmover(2.2)',2,'LibList2');

updfcn='';
qq_drawwin(winpar,ui,updfcn); 

h=[findobj('Tag','LibList1') findobj('Tag','LibList2')]; set(h,'Value',1); 
h=[findobj('Tag','Libname1Edit') findobj('Tag','Libname2Edit')]; set(h,'FontWeight','Normal','FontName','FixedWidth'); 

drawnow












