function qq_libset(an)

global metset fileset locset
persistent register all_libs n_all 

if an==1 
    openwin; 
    checklib
    [all_libs, n_all]=getall; 
    search_libs=metset.library_search;
    SearchLibsList=findobj('Tag','SearchLibsList'); set(SearchLibsList,'String',search_libs)
    LibraryEdit=findobj(gcf,'Tag','LibraryEdit'); set(LibraryEdit,'String',metset.library_name)  
    qq_register(6);
end

% -------------- SELECT LIBRARIES --------------
if an>2 && an<3
    [m,n_search]=size(metset.library_search);
end 
% Add all
if an==2.1
    metset.library_search=all_libs; [m,n_search]=size(metset.library_search);
    SearchLibsList=findobj('Tag','SearchLibsList');
    set(SearchLibsList,'String',metset.library_search)
end
% Add one
if an==2.2
    % BRUK SAMME PRINSIPP SOM AN=4.2
    AllLibsList=findobj('Tag','AllLibsList');
    val=get(AllLibsList,'Value');
    selected_lib=all_libs{val};
    found(1)=0; for x=1:n_search; found(x)=strcmp(selected_lib,metset.library_search{x}); end
    if sum(found)==0
        n_search=n_search+1; metset.library_search{n_search}=selected_lib;
    end
    SearchLibsList=findobj('Tag','SearchLibsList');
    set(SearchLibsList,'String',metset.library_search)
end
% Delete one
if an==2.3 && n_search>0
    SearchLibsList=findobj('Tag','SearchLibsList');
    val=get(SearchLibsList,'Value');
    metset.library_search(val)=[]; n_search=n_search-1;
    if val>n_search && val>1; set(SearchLibsList,'Value',n_search); end  
    set(SearchLibsList,'String',metset.library_search); 
end
% Select Editlib 
if an==2.4 
    AllLibsList=findobj('Tag','AllLibsList');
    val=get(AllLibsList,'Value');
    selected_lib=all_libs{val};
    LibraryEdit=findobj('Tag','LibraryEdit');
    set(LibraryEdit,'String',selected_lib);   
    metset.library_name=selected_lib;
end
% New editlib
if an==2.5
    LibraryEdit=findobj('Tag','LibraryEdit'); str=get(LibraryEdit,'String');
    metset.library_name=str;
end
    


%------------ SELECT COLUMNS -----------------
if an>4 && an<5
    allcollist=findobj('Tag','AllColumnsList'); allcolval=get(allcollist,'Value'); allcolstr=get(allcollist,'String'); 
    if iscell(allcolstr)==0 allcolstr=cellstr(allcolstr); end; n_all=length(allcolstr);
    selcollist=findobj('Tag','SearchColumnsList'); selcolval=get(selcollist,'Value'); selcolstr=get(selcollist,'String'); 
    if iscell(selcolstr)==0 selcolstr=cellstr(selcolstr); end; n_sel=length(selcolstr);
end 
% Add all
if an==4.1 && metset.library_skipcol==0
    selcolstr=allcolstr;
end
% Add one
if an==4.2 && metset.library_skipcol==0
    if isempty(strmatch(allcolstr(allcolval),selcolstr)) selcolstr(length(selcolstr)+1)=allcolstr(allcolval); end 
end
% Delete one
if an==4.3 && n_sel>0 && metset.library_skipcol==0
    selcolstr(selcolval)=[]; 
end
if an>4 && an<5
    selcollist=findobj('Tag','SearchColumnsList'); selcolval=get(selcollist,'Value'); selcolstr=sort(selcolstr);
    if iscell(selcolstr)==0 selcolstr=cellstr(selcolstr); end
    if selcolval>length(selcolstr) && length(selcolstr)>0  set(selcollist,'Value',length(selcolstr)); end
    if length(selcolstr)==0 set(selcollist,'Value',1); end
    metset.library_colsearch=selcolstr; set(selcollist,'String',selcolstr);
end

% Type of retention match
if an>6.0 && an<7.0
     h=findobj('Tag','RiCheckRadio'); set(h,'Value',0); set(gcbo,'Value',1)
     if an==6.1 metset.library_rimatch=1; end
     if an==6.2 metset.library_rimatch=2; end
     if an==6.3 metset.library_rimatch=3; end
 end

% Set match function
if an>=7.5 && an<8.0
     h=findobj('Tag','MfCheckRadio'); set(h,'Value',0); set(gcbo,'Value',1)
     if an==7.5 metset.library_mf=1; end
     if an==7.6 metset.library_mf=2; end
end

% Select retention index / retention time
if an>8 && an<9 
    h=findobj('Tag','ScaleCheckRadio'); set(h,'Value',0); set(gcbo,'Value',1);
    if an==8.1 metset.library_useri=0; end
    if an==8.2 metset.library_useri=1; end
end

% UPDATE COLUMNSLIST
if an==9 && metset.library_skipcol==0
    columnslist
end
% USE ALL COLUMNS ON/OFF
if an==9.5
    h=findobj('Tag','SkipColCheck'); val=get(h,'Value');
    AllColumnsList=findobj('Tag','AllColumnsList'); SearchColumnsList=findobj('Tag','SearchColumnsList');
    if val==1;
        set([SearchColumnsList AllColumnsList],'Enable','off');
    else
        set([SearchColumnsList AllColumnsList],'Enable','on');
    end
    metset.library_skipcol=val;
end

% Close
if an==99
    if metset.library_ramstore==1 && ~isempty(metset.library_search) qq_lib_search(80); end
    qq_closewin
end

if an==100
    checklib
    [all_libs, n_all]=getall; 
    search_libs=metset.library_search;
    SearchLibsList=findobj('Tag','SearchLibsList'); set(SearchLibsList,'String',search_libs)
    LibraryEdit=findobj(gcf,'Tag','LibraryEdit'); set(LibraryEdit,'String',metset.library_name)  
    qq_register(6);
end
 

%--------------------------------------------------------------------------
%--------                  SUBFUNCTIONS
%--------------------------------------------------------------------------

function checklib
global metset
% Checks that selected libraries exist in class

[all_libs, n_all]=getall;

% Checks search libraries
if ~isempty(metset.library_search)
    for x=1:length(metset.library_search)
        isntmember(x)=~ismember( metset.library_search(x), all_libs);
    end
    metset.library_search(isntmember)=[];
end

% checks edit library
if ~isempty(metset.library_name) && ~ismember(metset.library_name, all_libs)
    metset.library_name=[];
end
    

% --------- SUBFUNCTION: COLUMNSLIST --------------------------------------
function columnslist
global metset locset

dirname=[locset.path_library '\class_' metset.global_class '\'];
D=dir([dirname 'lib_*.mat']);

columns=[]; p=0;
for x=1:length(D)
    load([dirname D(x).name]);
    n_entr=length(Library);
    for y=1:n_entr
        if isnumeric(Library(y).column) Library(y).column=num2str(Library(y).column); end
        if sum(strcmp(Library(y).column,columns))==0
            p=p+1; columns{p}=Library(y).column;
        end
    end    
end

columns=sort(columns);
h=findobj('Tag','AllColumnsList'); set(h,'String',columns);

% --------- SUBFUNCTION: GETALL ------------------------------------------
function [all_libs,n_all]=getall
global metset locset

% Henter filnavn
filename=[locset.path_library,'\class_',metset.global_class,'\lib_*'];
D=dir([filename,'.mat']);
DD=struct2cell(D);
[m,n_all]=size(DD);
for x=1:n_all
    all_libs(x)=DD(1,x);
    all_libs{x}(1:4)=[];
    ind=findstr(all_libs{x},'.mat');
    all_libs{x}(ind:ind+3)=[];
end
AllLibsList=findobj('Tag','AllLibsList');
set(AllLibsList,'String',all_libs)



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

if isfield(metset,'library_root')==0; metset.library_root=1; end
if isfield(metset,'library_useri')==0; metset.library_useri=0; end

winpar{1}='LibSetWin'; winpar{2}='Q: Libr. Set.';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_libset(99)',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'',3,'');

%RETENTION
vp=14; vo=eh;
p=p+1;[ui{p,1:7}] = deal('Retention scale:','Text',colors.bc,[x(2)+bw/2 y(vp)+vo bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Time','Radiobutton',colors.bc,[x(2)+bw/2 y(vp) bw*1.5 eh],'qq_libset(8.1)',2,'ScaleCheckRadio');
p=p+1;[ui{p,1:7}] = deal('Retention index','Radiobutton',colors.bc,[x(2)+bw/2 y(vp)-vo bw*1.5 eh],'qq_libset(8.2)',2,'ScaleCheckRadio');
% Match RI
hp=16; vo=eh;
p=p+1;[ui{p,1:7}] = deal('Match retention:','Text',colors.bc,[x(2)+bw/2 y(hp) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Exclude','Radiobutton',colors.bc,[x(2)+bw/2 y(hp)-vo bw*1.5 eh],'qq_libset(6.1)',2,'RiCheckRadio');
p=p+1;[ui{p,1:7}] = deal('Interval','Radiobutton',colors.bc,[x(2)+bw/2 y(hp)-2*vo bw*1.5 eh],'qq_libset(6.2)',2,'RiCheckRadio');
p=p+1;[ui{p,1:7}] = deal('Gaussian Funct.','Radiobutton',colors.bc,[x(2)+bw/2 y(hp)-3*vo bw*1.5 eh],'qq_libset(6.3)',2,'RiCheckRadio');
% RI Interval
p=p+1;[ui{p,1:7}] = deal('Interval:','Text',colors.bc,[x(2)+bw/2 y(19) bw eh],'',2,'');
p=p+1;[ui{p,1:8}] = deal(metset.library_riinterval,'Edit',[1 1 1],[x(2)+bw/2+2/3*bw y(19) bw/3 eh],'qq_eval(''pn'')',2,'metset.library_riinterval','-c');

% SPECTRA
% Spectr Search
hp=14; vo=eh;
p=p+1;[ui{p,1:7}] = deal('Spectr. searchparam:','Text',colors.bc,[x(1) y(hp)+vo bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('MF1: Correl. coeff.','Radiobutton',colors.bc,[x(1) y(hp) bw*1.5 eh],'qq_libset(7.5)',2,'MfCheckRadio');
p=p+1;[ui{p,1:7}] = deal('MF2: Expl. var. coeff.','Radiobutton',colors.bc,[x(1) y(hp)-vo bw*1.5 eh],'qq_libset(7.6)',2,'MfCheckRadio');
% Root
p=p+1;[ui{p,1:7}] = deal('Root:','Text',colors.bc,[x(1) y(18) bw eh],'',2,'');
p=p+1;[ui{p,1:8}] = deal(num2str(metset.library_root),'Edit',[1 1 1],[x(1)+2/3*bw y(18) bw/3 eh],'qq_eval(''pi'')',2,'metset.library_root','-c');
% Ion Match
p=p+1;[ui{p,1:7}] = deal('Match ions in both','Checkbox',colors.bc,[x(1) y(16) bw eh],'qq_eval(''ch'')',2,'metset.library_ionsinboth');
p=p+1;[ui{p,1:7}] = deal('Min. ions:','Text',colors.bc,[x(1) y(17) bw eh],'',2,'');
p=p+1;[ui{p,1:8}] = deal(metset.library_minions,'Edit',[1 1 1],[x(1)+2/3*bw y(17) bw/3 eh],'qq_eval(''pi'')',2,'metset.library_minions','-c');

% Select Searchlibs
p=p+1;[ui{p,1:7}] = deal('->','Pushbutton',colors.accept,[x(2)+bw/2 y(2) bw/2 bh],'qq_libset(2.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('<-','Pushbutton',colors.reset,[x(2)+bw/2 y(3) bw/2 bh],'qq_libset(2.3)',4,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.accept,[x(2)+bw/2 y(4) bw/2 bh],'qq_libset(2.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('->','Pushbutton',colors.accept,[x(2)+bw/2 y(7) bw/2 bh],'qq_libset(2.4)',4,'');

% Select Columns
p=p+1;[ui{p,1:7}] = deal('->','Pushbutton',colors.accept,[x(2)+bw/2 y(9) bw/2 bh],'qq_libset(4.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('<-','Pushbutton',colors.reset,[x(2)+bw/2 y(10) bw/2 bh],'qq_libset(4.3)',4,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.accept,[x(2)+bw/2 y(11) bw/2 bh],'qq_libset(4.1)',2,'');

% Lister
p=p+1;[ui{p,1:7}] = deal('Available Libraries','Text',colors.bc,[x(1) y(1) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1) y(7) bw*1.5 y(1)-y(7)],'',2,'AllLibsList');
p=p+1;[ui{p,1:7}] = deal('Search In','Text',colors.bc,[x(3) y(1) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(3) y(5) bw*1.5 y(1)-y(5)],'',2,'SearchLibsList');
p=p+1;[ui{p,1:7}] = deal('Edit Library','Text',colors.bc,[x(3) y(6) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.library_name,'Edit',[1 1 1],[x(3) y(7) bw*1.5 bh],'qq_libset(2.5)',2,'LibraryEdit');

p=p+1;[ui{p,1:7}] = deal('Columns','Text',colors.bc,[x(1) y(8) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.global_columns,'Listbox',[1 1 1],[x(1) y(11) bw*1.5 y(8)-y(11)],'',2,'AllColumnsList');
p=p+1;[ui{p,1:7}] = deal('Use in RI Search','Text',colors.bc,[x(3) y(8) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.library_colsearch,'Listbox',[1 1 1],[x(3) y(11) bw*1.5 y(8)-y(11)],'',2,'SearchColumnsList');
p=p+1;[ui{p,1:7}] = deal('Upd List','Pushbutton',colors.bc,[x(1) y(12) bw bh],'qq_libset(9)',2,'');
p=p+1;[ui{p,1:7}] = deal('Skip column test','CheckBox',colors.bc,[x(2)+bw/2 y(12) bw*1.5 bh],'qq_libset(9.5)',2,'SkipColCheck');

% General
p=p+1;[ui{p,1:7}] = deal('Store spectra in RAM','CheckBox',colors.bc,[x(4) y(12) bw*1.5 bh],'qq_eval(''ch'')',2,'metset.library_ramstore');
% Treshold
if isfield(metset,'library_treshold')==0 metset.library_treshold=99; end
p=p+1;[ui{p,1:7}] = deal('Score thresh:','Text',colors.bc,[x(4) y(13) bw eh],'',2,'');
p=p+1;[ui{p,1:8}] = deal(metset.library_treshold,'Edit',[1 1 1],[x(4)+2/3*bw y(13) bw/3 eh],'qq_eval(''pn0'')',2,'metset.library_treshold','-c');

% Register
p=p+1;[ui{p,1:7}] = deal('Register','Text',colors.bc,[x(6) y(1) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(6) y(18) bw*4 y(1)-y(18)],'',2,'RegisterList');
p=p+1;[ui{p,1:7}] = deal('Show Reg.','Pushbutton',colors.btn{5},[x(6) y(19) bw bh],'qq_register(6)',2,'');
p=p+1;[ui{p,1:7}] = deal('Search','Pushbutton',colors.btn{5},[x(7) y(19) bw bh],'qq_register(7)',2,'');
p=p+1;[ui{p,1:8}] = deal('Update Reg.','Pushbutton',colors.btn{5},[x(8) y(19) bw bh],'qq_register(1)',2,'','-bm');
%p=p+1;[ui{p,1:7}] = deal('TEMP','Pushbutton',colors.btn{4},[x(9) y(19) bw bh],'qq_transformregister',2,'');

updfcn='qq_libset(100)';
h0=qq_drawwin(winpar,ui,updfcn); 

if isfield(metset,'library_ionsinboth')==0 metset.library_ionsinboth=0; end
h=findobj(h0,'Tag','metset.library_ionsinboth'); set(h,'Value',metset.library_ionsinboth);

h=findobj('Tag','RiCheckRadio'); set(h,'Value',0)
switch metset.library_rimatch
    case 1; h=findobj(h,'String','Exclude'); set(h,'Value',1); 
    case 2; h=findobj(h,'String','Interval'); set(h,'Value',1); 
    case 3; h=findobj(h,'String','Gaussian Funct.'); set(h,'Value',1);
end

h=findobj('Tag','ScaleCheckRadio'); set(h,'Value',0)
switch metset.library_useri
    case 0; h=findobj(h,'String','Time'); set(h,'Value',1); 
    case 1; h=findobj(h,'String','Retention index'); set(h,'Value',1); 
end

h=findobj('Tag','MfCheckRadio'); set(h,'Value',0)
switch metset.library_mf
    case 1; h=findobj(h,'String','MF1: Correl. coeff.'); set(h,'Value',1); 
    case 2; h=findobj(h,'String','MF2: Expl. var. coeff.'); set(h,'Value',1); 
end

if isfield(metset,'library_skipcol')==0 metset.library_skipcol=1; end
h=findobj('Tag','SkipColCheck'); set(h,'Value',metset.library_skipcol);
h1=findobj('Tag','AllColumnsList'); h2=findobj('Tag','SearchColumnsList');
if metset.library_skipcol==1 set([h1 h2],'Enable','off'); end

if isfield(metset,'library_ramstore')==0 metset.library_ramstore=1; end
h=findobj(h0,'Tag','metset.library_ramstore'); set(h,'Val',metset.library_ramstore)

drawnow









