function qq_libsub(an)
global metset locset
persistent Library1 selected1 Codes SubLib n_subs CondLib selectedcode n_codes
% persistent Library2 selected2 entries2 entries1  

message(' ');
qq_message(2);

if nargin==0
    an=0;
end
if an==0
    openwin
    %h=findobj('Tag','SubWin'); set(h,'Visible','off') 
    %h=findobj('Tag','Libname1Edit'); 
    %set(h,'String',metset.library_name);
    %an=6.1;
    liblist
    SubLib=[]; n_subs=0;
end

%---------------------- SELECT ---------------------
if an==4.1
    h=findobj('Tag','SelectRadio'); set(h,'Value',0); set(gcbo,'Value',1); an=2.1;
end


% ---------------- Selectcode -------------
% Selectcode
if an==2.1
    CodeList=findobj('Tag','CodeList');
    selectedcode=get(CodeList,'Value');
    CondLib=getentries(Library1,Codes);
    showentries(CondLib);
    PCA(CondLib)   
end

%---------------------- ADD ----------------------
if an==3.1 & selectedcode<=n_codes
    
    % Bestemmer valgt entry
    h=findobj('Tag','EntriesList');
    selectedentry=get(h,'Value'); 
    
    % Bestemmer antall i sublib
    if isstruct(SubLib)==0
        n_subs=1; SubLib=CondLib(selectedentry);   
    else
        n_subs=n_subs+1; SubLib(n_subs)=CondLib(selectedentry); 
    end
    showsub(SubLib)  
    % Legger antall i sublib til Codes
    Codes(selectedcode).n_insublib=Codes(selectedcode).n_insublib+1;
    showcodes(Codes)
    
    h=findobj('Tag','NextCheck');
    if get(h,'Value')==1 & selectedcode<n_codes
        selectedcode=selectedcode+1;
        CodeList=findobj('Tag','CodeList');
        set(CodeList,'Value',selectedcode);
        CondLib=getentries(Library1,Codes);
        showentries(CondLib);
        PCA(CondLib)     
    end
end

%---------------------- ADD ALL ----------------------
if an==3.3 
    CodeList=findobj('Tag','CodeList');    
    for i1=1:n_codes
        set(CodeList,'Value',i1);
        CondLib=getentries(Library1,Codes);
        bestmatch=findbest(CondLib);
        Codes(i1).n_insublib=Codes(i1).n_insublib+1;
        if n_subs==0 SubLib=CondLib(bestmatch); n_subs=n_subs+1; end
        if n_subs>0 SubLib(n_subs)=CondLib(bestmatch); n_subs=n_subs+1; end
    end
    showsub(SubLib)
    showcodes(Codes)
end


%---------------------- DELETE ----------------------
if an==3.2 & n_subs>0
    SublibList=findobj('Tag','SublibList');
    val=get(SublibList,'Value');
    delcode=SubLib(val).cmp_code;
    SubLib(val)=[]; n_subs=n_subs-1;
    if n_subs>0 & val>n_subs set(SublibList,'Value',n_subs); end
    showsub(SubLib)
    casnrs=cellstr(strvcat(Codes.cmp_code));
    codenr=find(strcmp(casnrs,delcode));
    Codes(codenr).n_insublib=Codes(codenr).n_insublib-1;
    showcodes(Codes)    
end


%---------------------- LOAD ----------------------
if an==6.1
    h=findobj('Tag','LibnamePop'); 
    libnames=get(h,'String'); libname=libnames{get(h,'Value')};
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',libname];
    [nn_entries,t_Library]=getlib(filename); 
    if nn_entries==0; qq_message(1,'r|Library not found'); t_library=dummylib; nn_entries=0; end
    
    Library1=t_Library;
    entries1=nn_entries;
    [Codes,n_codes]=getcodes(Library1,entries1); 
    showcodes(Codes);
    selectedcode=1; n_sublib=0;
    CodeList=findobj('Tag','CodeList'); set(CodeList,'Value',selectedcode);
    CondLib=getentries(Library1,Codes); showentries(CondLib); PCA(CondLib);  
end

%---------------------- SAVE ----------------------
if an==6.2 & n_subs==0 
    qq_message(1,'r|No sublibrary')
end
if an==6.2 & n_subs>0
    sublibsave(SubLib)
end
    
% CLOSE
if an==8
    qq_closewin;
    h=findobj('Visible','off');
    set(h,'Visible','on')
end



%--------------------------------------------------------------------------
%------------------------ S U B F U N C T I O N S -------------------------
%--------------------------------------------------------------------------

% -------------- FUNCTION: LIBLIST -------------------------------------
function liblist
global locset metset

dirname=[locset.path_library '\class_' metset.global_class '\lib_*.*'];
DD=dir(dirname);
str{1}='No libraries';
for x=1:length(DD)
    str{x}=DD(x).name(5:length(DD(x).name));
end
h=findobj('Tag','LibnamePop'); set(h,'String',str');


% -------------- FUNCTION: SUBLIBSAVE -------------------------------------
function sublibsave(Library)

global metset
h=findobj('Tag','SublibNameEdit');
libname=get(h,'String');
filename=[locset.path_library,'\class_',metset.global_class,'\lib_',libname,'.mat'];
D=dir(filename); DD=struct2cell(D); [m,n]=size(DD);
if n>0 
    qq_message(1,'r|Library exist') 
else
    %save(filename,'Library'); qq_message(1,'b|Saved');
    qq_savefile(filename,Library,'-o'); qq_message(1,'b|Saved');
end


% ------------- FUNCTION: GETCODES --------------------------------------------------------
function [Codes,n_codes]=getcodes(Library,n_entries)

p=1; Codes(p).cmp_code=Library(1).cmp_code; Codes(p).n_entries=1; Codes(p).n_entries=0; Codes(p).n_insublib=0;
for x=2:n_entries
    if strcmp(Library(x).cmp_code,Library(x-1).cmp_code)==1
        Codes(p).n_entries=Codes(p).n_entries+1;
    else
        p=p+1; Codes(p).cmp_code=Library(x).cmp_code; Codes(p).n_entries=1; Codes(p).n_insublib=0;
    end   
end
n_codes=p;

% ------------- FUNCTION: SHOWCODES --------------------------------------------------------

function showcodes(codes)

CodeList=findobj('Tag','CodeList');     
n_codes=length(cat(1,codes.n_entries));
for i1=1:n_codes
    Str4=num2str(i1); Str4=[Str4,blanks(10)]; Str4=Str4(1:4);
    Str1=codes(i1).cmp_code; Str1=[Str1,blanks(10)]; Str1=Str1(1:8);
    Str2=num2str(codes(i1).n_entries); Str2=[Str2,blanks(10)]; Str2=Str2(1:4);
    Str3=' '; if codes(i1).n_insublib>0 Str3=num2str(codes(i1).n_insublib); end
    Str3=[Str3,blanks(10)]; Str3=Str3(1:4);
    ReM{i1}=[Str4,' ',Str1,' ',Str2,' ',Str3];
end
set(CodeList,'String',ReM)

% ------------- Function: SHOWENTRIES --------------------------------------------

function showentries(CondLib)

EntriesList=findobj('Tag','EntriesList');
n_entries=length(cat(1,CondLib.entrynr));
for i1=1:n_entries
    Str1=num2str(CondLib(i1).entrynr); Str1=[Str1,blanks(10)]; Str1=Str1(1:5);
    Str2=CondLib(i1).cmp_code; Str2=[Str2,blanks(15)];Str2=Str2(1:12);
    Str3=num2str(length(CondLib(i1).ions));Str3=[Str3,blanks(10)];Str3=Str3(1:9); 
    Str4=CondLib(i1).cmp_shortname; Str4=[Str4,blanks(25)];Str4=Str4(1:18);
    ReM{i1}=[Str1,' ',Str2,' ',Str3,' ',Str4]; 
end
set(EntriesList,'String',ReM)

% ------------- Function: findbest ---------------------------------------
function bestmatch=findbest(CondLib)

data=cat(1,CondLib.S);
% Legger til gjennomsnittspektrum
average=mean(data,1); data=[data; average]; 
% Normaliserer
sumdata=sum(data,2); [m,n]=size(data); for x=1:m ndata(x,:)=data(x,:).*(100/sumdata(x)); end; data=ndata;

[m,n]=size(data);
for x=1:m-1
    rr=corrcoef(data(x,:),data(m,:)); corr(x)=rr(2,1); % Korrelasjonskoeffisient
    sep(x)=std(data(x,:)-data(m,:)); % Standard difference
end
bestcorr=find(corr==max(corr)); bestcorr=bestcorr(1);
bestsep=find(sep==min(sep)); bestsep=bestsep(1);

% Bestemmer bestmatch
h=findobj('Tag','SelectRadio'); selval=get(h,'Value');
if selval{2}==1 bestmatch=bestcorr; else bestmatch=bestsep; end



% ------------- Function: PCA --------------------------------------------
    
function PCA(CondLib)

data=cat(1,CondLib.S);
data % TEMP
% Legger til gjennomsnittspektrum
average=mean(data,1); data=[data; average];
% Normaliserer
sumdata=sum(data,2); [m,n]=size(data); for x=1:m ndata(x,:)=data(x,:).*(100/sumdata(x)); end; data=ndata;
[U S V]=svd(data);

h=findobj('Tag','PCAplot');
set(gcf,'CurrentAxes',h)

[m,n]=size(data); maxx=max(U(1,:)); minx=min(U(1,:)); in=maxx-minx; o=in/100;

if m>2 
    plot(U(1,:),U(2,:),'.r'); 
    for x=1:m-1
        t(x)=text(U(1,x)+o,U(2,x),num2str(CondLib(x).entrynr)); 
        rr=corrcoef(data(x,:),data(m,:)); corr(x)=rr(2,1); % Korrelasjonskoeffisient
        sep(x)=std(data(x,:)-data(m,:));
    end
    text(U(1,m)+o,U(2,m),'Mean','Fontweight','Bold','Color',[0 0 1]); 

    bestcorr=find(corr==max(corr)); bestcorr=bestcorr(1);
    set(t(bestcorr),'Fontweight','Bold','Color',[0 0.8 0]); 
    
    bestsep=find(sep==min(sep)); bestsep=bestsep(1);
    set(t(bestsep),'Fontweight','Bold','Color',[0 0.5 0]); 

    if bestcorr==bestsep 
        set(t(bestsep),'Fontweight','Bold','Color',[1 0 0]); 
        str=['Best correlation = best std.diff: ',num2str(CondLib(bestsep).entrynr)];   
    else
        str=['Best correlation: ',num2str(CondLib(bestcorr).entrynr),'. Best std.diff: ',num2str(CondLib(bestsep).entrynr)];   
    end

    % Bestemmer bestmatch
    h=findobj('Tag','SelectRadio'); selval=get(h,'Value');
    if selval{2}==1 bestmatch=bestcorr; else bestmatch=bestsep; end

else
    bestmatch=1; plot(0); str='Single spectrum'; 
end

EntriesList=findobj('Tag','EntriesList');
set(EntriesList,'Value',bestmatch);
message(str)


% ------------- FUNCTION: getentries --------------------------------------------------------

function CondLib=getentries(Library,Codes)

CodeList=findobj('Tag','CodeList');
selectedcode=get(CodeList,'Value');

cmp_code=Codes(selectedcode).cmp_code;
n_entries=length(cat(1,Library.entrynr));

libindex=[];
for i1=1:n_entries
    if strcmp(Library(i1).cmp_code,cmp_code)
        libindex=[libindex i1];
    end
end
CondLib=Library(libindex);


% ------------- FUNCTION: MESSAGE --------------------------------------------------------
function message(txt)
MessageTxt=findobj('Tag','lbMessage');
set(MessageTxt,'String',txt);

% --------- SUBFUNCTION: showsub ------------------------------------------------------------------

function showsub(lib)

if isstruct(lib) n_entries=length(cat(2,lib.pn)); end

    LibList=findobj('Tag','SublibList');

if n_entries>0
    % Skriver resultater
    for i1=1:n_entries
        Str1=num2str(lib(i1).entrynr); Str1=[Str1,blanks(10)]; Str1=Str1(1:5);
        Str2=lib(i1).cmp_code; Str2=[Str2,blanks(15)];Str2=Str2(1:12);
        Str3=num2str(length(lib(i1).ions));Str3=[Str3,blanks(10)];Str3=Str3(1:9); 
        Str4=lib(i1).cmp_shortname; Str4=[Str4,blanks(25)];Str4=Str4(1:18);
        ReM{i1}=[Str1,' ',Str2,' ',Str3,' ',Str4];
    end
    if n_entries==0 ReM=[]; end
    
    set(LibList,'String',ReM); set(LibList,'Enable','on');   
    if get(LibList,'Value')>n_entries set(LibList,'Value',n_entries); end
    
else
    set(LibList,'String',' '); set(LibList,'Enable','off');
end

% ------------- FUNCTION: GETLIB --------------------------------------------------------

function [n_entries,Library]=getlib(filename)

D=dir(filename); n=length(D);
if n>0 load(filename,'Library'); else Library=[]; end

% Sorterer
n_entries=length(Library);
Library=entrynr(Library,n_entries)

[b,index]=sortrows(strvcat(Library.cmp_code)); 
Library(:)=Library(index);



% ------------- FUNCTION: ENTRYNR --------------------------------------------------------
function Library=entrynr(Library,n_entries)

if n_entries>0
    entrynr=1:n_entries; 
    entrynr=num2cell(entrynr); 
    [Library(:).entrynr]=deal(entrynr{:});
end


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='SubLibWin'; winpar{2}='Q:Create Sublib';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'',3,'');

% Add/Select/Delete
p=p+1;[ui{p,1:7}] = deal('Add ->','Pushbutton',colors.accept,[x(5) y(3) bw bh],'qq_libsub(3.1)',3,'');
p=p+1;[ui{p,1:7}] = deal('Select next','Checkbox',colors.accept,[x(5) y(4) bw bh],'',2,'NextCheck');
p=p+1;[ui{p,1:7}] = deal('Delete <-','Pushbutton',colors.reset,[x(5) y(5) bw bh],'qq_libsub(3.2)',3,'');
p=p+1;[ui{p,1:7}] = deal('Add all ->','Pushbutton',colors.accept,[x(5) y(6) bw bh],'qq_libsub(3.3)',3,'');
% Parent Library/Load
p=p+1;[ui{p,1:7}] = deal('Parent Libr.','Text',colors.bc,[x(1) y(17) bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('---','Popupmenu',[1 1 1],[x(2) y(17) bw*2 bh],'qq_libsub(1.1)',2,'LibnamePop');
p=p+1;[ui{p,1:7}] = deal('Load','Pushbutton',colors.accept,[x(4) y(17) bw bh],'qq_libsub(6.1)',3,'');
% Sublib/Save
p=p+1;[ui{p,1:7}] = deal('Sub Library','Text',colors.bc,[x(1) y(18) bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(18) bw*2 bh],'qq_libsub(1.1)',3,'SublibNameEdit');
p=p+1;[ui{p,1:7}] = deal('Save','Pushbutton',colors.reset,[x(4) y(18) bw bh],'qq_libsub(6.2)',3,'');

% Select
hp=8;
p=p+1;[ui{p,1:7}] = deal('Select','Text',colors.bc,[x(5) y(hp) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Correlation','Radiobutton',colors.bc,[x(5) y(hp)-eh bw eh],'qq_libsub(4.1)',2,'SelectRadio');
p=p+1;[ui{p,1:7}] = deal('Std.diff.','Radiobutton',colors.bc,[x(5) y(hp)-2*eh bw eh],'qq_libsub(4.1)',2,'SelectRadio');
% Lister
vp=16;
p=p+1;[ui{p,1:7}] = deal('Codes','Text',colors.bc,[x(1) y(1) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1) y(vp) bw*2 y(1)-y(vp)],'qq_libsub(2.1)',2,'CodeList');
p=p+1;[ui{p,1:7}] = deal('Entries','Text',colors.bc,[x(3) y(1) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(3) y(vp) bw*2 y(1)-y(vp)],'qq_libsub(2.2)',2,'EntriesList');
vp=9;
p=p+1;[ui{p,1:7}] = deal('Sublibrary','Text',colors.bc,[x(6) y(1) bw*4 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(6) y(vp) bw*4 y(1)-y(vp)],'',2,'SublibList');


updfcn='';
qq_drawwin(winpar,ui,updfcn); 

h=findobj('Tag','CodeList'); set(h,'Value',1,'ButtonDownFcn','qq_libsub(2.1)','FontWeight','normal','FontName','FixedWidth'); 
h=findobj('Tag','EntriesList'); set(h,'Value',1,'ButtonDownFcn','qq_libsub(2.2)','FontWeight','normal','FontName','FixedWidth'); 
h=findobj('Tag','SublibList'); set(h,'Value',1,'FontWeight','normal','FontName','FixedWidth'); 
h=findobj('Tag','SelectRadio'); set(h,'Value',0); h=findobj(h,'String','Correlation'); set(h,'Value',1); 
%h=[findobj('Tag','Libname1Edit') findobj('Tag','Libname2Edit')]; set(h,'FontWeight','Normal','FontName','FixedWidth'); 

vp=19;
h1=axes('Position',[x(6) y(vp) bw*4 y(10)-y(vp)],'Tag','PCAplot');

drawnow









