function qq_load_plots(X,labels,ions,Info,type)

if type==1
    plottic(X,labels);
end
if type==2
    plotdata(X,labels,ions)
end

p=0; str{1}='';
if isfield(Info,'File_Name'); p=p+1; str{p}=['File Name: ' Info.File_Name]; end
if isfield(Info,'Sample_Name'); p=p+1; str{p}=['Sample Name: ' Info.Sample_Name]; end
if isfield(Info,'Operator'); p=p+1; str{p}=['Operator: ' Info.Operator]; end
if isfield(Info,'Time'); p=p+1; str{p}=['Acquired: ' Info.Time]; end
if isfield(Info,'Method'); p=p+1; str{p}=['Method: ' Info.Method]; end
if isfield(Info,'Source'); p=p+1; str{p}=['Source: ' Info.Source]; end
if isfield(Info,'Bottle_No'); p=p+1; str{p}=['Bottle No: ' num2str(Info.Bottle_No)]; end

h=text(0.025,0.9,str,'Units','Normalized','FontWeight','bold','VerticalAlignment','top','Interpreter','none');


% -------------- SUBFUNCTION PLOTTIC -------------------
function plottic(X,llabels)
global positions
[m,n]=size(X);
if n>1 tic=sum(X'); else tic=X; end
%subplot('position',[0 0.5 1 0.5])
subplot('position',positions.largeplot)
h=plot(llabels,tic);
set(h,'LineWidth',1)
dim=size(tic);
minx=min(llabels);maxx=max(llabels);miny=0;maxy=max(tic); offs=maxy*0.05;
axis ([minx maxx miny maxy+offs])


% -------------- SUBFUNCTION PLOTDATA -------------------
function plotdata(X,llabels,lions)
subplot('position',[0 0.5 1 0.5])
plot(llabels,X);
dim=size(X);
minx=1;maxx=dim(1);miny=0;maxy=max(max(X)); offs=maxy*0.05;
axis ([llabels(minx) llabels(maxx) miny maxy+offs])

%Skriver Ions
[yp,xp]=max(X); % x og y pos for max av ioner
xp=xp(1,:); % Trunkerer hvis >1 maximum.
yp=yp(1,:); 
txt=strvcat(num2str(lions(:)));
h=text(llabels(xp),yp+offs/2,txt);
set(h,'HorizontalAlignment','center')
set(h,'FontSize',10)
set(h,'FontWeight','bold')