function qq_plot_mainchrom(an)

% function qq_plot_mainchrom(an)
% Plots TIC in mainwindow
% an==0: Autoselect plot (depends on available data)
% an==1; TIC of X and XR
% an==2...

% SJEKK FOR PLOTSCALE
h=findobj(gcf,'Tag','Plotcontrol'); if isempty(h) qq_plot_scale; end

if nargin<1 an=0; end

if an==0 an=1; end % TEMP

if an==1 plottic; end

% M FIKSE SLIK AT DET TEGNES MED RIKTIG SKALA (RI ELLER Rt)

% -------------- SUBFUNCTION PLOTTIC -------------------
function plottic

%disp('--- qq_chrom / plottic ---')

global XR XBL fileset metset positions


%switch metset.global_plotscale
%    case 1; fileset.chrom_plotlab=fileset.rt;
%    case 2; fileset.chrom_plotlab=fileset.results_rivect;
%    case 3; fileset.chrom_plotlab=1:length(fileset.rt)
%end

if isfield(fileset,'chrom_plotlab')==0 fileset.chrom_plotlab=fileset.rt; end
fileset.chrom_tic1=sum(XR'); % tic_1 is raw tic
fileset.chrom_tic2=sum(XBL');% tic 2 is baselinesubtracted tic

%subplot('position',[0 0.5 1 0.5])
subplot('position',positions.largeplot)

h=plot(fileset.chrom_plotlab,fileset.chrom_tic1);
h=plot(fileset.chrom_plotlab,fileset.chrom_tic2);
hold on
plot(fileset.chrom_plotlab, fileset.chrom_tic1,'--','linewidt',0.5,'color',[0.8 0.8 0.8])
plot(fileset.chrom_plotlab, fileset.chrom_tic2,'-','linewidth',1,'color',[0 0 1])
hold off
%scale; yscale
set(gca,'Tag','Mainchrom','UserData','Mainwin Chromatogram')
qq_copyfigure
% Set slider
%sp=fileset.chrom_cent/length(fileset.rt); sh=findobj(gcf,'Tag','Plotslider'); set(sh,'Value',sp*100);
