function qq_report_txt(Reportstruct)
global locset metset

linefeed=char([13 10]);

% ------------- Opens file -------------
Reportstruct(1).pathname=[Reportstruct.pathname];
fh=fopen([Reportstruct(1).pathname '.txt'],'w');

if fh==-1; 
    cc_message(1,'|r|Warning, could not write to file, file may be open or output folder may not exist'); 
else
    % ------------- Writes header -------------
    for x=1:length(Reportstruct.header)
        fprintf(fh,[Reportstruct.header{x},linefeed]);
    end
    fprintf(fh,[linefeed]);

    % ------------- convert to typstr -------------
    [n_columns,n_rows]=size(Reportstruct.cells);
    U=[];
    for x=1:n_columns
        typestr{1,x}=[Reportstruct.columntitle{x} '  '];
        for y=1:n_rows
            if strcmp(Reportstruct.format{x},'str')
                typestr{y+2,x}=[Reportstruct.cells{x,y} '  '];
            else
                typestr{y+2,x}=[num2str(Reportstruct.cells{x,y},Reportstruct.format{x}) '  '];
            end
        end
        U=[U char(typestr{:,x});];
    end

    [m,linewidth]=size(U); U(:,linewidth-1:linewidth)=[];
    separator=repmat('-',1,linewidth-2); U(2,:)=separator; U(m+1,:)=separator;

    % Writes cellcontents
    for x=1:m+1
        fprintf(fh,[U(x,:) linefeed]);
    end

    % Writes footer
    for x=1:length(Reportstruct.footer)
        fprintf(fh,[Reportstruct.footer{x},linefeed]);
    end

    fclose(fh);

    if isfield(Reportstruct,'displaymessage') && Reportstruct.displaymessage==1;
        qq_message(1,['|b|Report saved as ' Reportstruct.pathname '.txt'])
    end    
    
    
    % Opens
    if isfield(Reportstruct,'autoopen') && Reportstruct.autoopen==1;
        %if isfield(locset,'editor') && strcmp(locset.editor,'notepad')
            %a=dos(['notepad ' Reportstruct.pathname '.txt']);
       try
           winopen([Reportstruct.pathname '.txt']);
       catch
           qq_message(1,'|r|Could not open file'); 
       end
        %else
            %a=dos(['' Reportstruct.pathname '.txt']);
            %winopen([Reportstruct.pathname '.txt']);
        %end
        %if a>0 qq_message(1,'|r|Could not open file'); end
    end
    


end % if fh==-1













