function qq_report_xls(Reportstruct)
global locset 

if locset.tracker==1 disp('--- qq_report_xls ---'); end

n_headerlines=length(Reportstruct.header);
[n_titlelines,n_titlecolumns]=size(Reportstruct.columntitle);
[n_cellines,n_cellcolumns]=size(Reportstruct.cells');
[n_footerlines]=length(Reportstruct.footer);

n_lines=n_headerlines+n_titlelines+n_cellines+n_footerlines+2;
n_columns=max(n_titlecolumns,n_cellcolumns);

printcell=cell(n_lines, n_columns);

lineno=0;
for y=1:n_headerlines
    lineno=lineno+1;
    printcell{lineno,1}=Reportstruct.header{y};
end
lineno=lineno+1;
for y=1:n_titlelines
    lineno=lineno+1;
    for x=1:n_titlecolumns
        printcell{lineno,x}=Reportstruct.columntitle{y,x};
    end
end

for y=1:n_cellines
    lineno=lineno+1;
    for x=1:n_cellcolumns
        printcell{lineno,x}=Reportstruct.cells{x,y};
    end
end
lineno=lineno+1;
for y=1:n_footerlines
    lineno=lineno+1;
    printcell{lineno,1}=Reportstruct.footer{y};
end

try 
    xlswrite(Reportstruct.pathname, printcell)

    if isfield(Reportstruct,'displaymessage') && Reportstruct.displaymessage==1;
        qq_message(1,['|b|Report saved as ' Reportstruct.pathname '.xls'])
    end    
    
    if isfield(Reportstruct,'autoopen') && Reportstruct.autoopen==1;
        try
            winopen([Reportstruct.pathname '.xls'])
        catch
            qq_message(1,'|r|Could not open file')
        end
        
        %a=dos([Reportstruct.pathname '.xls']);
        %if a>0 qq_message(1,'|r|Could not open file'); end
    end
    


catch
    qq_message(1,'|r|Could not write xls file. File may be open or xlswrite may not be supported by current Matlab version (try dif format)')
end


