function qq_2dfari_addlib(an)

global fariset Refdata Sampledata Samplegroupdata Results files 


% ADD
if an==1
    if strmatch(fariset.resultstype,'2D-FARI')
        addlib
    else
        qq_message(1,'|r|Not 2D-FARI Results')
        an=9000;
    end
end



% -------------------------------------------------------------------------
% -------------------- S U B F U N C T I O N S ----------------------------
% -------------------------------------------------------------------------






% --------------- ADDLIB --------------
function addlib

global fariset Results Farilib

Libentry=Results(fariset.selected);
if Libentry.group==0; Libentry.calcomp=1; else Libentry.calcomp=0; end
Libentry.libtime=now; 
Libentry=rmfield(Libentry,{'plot_x','plot_y','index','group'});
DD=dir(pathname);

% Bibliotek eksisterer ikke
if isempty(DD)
    clear Farilib
    Farilib(1)=Libentry; n_entries=1;
    %disp('---- NO LIB ----')
else
    %disp('---- LIB EXIST ----')
    load(pathname,'Farilib')
    n_entries=length(Farilib); 
    if duplicate==0
        n_entries=n_entries+1; 
        fnames=fieldnames(Libentry); n=length(fnames)
        for x=1:n Farilib(n_entries).(fnames{x})=Libentry.(fnames{x}); end
    else
        qq_message(1,'|r|Duplicate found in Library')
    end   
end

save(pathname,'Farilib')

h=findobj('Tag','EntriesTxt'); set(h,'String',[num2str(n_entries) ' Entries'])


% --------------- pathname --------------   
function pathname=pathname;

global fariset

h=findobj('Tag','LibEdit'); fariset.edit_lib=get(h,'String');
fariset.libdir='C:\qq\2D-FARI\Libraries';
pathname=[fariset.libdir,'\2D-FARILIB_',fariset.edit_lib,'.mat'];

% --------------- dupcheck -------------- 
function ex=duplicate

global Results fariset Farilib

X=[cat(1,Farilib.FARIA) cat(1,Farilib.FARIB)];
X(:,3)=((X(:,1)-Results(fariset.selected).FARIA).^2 + (X(:,2)-Results(fariset.selected).FARIB).^2);
eq_entries=find(X(:,3)==0);
Codes=strvcat(Farilib(eq_entries).Code);
match=strmatch(Results(fariset.selected).Code,Codes);
if isempty(match) ex=0; else ex=1; end
