function qq_classdef(an)

global metset fileset locset
global metset2 val % ccat: current category

qq_message(2)

if an==1 
    openwin; 
    metset2.mdescr=[];
    getclass
    an=5.1;
end

% VARIABLES %
% Initialize
if an>2 & an<3 val=get(gcbo,'UserData'); end
% Delete
if an==2.1 metset2.mdescr(val)=[]; val=val-1; end
% Add
if an==2.2
    n=length(metset2.mdescr); val=n+1;
    metset2.mdescr(val).varname=['var', num2str(val)]; metset2.mdescr(val).text='-'; metset2.mdescr(val).fieldtype='Integer';    
end
% Text
if an==2.3 metset2.mdescr(val).text=get(gcbo,'String'); end
% Variable Name
if an==2.4 
    metset2.mdescr(val).varname=get(gcbo,'String'); 
end
% Type
if an==2.5 fieldtypes=get(gcbo,'String'); pos=get(gcbo,'Value'); metset2.mdescr(val).fieldtype=fieldtypes{pos}; end

% End
if an>2 & an<3 
    entries; categories(val); varcheck(val); 
end
    
% CATEGORIES %
% Add Category
if an==3.1
    str=get(findobj('Tag','CatEdit'),'String');
    le=length(metset2.mdescr(val).cat);
    metset2.mdescr(val).cat{le+1}=str;
    set(findobj('Tag','CatList'),'String',metset2.mdescr(val).cat);    
end
% Remove Category
if an==3.2
    pos=get(findobj('Tag','CatList'),'Value');
    metset2.mdescr(val).cat(pos)=[];
    set(findobj('Tag','CatList'),'String',metset2.mdescr(val).cat);
    if pos>length(metset2.mdescr(val).cat) set(findobj('Tag','CatList'),'Value',length(metset2.mdescr(val).cat)); end
end

% LOAD/SAVE SETTINGS
if an==4.1
    % Load
    h=findobj('Tag','ClassPop'); str=get(h,'String'); sel=get(h,'Value'); c_class=str{sel};
    h=findobj('Tag','CurrentClassEdit'); set(h,'String',c_class);
    filename=[locset.path_library,'/class_', c_class, '/Definitions.mat'] 
    load(filename, 'Definitions');
    metset2.mdescr=Definitions.mdescr;
    entries; categories(0); varcheck(0); 
    
end
% LOAD/SAVE SETTINGS
if an==4.2
    % Save
    h=findobj('Tag','CurrentClassEdit'); c_class=get(h,'String');
    % Check for existense
    [d,m]=fileattrib([locset.path_library,'/class_', c_class]);
    if d==1 & m.directory==1 exd=1; else exd=0; end
    if exd==0 
        mkdir([locset.path_library],['/class_', c_class]); 
        qq_message(1,'|b|New class created'); 
        h=findobj('Tag','ClassPop'); str=get(h,'String'); le=length(str); str{le+1}=c_class; set(h,'String',str);       
    end
    Definitions.mdescr=metset2.mdescr;
    filename=[locset.path_library,'/class_', c_class, '/Definitions.mat']; 
    %save(filename, 'Definitions')
    qq_savefile(filename,Definitions,'-o')
end

% Set to current
if an==4.3
    %qq_message(1,'|r|Set in metset')
    h=findobj('Tag','CurrentClassEdit'); c_class=get(h,'String');
    filename=[locset.path_library,'/class_', c_class, '/Definitions.mat']; 
    [s,m]=fileattrib(filename);
    if s==0 
        qq_message(1,'|r|Definitions not saved'); 
    else
        metset.global_class=c_class; metupd; qq_message(1,['|b|Selected class: ',c_class]);
    end
end

% NEW CLASS
if an==5.1
    % rmfield(metset2,'mdescr');
    metset2.mdescr=[];
    metset2.mdescr(1).varname='var1'; metset2.mdescr(1).text='-'; metset2.mdescr(1).fieldtype='Integer'; metset2.mdescr(1).cat={''}; 
    entries; categories(1);
    h=findobj('Tag','CurrentClassEdit'); set(h,'String','New_Class');
end

% Update method
if an==99 metupd; end 

%le=length(metset2.mdescr)



%======================================== SUBFUNCTIONS ========================================

% ------------------- metupd ---------------------
% Oppdaterer metset til klasse valgt i metodefil
function metupd
global metset locset

try
    load([locset.path_library,'\class_',metset.global_class,'\Definitions.mat']);
    n_descr=length(Definitions.mdescr);
    metset.mdescr=Definitions.mdescr; 
catch
    qq_message(1,'|r|Warning: Could not read selected compound class')
end


% ------------------- getclass ---------------------
function getclass
global metset locset

D=dir([locset.path_library,'/class_*']); % Leser klasser fra Library-dir
D=D(find(cat(2,D.isdir))); for x=1:length(D) DD{x}=D(x).name(7:length(D(x).name)); end % Variabel for klasse-navn
h=findobj('Tag','ClassPop'); set(h,'String',DD);
%pos=pop_set(pos,'Class:',DD,'global_class','Compound class');


% ------------------- varcheck ---------------------
function varcheck(val)
global metset2

if val>0
    if isvarname(metset2.mdescr(val).varname)==0 
        h=findobj('Tag','VarEdit','UserData',val);
        set(h,'BackgroundColor',[1 0 0]); 
        qq_message(1,['|r|Illegal: ' metset2.mdescr(val).varname]);
    end
end
    
match=[];
for x=1:length(metset2.mdescr); varcell{x}=metset2.mdescr(x).varname; end
for x=1:length(metset2.mdescr)
    testcell=varcell; testcell{x}=''; match=[match; strmatch(metset2.mdescr(x).varname,testcell,'Exact')];
end
match=unique(match);
if isempty(match)==0; 
    qq_message(1,'|r|Duplicates'); 
    for x=1:length(match)
        h=findobj('Tag','VarEdit','UserData',match(x)); set(h,'BackgroundColor',[1 1 0]); 
    end
end         
      

% ------------------- entries ---------------------
function entries
global positions colors metset metset2

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 
pos=0.85;
fieldtypes={'Integer','Decimal','String','Binary','Category'};

h=findobj('Tag','TextEdit'); delete(h)
h=findobj('Tag','VarEdit'); delete(h)
h=findobj('Tag','TypePop'); delete(h)
h=findobj('Tag','DelButton'); delete(h)
h=findobj('Tag','AddButton'); delete(h)
h=findobj('Tag','EntNum'); delete(h)

for p=1:length(metset2.mdescr)
    pos=pos-gh;    
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.bc, ...
	    'Position',[x(1)-bw/4 pos bw/2 eh], ...
        'Style','Text',...
        'HorizontalAlignment','left',...
	    'Tag','EntNum',...
        'String',num2str(p));
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
	    'Position',[x(1) pos bw*0.8 eh], ...
        'Style','Edit',...
        'HorizontalAlignment','left',...
	    'String',metset2.mdescr(p).text,...
        'UserData',p,...
        'CallBack','qq_classdef(2.3)',...
        'Tag','TextEdit');
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
	    'Position',[x(2) pos bw*0.8 eh], ...
        'HorizontalAlignment','left',...
        'Style','Edit',...
        'UserData',p,...
        'CallBack','qq_classdef(2.4)',...
        'Tag','VarEdit',...
	    'String',metset2.mdescr(p).varname);

    val=strmatch(metset2.mdescr(p).fieldtype,fieldtypes); if isempty(val) val=1; end
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
	    'Position',[x(3) pos bw*0.8 eh], ...
        'HorizontalAlignment','left',...
        'Tag','TypePop',...
        'Style','Popupmenu',...
        'Value',val,...
        'UserData',p,...
        'CallBack','qq_classdef(2.5)',...
        'String',fieldtypes);
    
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.reset, ...
	    'Position',[x(4) pos bw*0.8 bh], ...
        'HorizontalAlignment','left',...
        'Tag','DelButton',...
        'UserData',p,...
        'CallBack','qq_classdef(2.1)',...
        'Style','Pushbutton',...
	    'String','Delete');    
    
    if strmatch(fieldtypes(val),'Category')
        h1 = uicontrol('Parent',gcf, ...
            'BackgroundColor',colors.btn{6}, ...
	        'Position',[x(5) pos bw*0.8 bh], ...
            'HorizontalAlignment','left',...
            'Tag','DelButton',...
            'UserData',p,...
            'CallBack','qq_classdef(2.6)',...
            'Style','Pushbutton',...
	        'String','Ed.Cat. ->');
    end    
end

pos=pos-gh;
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.accept, ...
    'Position',[x(4) pos bw*0.8 bh], ...
    'HorizontalAlignment','left',...
    'Tag','AddButton',...
    'Style','Pushbutton',...
    'CallBack','qq_classdef(2.2)',...
	'String','Add');


% ------------------- Categories ---------------------
function categories(inp)
global positions colors metset metset2

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 
pos=0.85;

h=findobj('Tag','CatList'); delete(h)
h=findobj('Tag','CatEdit'); delete(h)
h=findobj('Tag','AddCat'); delete(h)
h=findobj('Tag','DelCat'); delete(h)

if inp>0;
    if strmatch(metset2.mdescr(inp).fieldtype,'Category')
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
        'Position',[x(6) pos-0.3 bw*1.5 0.29], ...
        'Style','Listbox',...
        'HorizontalAlignment','left',...
	    'String',metset2.mdescr(inp).cat,...
        'Tag','CatList');
    
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
        'Position',[x(8) pos-gh bw*1.5 bh], ...
        'Style','Edit',...
        'HorizontalAlignment','left',...
	    'String','',...
        'Tag','CatEdit');    

    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.accept, ...
        'Position',[x(7)+bw/2 pos-gh bw*0.5 bh], ...
        'Style','Pushbutton',...
        'HorizontalAlignment','left',...
	    'String','<- Add',...
        'CallBack','qq_classdef(3.1)',...
        'Tag','AddCat');  

     h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.reset, ...
        'Position',[x(7)+bw/2 pos-gh*2 bw*0.5 bh], ...
        'Style','Pushbutton',...
        'HorizontalAlignment','left',...
	    'String','-> Del',...
        'CallBack','qq_classdef(3.2)',...
        'Tag','AddCat'); 
    end
end


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='ClassDefWin'; winpar{2}='Q: Define Class';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'',3,'');

p=p+1;[ui{p,1:7}] = deal('New Class','Pushbutton',colors.btn{1},[x(1) y(2) bw bh*1.5],'qq_classdef(5.1)',3,'');

vp=0.835; o=bw/8;
p=p+1;[ui{p,1:7}] = deal('Descriptor','Text',colors.bc,[x(1)+o vp bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Var.Name','Text',colors.bc,[x(2)+o vp bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Type','Text',colors.bc,[x(3)+o vp bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Categories','Text',colors.bc,[x(6)+o vp bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('New Cat.','Text',colors.bc,[x(8)+o vp bw bh],'',2,'');

vp=y(20)+bh/2;
p=p+1;[ui{p,1:7}] = deal('Load Def.','Pushbutton',colors.btn{6},[x(3) vp bw bh],'qq_classdef(4.1)',2,'');
p=p+1;[ui{p,1:7}] = deal(' ','Popupmenu',[1 1 1],[x(4) vp bw*1.5 bh],'',2,'ClassPop');

p=p+1;[ui{p,1:7}] = deal('Save Def.','Pushbutton',colors.btn{6},[x(6) vp bw bh],'qq_classdef(4.2)',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.file_method,'Edit',[1 1 1],[x(7) vp bw*1.5 bh],'',2,'CurrentClassEdit');
p=p+1;[ui{p,1:7}] = deal('Use','Pushbutton',colors.btn{6},[x(8)+bw/2 vp bw bh],'qq_classdef(4.3)',2,'');

updfcn='';
qq_drawwin(winpar,ui,updfcn); 

h=findobj('Style','PopupMenu'); set(h,'FontName','FixedWidth','FontWeight','Normal')

drawnow









