function qq_copyfigure(call)
% Copies figure to nw window.
% command 'qq_copyfigure' (no inp. parameters) must be given after figure
% is drawn to add menu.

global colors

if nargin==0 call=0; end

if call==0
    cmenu = uicontextmenu;
    item1 = uimenu(cmenu, 'Label', 'Copy Figure', 'Callback', 'qq_copyfigure(1)');
    set(gca,'UiContextMenu',cmenu);
end

if call==1
    axesh=gca;
    nyfig=figure('Color',colors.bc); 
    h=copyobj(axesh,nyfig); set(h,'Position',[0.05 0.05 0.9 0.9]); 
    child=get(h,'Children'); set(child,'ButtonDownFcn','')
end