function qq_editlib(an)

global fileset metset locset
global Library n_entries cond_lib n_cond selected delvect editvect searchparameters % CHANGE TO PERSISTENT

%disp('-------------------------------------------------------------------')
%disp('--------------- START ---------------------------------------------')

if locset.tracker==1 disp(['--- qq_editlib --- an=' num2str(an) ]); end

qq_message(2)

% Frste call pner vindu , Initial settings
if an==1; 
    openwin; qq_lib_descriptors(0); selected=1;
    %h=findobj('Tag','SubWin'); set(h,'Visible','off')
    le=length(metset.mdescr); for x=1:le h=findobj('Tag',['DescrField',num2str(x)]); set(h,'CallBack','qq_editlib(6)'); end
    
    % Searchparameters
    searchparameters(1).text='Name';searchparameters(1).varname='cmp_name'; searchparameters(1).selected=[];
    searchparameters(2).text='Short Name';searchparameters(2).varname='cmp_shortname'; searchparameters(2).selected=[];
    searchparameters(3).text='Reg. Code';searchparameters(3).varname='cmp_code'; searchparameters(3).selected=[];
    searchparameters(4).text='Comments';searchparameters(4).varname='comments'; searchparameters(4).selected=[];
    searchparameters(5).text='RI :  ';searchparameters(5).varname='ri_calc'; searchparameters(5).selected=[];
    searchparameters(6).text='RI Def:  ';searchparameters(6).varname='ri_def'; searchparameters(6).selected=[];
    for x=1:le searchparameters(6+x).text=metset.mdescr(x).text; searchparameters(6+x).varname=metset.mdescr(x).varname; end
    for x=1:length(searchparameters); str{x}=searchparameters(x).text; end
    for x=1:length(searchparameters); searchparameters(x).selected=[];searchparameters(x).value=[]; end
    h=findobj('Tag','SearchPop');
    set(h,'String',str);   
end

% HENT BIBLIOTEK    
% Oppdaterer n_entries, Sjekker om bibliotek finnes
if an==1 | an==2
    LibraryEdit=findobj('Tag','LibraryEdit'); libname=get(LibraryEdit,'String');
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',libname];
    [nn_entries,t_Library]=getlib(filename); 
    if nn_entries==0; qq_message(1,'|r|Library not found'); end
    if nn_entries>0; metset.libray_name=libname; an=4; n_entries=nn_entries; Library=t_Library; end
    EntriesTxt=findobj('Tag','EntriesTxt');
    set(EntriesTxt,'String',[num2str(n_entries),' Entries']);
end

if an==3
    LibList1=findobj('Tag','LibList1');
    selected=get(LibList1,'Value');
    lib_entry=cond_lib(selected); upd_entry(lib_entry);
end

% Search mm.
if an>=4 & an<5
    [cond_lib,n_cond]=searchlib(Library,searchparameters);
    liblist(cond_lib,n_cond);
    if isempty(selected) selected=1; end 
    
    if n_cond>0
        if selected>n_cond; selected=n_cond; end 
        if selected<1 selected=1; end
        lib_entry=cond_lib(selected);
    else
        selected=0; lib_entry=dummylib;
    end
    
    upd_entry(lib_entry);
    delvect=[]; editvect=[];

    LibList1=findobj('Tag','LibList1');
    if an==4.0 & selected>0 set(LibList1,'Value',1); end          % SEARCH
    if an==4.5 & selected>0 set(LibList1,'Value',selected); end   % ACCEPT
    if selected==0 set(LibList1,'Value',1); end
    
end


% Delete
if an==5 & selected>0
    cond_lib(selected).cmp_name=('--- deleted ---');
    cond_lib(selected).cmp_shortname=('--- deleted ---');
    cond_lib(selected).cmp_code=('');
    cond_lib(selected).ri_calc=[];
    cond_lib(selected).ri_def=[];
    cond_lib(selected).pn=[];
    cond_lib(selected).clunr=[];
    cond_lib(selected).rt=[];
    cond_lib(selected).file_name=[];
    fn=fieldnames(cond_lib(selected).mdescr); for x=1:length(fn) cond_lib(selected).mdescr.(fn{x})=[]; end
    cond_lib(selected).single=[];
    cond_lib(selected).comments=[];
    liblist(cond_lib,n_cond); 
    lib_entry=cond_lib(selected); upd_entry(lib_entry);
    delvect=[delvect selected];
    qq_message(1,'|b|Accept to save, Search to discard') 
end

% UPDATE ENTRY
if an==6
    CompoundNameEdit=findobj('Tag','CompoundNameEdit'); cond_lib(selected).cmp_name=get(CompoundNameEdit,'String');
    CompoundCodeEdit=findobj('Tag','CompoundCodeEdit'); cond_lib(selected).cmp_shortname=get(CompoundCodeEdit,'String');
    CasNrEdit=findobj('Tag','CasNrEdit'); cond_lib(selected).cmp_code=get(CasNrEdit,'String');    
    RiEdit=findobj('Tag','RiEdit'); cond_lib(selected).ri_calc=str2double(get(RiEdit,'String')); 
    RiDefEdit=findobj('Tag','RiDefEdit'); cond_lib(selected).ri_def=str2double(get(RiDefEdit,'String')); 
    CommentsEdit=findobj('Tag','CommentsEdit'); cond_lib(selected).comments=get(CommentsEdit,'String');
    % Descriptors
    cond_lib(selected).mdescr=qq_lib_descriptors(1);
    % cond_lib(selected)
    liblist(cond_lib,n_cond);
    if isempty(find(editvect==selected)) editvect=[editvect selected]; qq_message(1,'|b|Accept to save, Search to discard'); end   
end

%ACCEPT (& SAVE)
if an==7
    [Library,n_del]=accept_library(Library,cond_lib,delvect,editvect);
    n_entries=n_entries-n_del;
    EntriesTxt=findobj('Tag','EntriesTxt');
    set(EntriesTxt,'String',[num2str(n_entries),' Entries']);
    qq_editlib(4.5)
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',metset.libray_name];
    save(filename,'Library');
    qq_savefile(filename,Library,'-o');
end

% CLOSE
if an==8
    %h=findobj('Visible','off'); set(h,'Visible','on')
    qq_closewin;
end

% SEARCH:
% Initialize
if an>9 & an<10
    SearchList=findobj('Tag','SearchList'); SearchPop=findobj('Tag','SearchPop'); SearchEdit=findobj('Tag','SearchEdit');
    sel=cat(2,searchparameters.selected);  val=get(SearchPop,'Value'); editstr=get(SearchEdit,'String'); pos=get(SearchList,'Value');
end
% select parameter;
if an==9.1
    if val<6 editstr=cond_lib(selected).(searchparameters(val).varname); 
    else editstr=cond_lib(selected).mdescr.(searchparameters(val).varname); end
    if isnumeric(editstr) editstr=num2str(editstr); end; set(SearchEdit,'String',editstr);
end
% set value
if an==9.2
    if isempty(editstr) searchparameters(val).selected=[]; searchparameters(val).value=[];
    else searchparameters(val).selected=val; searchparameters(val).value=editstr; end
end
% Select from list
if an==9.3
    val=sel(pos); set(SearchPop,'Value',val); set(SearchEdit,'String',searchparameters(val).value);    
end
% Delete
if an==9.4 & isempty(sel)==0
    val=sel(pos); searchparameters(val).selected=[]; searchparameters(val).value=[];
end
% End
if an>9 & an<10    
    sel=cat(2,searchparameters.selected);
    liststr=[]; for x=1:length(sel) liststr{x}=[searchparameters(sel(x)).text ,': ',searchparameters(sel(x)).value];  end
    set(SearchList,'String',liststr); if pos>length(sel); set(SearchList,'Value',1); end         
end

% Key Press
if an==96
    kp=double(get(gcf,'CurrentCharacter')); listh=findobj('Tag','LibList1'); val=get(listh,'Value'); le=length(get(listh,'String'));
    if kp==31 val=val+1; if val>le val=le; end; end  % Arrow down   
    if kp==30 val=val-1; if val==0; val=1; end; end; % Arrow up
    set(listh,'Value',val); qq_editlib(3);
end

% update
if an==100
    %
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            S U B F U N C T I O N S
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% ------------- FUNCTION: ACCEPT_LIBRARY --------------------------------------------------
function [Library,n_del]=accept_library(Library,cond_lib,delvect,editvect)

% Change
for i1=1:length(editvect)
    cond_entry=editvect(i1);
    lib_entry=cond_lib(cond_entry).entrynr;
    %-------------------------
    Library(lib_entry).cmp_name=cond_lib(cond_entry).cmp_name;
    Library(lib_entry).cmp_shortname=cond_lib(cond_entry).cmp_shortname;
    Library(lib_entry).cmp_code=cond_lib(cond_entry).cmp_code;
    Library(lib_entry).ri_calc=cond_lib(cond_entry).ri_calc; 
    Library(lib_entry).ri_def=cond_lib(cond_entry).ri_def; 
    Library(lib_entry).comments=cond_lib(cond_entry).comments;   
    Library(lib_entry).mdescr=cond_lib(cond_entry).mdescr;   
end

% DELETE
n_del=length(delvect);
for i1=1:n_del; delvect_lib(i1)=cond_lib(delvect(i1)).entrynr; end
if n_del>0; Library(delvect_lib)=[]; end




% ------------- FUNCTION: UPD_ENTRY --------------------------------------------------------
function upd_entry(lib_entry)
global metset

CompoundNameEdit=findobj('Tag','CompoundNameEdit');
set(CompoundNameEdit,'String',lib_entry.cmp_name)
if isempty(lib_entry.cmp_name) lib_entry.cmp_name='-'; end 

CompoundCodeEdit=findobj('Tag','CompoundCodeEdit');
set(CompoundCodeEdit,'String',lib_entry.cmp_shortname)
if isempty(lib_entry.cmp_shortname) lib_entry.cmp_shortname='-'; end 

CasNrEdit=findobj('Tag','CasNrEdit');
set(CasNrEdit,'String',lib_entry.cmp_code)
if isempty(lib_entry.cmp_code) lib_entry.cmp_code='-'; end 

RiEdit=findobj('Tag','RiEdit');
if isfield(lib_entry,'ri_calc')==0 lib_entry.ri_calc=[]; end
set(RiEdit,'String',lib_entry.ri_calc)

RiDefEdit=findobj('Tag','RiDefEdit');
if isfield(lib_entry,'ri_def')==0 lib_entry.ri_def=NaN; end
set(RiDefEdit,'String',lib_entry.ri_def)

%CarbonsEdit=findobj('Tag','CarbonsEdit');
%set(CarbonsEdit,'String',lib_entry.carbons)
%DbbEdit=findobj('Tag','DbbEdit');
%set(DbbEdit,'String',lib_entry.dbb)
CommentsEdit=findobj('Tag','CommentsEdit');
set(CommentsEdit,'String',lib_entry.comments)

% DESCRIPTORS
if isfield(lib_entry,'mdescr')
    qq_lib_descriptors(2,lib_entry.mdescr);
end

% Additional info
Write{1}='-';
if isfield(lib_entry,'file_name') Write{1}=['File Name: ',lib_entry.file_name]; end
if isfield(lib_entry,'column') Write{2}=['Column: ',num2str(lib_entry.column)]; end
if isfield(lib_entry,'rt') Write{3}=['Retention time: ',num2str(lib_entry.rt)]; end
if isfield(lib_entry,'ri_calc') Write{4}=['Retention index: ',num2str(lib_entry.ri_calc)]; end
if isfield(lib_entry,'clunr') Write{5}=['Cluster: ',num2str(lib_entry.clunr),', Peak: ',num2str(lib_entry.pn)]; end
if isfield(lib_entry,'single') Write{6}=['Single/Extracted: ',lib_entry.single]; end
InfoTxt=findobj('Tag','InfoTxt');
set(InfoTxt,'String',Write);


% ------------- FUNCTION: DUMMYLIB --------------------------------------------------------
function lib_entry=dummylib

lib_entry.cmp_name=[];
lib_entry.cmp_shortname=[];
lib_entry.ri_def=[];
lib_entry.ri_calc=[];
lib_entry.column=[];
lib_entry.cmp_code=[];
lib_entry.pn=[];
lib_entry.clunr=[];
lib_entry.rt=[];
lib_entry.file_name=[];
lib_entry.single=[];
lib_entry.comments=[];
lib_entry.mdescr=[];


% ------------- FUNCTION: GETLIB --------------------------------------------------------

function [n_entries,Library]=getlib(filename)

D=dir([filename,'.mat']);
DD=struct2cell(D);[m,n]=size(DD);
if n>0
    load(filename,'Library');
    d=struct2cell(Library);
    [m,n_entries]=size(d);
else
    n_entries=0; Library=[];
end
%if n_entries>0; Library=conv2numb(Library); end

%function Library=conv2numb(Library)
%n_entries=length(cat(2,Library.pn)); 
%for i1=1:n_entries
    %if ischar(Library(i1).carbons) Library(i1).carbons=round(str2double(Library(i1).carbons)); end
    %if ischar(Library(i1).dbb) Library(i1).dbb=round(str2double(Library(i1).dbb)); end    
    %if ischar(Library(i1).ri_def) Library(i1).ri_def=str2double(Library(i1).ri_def); end
%end

% --------- SUBFUNCTION: Searchlib ------------------------------------------------------------------
function [cond_lib,n_entries]=searchlib(cond_lib,searchparameters)

% resetter liste
LibList1=findobj('Tag','LibList1');
set(LibList1,'Value',1);   

n_entries=length(cond_lib); 
% Legger til entrynr
entrynr=1:n_entries; 
entrynr=num2cell(entrynr); 
[cond_lib(:).entrynr]=deal(entrynr{:});
temp_lib=cond_lib;

sel=cat(2,searchparameters.selected);
for x=1:length(sel)
    varname=searchparameters(sel(x)).varname;
    val=searchparameters(sel(x)).value;
    n_cond=length(cond_lib); match=[];
    for y=1:n_cond
        if sel(x)<=5 teststr=cond_lib(y).(varname); else teststr=cond_lib(y).mdescr.(varname); end
        if isnumeric(teststr); match(y)=str2double(val)==teststr; else match(y)=strcmp(teststr,val); end       
    end
    matches=find(match); cond_lib=cond_lib(matches);    
end

if isempty(cond_lib) cond_lib=temp_lib; qq_message(1,'|b|No hits'); end
n_entries=length(cond_lib);

% --------- SUBFUNCTION: LIBLIST ------------------------------------------------------------------

function liblist(lib,n_entries)

if isstruct(lib)
    % Skriver resultater
    for i1=1:n_entries
        Str1=num2str(lib(i1).entrynr); Str1=[Str1,blanks(10)]; Str1=Str1(1:4);
        Str2=lib(i1).cmp_code; Str2=[Str2,blanks(15)];Str2=Str2(1:15);
        Str3=lib(i1).cmp_name; Str3=[Str3,blanks(50)];Str3=Str3(1:50);
        ReM{i1}=[Str1,' ',Str2,' ',Str3];
    end
    if n_entries==0 ReM=[]; end
    LibList1=findobj('Tag','LibList1');
    set(LibList1,'String',ReM);     
end % if isstruct


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='EditLibWin'; winpar{2}='Q: Edit Libr.';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'qq_addlib(8)',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_addlib(0)',3,'');
% FRAMES
yp=10;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5 y(13)+bh/2 bw*4.5 y(1)-y(14)-bh/2],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Edit','Text',colors.bc,[x(1) y(yp-9)-bh*0.2 bw*3 bh],'',4,'');
yp=19;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5 y(yp)+bh*0.7 bw*4.5 bh*7],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Search','Text',colors.bc,[x(1) y(yp-5)-bh*0.4 bw*3 bh],'',4,'');
% LISTE
p=p+1;[ui{p,1:7}] = deal('No   Reg.Code        Name','Text',[1 1 1],[x(6) y(1) bw*4 eh],'',2,'ListHead');
p=p+1;[ui{p,1:7}] = deal('Searching...','Listbox',[1 1 1],[x(6) y(18) bw*4 y(1)-y(18)],'qq_editlib(3)',2,'LibList1');
% NAME
p=p+1;[ui{p,1:7}] = deal('Name:','Text',colors.bc,[x(1) y(2) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(2) bw*3 eh],'qq_editlib(6)',2,'CompoundNameEdit');
% Short Name
p=p+1;[ui{p,1:7}] = deal('Short name:','Text',colors.bc,[x(1) y(3) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(3) bw*3 eh],'qq_editlib(6)',2,'CompoundCodeEdit');
% Code
p=p+1;[ui{p,1:7}] = deal('Reg. code:','Text',colors.bc,[x(1) y(4) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(4) bw eh],'qq_editlib(6)',2,'CasNrEdit');
% Retention index
p=p+1;[ui{p,1:8}] = deal('RI:  ','Text',colors.bc,[x(3) y(4) bw/2 eh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',[1 1 1],[x(3)+bw/2 y(4) bw/2 eh],'qq_editlib(6)',2,'RiEdit','-r');
% Ri def
p=p+1;[ui{p,1:8}] = deal('RI Def:  ','Text',colors.bc,[x(4) y(4) bw/2 eh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',[1 1 1],[x(4)+bw/2 y(4) bw/2 eh],'qq_editlib(6)',2,'RiDefEdit','-r');
% Comments
p=p+1;[ui{p,1:7}] = deal('Comments:','Text',colors.bc,[x(1) y(5) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(5) bw*3 eh],'qq_editlib(6)',2,'CommentsEdit');
% Delete
p=p+1;[ui{p,1:7}] = deal('Delete','Pushbutton',colors.reset,[x(1) y(10) bw bh],'qq_editlib(5)',2,'');
% Accept
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(1) y(11) bw bh],'qq_editlib(7)',2,'');

p=p+1;[ui{p,1:7}] = deal('Reset','Pushbutton',colors.btn{5},[x(1) y(12) bw bh],'qq_editlib(2)',2,'');
% InfoTxt
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(9) bw*2 bh*4.5],'',2,'InfoTxt');

% Library
p=p+1;[ui{p,1:7}] = deal('Library:','Text',colors.bc,[x(6) y(19) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.library_name,'Edit',[1 1 1],[x(7) y(19) bw*1.8 eh],'',2,'LibraryEdit');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(9) y(19) bw*3 eh],'',2,'EntriesTxt');

% --------- SEARCH ----------%
o=bh*0.4;
p=p+1;[ui{p,1:7}] = deal('Searchlist...','Listbox',[1 1 1],[x(1) y(17) bw*2 gh*2+bh-o],'qq_editlib(9.3)',2,'SearchList');
p=p+1;[ui{p,1:7}] = deal('Del. Param.','Pushbutton',colors.btn{6},[x(1) y(18) bw bh],'qq_editlib(9.4)',2,'');

p=p+1;[ui{p,1:7}] = deal('Select Parameter:','Text',colors.bc,[x(3)+bw/2 y(14)-bh*0.5-o bw*1.5 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(' ','PopupMenu',[1 1 1],[x(3)+bw/2 y(15)-o bw*1.5 bh],'qq_editlib(9.1)',2,'SearchPop');

p=p+1;[ui{p,1:7}] = deal('Value:','Text',colors.bc,[x(3)+bw/2 y(16)-bh*0.5 bw*1.5 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(' ','Edit',[1 1 1],[x(3)+bw/2 y(17) bw*1.5 bh],'qq_editlib(9.2)',2,'SearchEdit');

p=p+1;[ui{p,1:7}] = deal('Search','Pushbutton',colors.btn{6},[x(3)+bw/2 y(18) bw bh],'qq_editlib(4)',2,'');

updfcn='qq_editlib(100)';
h0=qq_drawwin(winpar,ui,updfcn); 
set(h0,'KeyPressFcn','qq_editlib(96)')

h=findobj('Tag','ListHead'); set(h,'FontName','FixedWidth','FontWeight','normal');
h=findobj('Tag','LibList1'); set(h,'ButtonDownFcn','qq_editlib(3)','Value',1);
drawnow






