function qq_lib_replace(an)
% function qq_addlib

global fileset metset locset
global LIB n_lib c_lib ind c_ind n_rep % ind=vektor med matchende indexer, c_ind=gjeldende index
%persistent LIB selected

qq_message(2)

%disp('----- ADDLIB -----')
%metset % TEMP

% pner vindu
if an==0; 
    LIB=[]; ind=[]; n_entr=0; c_ind=0; c_lib=0;

    openwin; 
    findlibs

end

% Select Libraries 
if an==1.1; addlib; end
if an==1.2; rmlib; end
if an==1.3; strlib; end
if an==1.4; addall; end
if an>1 & an<2 h=findobj('Tag','ActLibList'); n_lib=length(get(h,'String')); end

% Search
if an==2.1 & n_lib>0 & paracheck
    c_lib=1; c_ind=1; n_rep=0;
    h=findobj('Tag','ActLibList');str=get(h,'String'); set(h,'Value',1);
    [LIB,ind]=openlib(str{1}); 
    if isempty(ind); an=3.2; end
end

% Search and replace
if an==2.2 & n_lib>1 & paracheck
    n_rep=0;
    for c_lib=1:n_lib
        h=findobj('Tag','ActLibList');str=get(h,'String'); set(h,'Value',c_lib);
        [LIB,ind]=openlib(str{c_lib});    
        if isempty(ind)==0
            for c_ind=1:length(ind); LIB=replentry(LIB,ind(c_ind)); n_rep=n_rep+1; end
            savelib(LIB,str{c_lib}); 
        end
    end
    qq_message(1,['|b|End of search. ' num2str(n_rep) ' replaced']); 
end
                
%Replace
if an==3.1
    if c_ind<=length(ind) LIB=replentry(LIB,ind(c_ind)); n_rep=n_rep+1; end
end
% Replace all
if an==3.2
    if c_ind<=length(ind) for x=c_ind:length(ind); LIB=replentry(LIB,ind(x)); n_rep=n_rep+1; end; c_ind=x; end
end

% Skip Libr
if an==3.3
    c_ind=length(ind);
end

% Next entry/lib
if an>3.0 & an<4.0 
    c_ind=c_ind+1;
    if c_ind>length(ind) 
        h=findobj('Tag','ActLibList');str=get(h,'String');
        savelib(LIB,str{c_lib});       
        if c_lib<n_lib
            ind=[];
            while isempty(ind) & c_lib<n_lib
                c_lib=c_lib+1; c_ind=1;
                [LIB,ind]=openlib(str{c_lib});
                h=findobj('Tag','ActLibList'); set(h,'Value',c_lib);
            end
        else
            qq_message(1,['|b|End of search. ' num2str(n_rep) ' replaced']); 
        end
    end
end

% Replace parameters
if an>4.0 & an<5.0 
    if length(get(gcbo,'String'))>0 val=1; else val=0; end
    %length(get(gcbo,'String'))
    if an==4.1 h=findobj('Tag','ReplNameCheck'); set(h,'Value',val); end
    if an==4.2 h=findobj('Tag','ReplShortCheck'); set(h,'Value',val); end
    if an==4.3 h=findobj('Tag','ReplCodeCheck'); set(h,'Value',val); end
end

% ----------- UPDATE ----------
%c_ind
%ind
if c_ind>0 & length(ind)>0 & c_ind<=length(ind)
    EntrInfo(LIB(ind(c_ind)),c_ind,ind);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            S U B F U N C T I O N S
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ------------------- paracheck ---------------------
% returnerer 1 hvis klar
function check=paracheck;

check=1; 
v1=0;
h=findobj('Tag','SearchNameEdit'); str=get(h,'String'); if isempty(str)==0; v1=1; end
h=findobj('Tag','SearchShortEdit'); str=get(h,'String'); if isempty(str)==0; v1=1; end
h=findobj('Tag','SearchCodeEdit'); str=get(h,'String'); if isempty(str)==0; v1=1; end
if v1==0; qq_message(1,'|r|No Search parameters'); end

v2=0;
h=findobj('Tag','ReplNameCheck'); if get(h,'Value')==1 v2=1; end
h=findobj('Tag','ReplShortCheck'); if get(h,'Value')==1 v2=1; end
h=findobj('Tag','ReplCodeCheck'); if get(h,'Value')==1 v2=1; end
if v2==0; qq_message(1,'|r|No Replace parameters'); end

check=v1*v2;

% ------------------- REPLENTRY ---------------------
function LIB=replentry(LIB,entry)

% Name
h=findobj('Tag','ReplNameEdit'); namestr=get(h,'String');
h=findobj('Tag','ReplNameCheck'); nameval=get(h,'Value');
if length(namestr)>0 & nameval==1
    LIB(entry).cmp_name=namestr;
end

% Short
h=findobj('Tag','ReplShortEdit'); shortstr=get(h,'String');
h=findobj('Tag','ReplShortCheck'); shortval=get(h,'Value');
if length(shortstr)>0 & shortval==1
    LIB(entry).cmp_shortname=shortstr;
end

% Code
h=findobj('Tag','ReplCodeEdit'); codestr=get(h,'String');
h=findobj('Tag','ReplCodeCheck'); codeval=get(h,'Value');
if length(codestr)>0 & codeval==1
    LIB(entry).cmp_code=codestr;
end


% ------------------- FINDLIBS ---------------------
function findlibs
global metset locset

filename=[locset.path_library,'\class_',metset.global_class,'\lib_*'];
D=dir([filename,'.mat']);
DD=struct2cell(D);
[m,n_libs]=size(DD);

for x=1:n_libs LibNames{x}=DD{1,x}(5:length(DD{1,x})-4); end
h=findobj('Tag','AvaLibList'); set(h,'String',LibNames);


% ------------------- ADDLIB ---------------------
function addlib

h=findobj('Tag','AvaLibList'); AvaStr=get(h,'String'); AvaPos=get(h,'Value'); nAva=length(AvaStr);
SelLib=AvaStr{AvaPos};
if AvaPos<nAva; set(h,'Value',AvaPos+1); end

h=findobj('Tag','ActLibList'); ActStr=get(h,'String'); nAct=length(ActStr); strm=strmatch(SelLib,ActStr,'exact');
if isempty(strm) ActStr{nAct+1}=SelLib; set(h,'String',ActStr,'Value',nAct+1); end



% ------------------- ADDALL ---------------------
function addall

h=findobj('Tag','AvaLibList'); AvaStr=get(h,'String');
h=findobj('Tag','ActLibList'); set(h,'String',AvaStr);

% ------------------- RMLIB ---------------------
function rmlib

h=findobj('Tag','ActLibList'); ActStr=get(h,'String'); 
ActPos=get(h,'Value'); nAct=length(ActStr);
if nAct>0 
    ActStr(ActPos)=[]; nAct=nAct-1; 
    if ActPos>nAct; set(h,'Value',nAct); end 
    set(h,'String',ActStr); 
end


% ------------------- STRINGLIB ---------------------
function strlib

h=findobj('Tag','LibStrEdit'); LibStr=get(h,'String');
if isempty(LibStr)
    qq_message(1,'|r|No String')
else
    h=findobj('Tag','AvaLibList'); AvaStr=get(h,'String');
    matchpos=strmatch(LibStr,AvaStr);
    ActStr=AvaStr(matchpos);
    h=findobj('Tag','ActLibList');
    if isempty(ActStr)==0 set(h,'String',ActStr,'Value',1); else qq_message(1,'|r|No Match'); end
end

% ------------------- SAVELIB ---------------------
function savelib(LIB,libname)
global metset locset

Library=LIB;
filename=[locset.path_library,'\class_',metset.global_class,'\LIB_',libname,'.mat'];
%save(filename,'Library');
qq_savefile(filename,Library,'-o');


% ------------------- OPENLIB ---------------------
function [LIB,ind]=openlib(libname)
global metset locset

filename=[locset.path_library,'\class_',metset.global_class,'\LIB_',libname,'.mat'];
load(filename,'Library');
LIB=Library;

% Returnerer indexer som matcher skekriterier
ind=[]; n_entries=length(LIB); nameskip=0; shortskip=0; codeskip=0;
SearchName=get(findobj('Tag','SearchNameEdit'),'String'); if length(SearchName)==0; nameskip=1;end
SearchShort=get(findobj('Tag','SearchShortEdit'),'String'); if length(SearchShort)==0; shortskip=1; end
SearchCode=get(findobj('Tag','SearchCodeEdit'),'String'); if length(SearchCode)==0; codeskip=1; end

if nameskip & shortskip & codeskip 
    qq_message(1,'|r|No search criteria')
else
    for x=1:length(LIB)
        m(1)=strcmp(SearchName,LIB(x).cmp_name) | nameskip;
        m(2)=strcmp(SearchShort,LIB(x).cmp_shortname) | shortskip;   
        m(3)=strcmp(SearchCode,LIB(x).cmp_code) | codeskip;
        ind(x)=(m(1) & m(2) & m(3));
    end
end

ind=find(ind);

str{1}=['Current Library: ' libname];
str{2}=['Matching entries: ' num2str(length(ind))];
h=findobj('Tag','LibTxt'); set(h,'String',str);
h=findobj('Tag','InfoTxt'); set(h,'String','');


% ------------------- EntrInfo ---------------------
function EntrInfo(Entry,c_ind,ind)

h=findobj('Tag','InfoTxt');

str{1}=['Entry: ' num2str(c_ind)];
str{2}=['Name: ' Entry.cmp_name];
str{3}=['Short: ' Entry.cmp_shortname];
str{4}=['Code: ' Entry.cmp_code];
str{5}=['Filename: ' Entry.file_name];
str{6}=['Ions: ' num2str(length(Entry.ions))];
str{7}=['Position in library: ' num2str(ind(c_ind))];
str{8}=['Comments: ' Entry.comments];

set(h,'String',str)

%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='AddLibWin'; winpar{2}='Q:Lib.Replace';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'qq_addlib(8)',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_addlib(0)',3,'');

% FRAME
oo=5;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5 y(oo) bw*4 y(1)-y(6)],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Searchparameters:','Text',colors.bc,[x(1) y(oo-4) bw*2.5 bh],'',4,'');
% NAME
p=p+1;[ui{p,1:7}] = deal('Name:','Text',colors.bc,[x(1) y(oo-3) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(oo-3) bw*2.5 eh],'',2,'SearchNameEdit');
% Short Name
p=p+1;[ui{p,1:7}] = deal('Short name:','Text',colors.bc,[x(1) y(oo-2) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(oo-2) bw*2.5 eh],'',2,'SearchShortEdit');
% Code
p=p+1;[ui{p,1:7}] = deal('Reg. code:','Text',colors.bc,[x(1) y(oo-1) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(oo-1) bw eh],'',2,'SearchCodeEdit');

% REPLACE FRAME
oo=11; 
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5 y(oo) bw*4 y(1)-y(6)],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Replace:','Text',colors.bc,[x(1) y(oo-4) bw*2.5 bh],'',4,'');
% NAME
p=p+1;[ui{p,1:7}] = deal('Name:','Text',colors.bc,[x(1) y(oo-3) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(oo-3) bw*2.3 eh],'qq_lib_replace(4.1)',2,'ReplNameEdit');
p=p+1;[ui{p,1:7}] = deal('','CheckBox',colors.bc,[x(5)-bw*0.6 y(oo-3) bw*0.1 bh],'',4,'ReplNameCheck');
% Short Name
p=p+1;[ui{p,1:7}] = deal('Short name:','Text',colors.bc,[x(1) y(oo-2) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(oo-2) bw*2.3 eh],'qq_lib_replace(4.2)',2,'ReplShortEdit');
p=p+1;[ui{p,1:7}] = deal('','CheckBox',colors.bc,[x(5)-bw*0.6 y(oo-2) bw*0.1 bh],'',4,'ReplShortCheck');
% Code
p=p+1;[ui{p,1:7}] = deal('Reg. code:','Text',colors.bc,[x(1) y(oo-1) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(oo-1) bw eh],'qq_lib_replace(4.3)',2,'ReplCodeEdit');
p=p+1;[ui{p,1:7}] = deal('','CheckBox',colors.bc,[x(5)-bw*0.6 y(oo-1) bw*0.1 bh],'',4,'ReplCodeCheck');

% FRAME
oo=1; fh=10; ho=4.5*bw;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)+ho-bw/3 y(oo+fh) bw*5 y(1)-y(fh+2)],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Libraries:','Text',colors.bc,[x(1)+ho y(oo) bw*3 bh],'',4,'');
p=p+1;[ui{p,1:7}] = deal('Searchstr:','Text',colors.bc,[x(2)+ho+bw*0.6 y(oo) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(3)+ho+bw/2 y(oo) bw*2 eh],'',2,'LibStrEdit');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1)+ho y(oo+9) bw*2 gh*8.6],'',2,'AvaLibList');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(3)+ho+bw/2 y(oo+9) bw*2 gh*8.6],'',2,'ActLibList');
p=p+1;[ui{p,1:7}] = deal('Add ->','Pushbutton',colors.accept,[x(1)+ho+bw*2 y(oo+3) bw/2 bh*1],'qq_lib_replace(1.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Del <-','Pushbutton',colors.reset,[x(1)+ho+bw*2 y(oo+4) bw/2 bh*1],'qq_lib_replace(1.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('String','Pushbutton',colors.accept,[x(1)+ho+bw*2 y(oo+5) bw/2 bh*1],'qq_lib_replace(1.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.accept,[x(1)+ho+bw*2 y(oo+6) bw/2 bh*1],'qq_lib_replace(1.4)',2,'');

% Search
vp=17;
p=p+1;[ui{p,1:7}] = deal('Search','Pushbutton',colors.btn{6},[x(1) y(vp) bw bh],'qq_lib_replace(2.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Srch/Repl','Pushbutton',colors.accept,[x(2) y(vp) bw bh],'qq_lib_replace(2.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Repl. Entr.','Pushbutton',colors.accept,[x(1)+ho y(vp+1) bw bh],'qq_lib_replace(3.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Repl All','Pushbutton',colors.accept,[x(2)+ho y(vp+1) bw bh],'qq_lib_replace(3.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Skip Entr.','Pushbutton',colors.reset,[x(3)+ho y(vp+1) bw bh],'qq_lib_replace(3.9)',2,'');
p=p+1;[ui{p,1:7}] = deal('Skip Libr.','Pushbutton',colors.reset,[x(3) y(vp) bw bh],'qq_lib_replace(3.3)',2,'');

% InfoTxt
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1)+ho y(17) bw*4.5 gh*5],'',3,'InfoTxt');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(14) bw*3.5 gh*2],'',3,'LibTxt');

updfcn='';
h0=qq_drawwin(winpar,ui,updfcn); 


drawnow






