function qq_message(an,messagetxt)

global fileset fonts metset locset
persistent messagelog mess_nr n_mess

% Legger inn linje
if an==0 drawbox; end

max_n_mess=20; % Max antall i logg

% Melding
if an==1
    if exist('n_mess')~=1 | isempty(n_mess) n_mess=0; end
    n_mess=n_mess+1; if n_mess>max_n_mess; n_mess=max_n_mess; end
 
    if iscell(messagelog)==0 messagelog{1}='...'; end % Dersom frste call
    if n_mess>1 
        for x=n_mess-1:-1:1;  messagelog{x+1}=messagelog{x}; end % Flytter alle ned en
    end 
    messagelog{1}=messagetxt; % Ny melding i logg
    typemess(messagelog{1}); mess_nr=1; % Skriver melding til skjerm
end

% Blank ut
if an==2
    h=findobj('Tag','MessageTxt');
    set(h,'String',' ');
    mess_nr=0;
end
    
% Neste
if an==3 & n_mess>0
    if exist('mess_nr')~=1 | isempty(mess_nr) mess_nr=1; end
    mess_nr=mess_nr+1;
    if mess_nr==n_mess+1 mess_nr=1; end
    typemess([messagelog{mess_nr} '   (' num2str(mess_nr) ')' ])
end

% INFO
if an==4
    typemess(['|b|File: ' fileset.global_filename, ...
            '   Class: ' metset.global_class, ...
            '   Method: ' metset.file_method])
end

% INITIALIZE
if an==5
    n_mess=0; mess_nr=0; messagelog{1}='...'; messagelog=[]; 
end

if an==6
    showfile(messagetxt); % pner fil med path lik messagetext
end
    


% ----------------------------------------------------------
% ----------------------- SUBFUNCTIONS ---------------------
% ----------------------------------------------------------

function typemess(textstr)

h=findobj('Tag','MessageTxt');
set(h,'HorizontalAlignment','Center');

ind=findstr('|',textstr);
if length(ind)>=2
    codestr=textstr(ind(1)+1:ind(2)-1);
    textstr=textstr(ind(2)+1:length(textstr));
else
    codestr=[]; set(h,'ForegroundColor',[0 0 0]);
end

if findstr('g',codestr)~=0 set(h,'ForegroundColor',[0 0.5 0]); end
if findstr('r',codestr)~=0 set(h,'ForegroundColor',[1 0 0]); end
if findstr('b',codestr)~=0 set(h,'ForegroundColor',[0 0 1]); end

set(h,'String',textstr); 

% ---------------- SHOWFILE -------------
function showfile(messagetxt)
% FUNCTION MAY BE OBSOLETE (SAM 27.aug.2011)

try
    winopen(messagetxt);
catch
    qq_message(1,'|r|Could not open file');
end
    
%if strmatch(locset.editor,'notepad')
%    a=dos(['start notepad ' messagetxt]);    
%else
%    a=dos(messagetxt);
%end
%if a>0 qq_message(1,'|r|Could not open file'); end


% ---------------- TEGNER LINJE -------------
function drawbox

global fonts locset

hp=0; % Vertikal posisjon til messageline
%hp=0.025; % Vertikal posisjon til messageline

h1 = uicontrol('Parent',gcf, ...
    'ForegroundColor',[1 0 0],...
    'BackgroundColor',[1 1 1],...
    'Position',[0 hp 1 0.03], ...
	'String',' ', ...
    'FontSize',fonts(3),...
	'Style','text', ...
    'Tag','MessageTxt');
    
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',[1 1 1], ...
	'Callback','qq_message(3)', ...
	'Position',[0.025 hp 0.025 0.03], ...
	'String','>>');

h1 = uicontrol('Parent',gcf, ...
    'ForegroundColor',[0 0 1], ...
    'BackgroundColor',[1 1 1], ...
	'Callback','qq_message(4)', ...
	'Position',[0 hp 0.025 0.03], ...
	'String','i');

h1 = uicontrol('Parent',gcf, ...
    'ForegroundColor',[0 0 1], ...
    'BackgroundColor',[1 1 1], ...
	'Callback','qq_settings(1)', ...
	'Position',[1-0.06 hp 0.060 0.03], ...
	'String','Settings');

% Free modal windows
cbf='set(findobj(''Type'',''Figure''),''Visible'',''on'');set(findobj(''Type'',''Figure''),''WindowStyle'',''normal'');';
h1 = uicontrol('Parent',gcf, ...
    'ForegroundColor',[0 0 1], ...
    'BackgroundColor',[1 1 1], ...
	'Callback',cbf, ...
	'Position',[1-0.06-0.03 hp 0.030 0.03], ...
	'String','FW');

% Open explorer
%dosstr=['start explorer.exe ' locset.path_root];
%cbf=['dos(''' dosstr ''');'];
cbf=['winopen(''' locset.path_root ''');'];
h1 = uicontrol('Parent',gcf, ...
    'ForegroundColor',[0 0 1], ...
    'BackgroundColor',[1 1 1], ...
	'Callback',cbf, ...
	'Position',[1-0.09-0.03 hp 0.030 0.03], ...
	'String','Ex');

dosstr=[locset.path_root '\Notes.txt'];
cbf=['winopen(''' dosstr ''');'];
h1 = uicontrol('Parent',gcf, ...
    'ForegroundColor',[0 0 1], ...
    'BackgroundColor',[1 1 1], ...
	'Callback',cbf, ...
	'Position',[1-0.09-0.03-0.03 hp 0.030 0.03], ...
	'String','N');

