function qq_peakcall(an)

% GLOBALE OG PERSISTENTE VARIABLER %
global XR XBL fileset metset CL locset 
global lockvector stat treshold n_scans detvector %caller winsize % CHANGE TO PERSISTENT 
global CL_r fileset_r % Benyttes ved reset % CHANGE TO PERSISTENT 
global maincall % Change to persistent

if locset.tracker==1 disp(['---- qq_peakcall ---- ' num2str(an)]); end

qq_message(2)

if an==100
    if isfield(fileset,'global_currentcl')==0; fileset.global_currentcl=0; end
    qq_plot_peakchrom(0); 
    update; 
end % OPPDATER

if an==0 && isempty(XR)==0
    CallWinTag=get(gcf,'Tag'); maincall=strcmp(CallWinTag,'MainWin'); % must come before openwin
    openwin
    
    %%% -------- SETTINGS ----------
    n_scans=length(fileset.rt); detvector=zeros(1,n_scans);
   
    %---------------- HVIS CL FINNES -----------
    if isfield(fileset,'global_nuclusters') & fileset.global_nuclusters>0 
       lockvector=updlock(CL,n_scans);
       stat=3; % Status: 1) kromatogr. eksisterer, 2) treshold ekssterer, 3) detvector eksistrer;
       nupeaks=size({CL.nr});fileset.global_nuclusters=nupeaks(2); % antall topper
    else
       %disp('------- NYE DATA / RESET -------')
       lockvector=zeros(1,n_scans); CL=emptyCL;
       stat=1; % Status: 1) kromatogr. eksisterer, 2) treshold ekssterer, 3) detvector eksistrer;
       fileset.global_currentcl=0; % Current cluster = 0.
    end
    CL_r=CL; % Tar vare p CL ved input til CL-reset
    fileset_r=fileset;
   
end
if an==0 && isempty(XR)==1 qq_message(1,'|r|No data'); end


%---------------- CALL FRA QUANTWINDOW -----------
if an==0 && maincall==0 %caller=400;    
   fileset.chrom_li=CL(fileset.global_currentcl).startp;   % Index for vind
   fileset.chrom_ri=CL(fileset.global_currentcl).endp;     % Index for vindu
   range=fileset.chrom_ri-fileset.chrom_li; fileset.chrom_li=fileset.chrom_li-floor(range/2); 
   if fileset.chrom_li<1; fileset.chrom_li=1; end;
   fileset.chrom_ri=fileset.chrom_ri+floor(range/2); 
   if fileset.chrom_ri>n_scans; fileset.chrom_ri=n_scans; end
   zf=n_scans/range;                             % Zoomfaktor
   wz  = floor(n_scans/zf);                     % Window size
   cp=(CL(fileset.global_currentcl).startp+CL(fileset.global_currentcl).endp)*0.5;
end
%if an==401; qq_chrom(7.0); end
    
% --------------- Kromatogram ------------
if an==0  & isempty(XR)==0 %| an==400 | an==401  
    qq_plot_peakchrom(0); 
    an=5;
end

%----------------------------------------------------
%            C A L L F U N C T I O N S
%----------------------------------------------------

% ---------------------- SET TRESHOLD ----------------------
if an>5 & an<6
    treslock=get(findobj(gcbf,'Tag','TresholdLock'),'Value');
    if stat<1 treslock=1; end
    slide=findobj(gcbf,'Tag','TresholdSlider');  
    treshedit=findobj('Tag','TresholdEdit');
    trl=findobj('Tag','tresholdline');
end
% Calculate
if an==5.1 & treslock==0
   treshold=blfindtres(fileset.chrom_tic2(fileset.chrom_li:fileset.chrom_ri),0);                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
end
%Use slider
if an==5.2 & treslock==0
   value=get(slide,'Value'); value=value^4; treshold=value*(max(fileset.chrom_tic2)/100^4);   
end
% Use edit
if an==5.3 & treslock==0
    treshold=str2double(get(treshedit,'String'));
end
% Update
if an>5 & an<6 
    set(treshedit,'String',num2str(treshold));
    set(trl,'ydata',[treshold, treshold]);  
    value=treshold*(100^4/max(fileset.chrom_tic2)); value=value^0.25; set(slide,'Value',value); 
    if stat<2 stat=2; end  
end


% ---------------------- PEAK DETECT ------------------
if an==7 & stat<=1
    qq_message(1,'Calculate treshold!')
end

if an==7 & stat>1  
   % BEREGNER DETVECTOR
   % Finner detvector (omrde over treshold) innenfor fileset.chrom_li-fileset.chrom_ri
   detvector(fileset.chrom_li:fileset.chrom_ri)=detect(fileset.chrom_tic2(fileset.chrom_li:fileset.chrom_ri),treshold);
   % Dersom verdi for lockvector: detvector settes til 0.
    detvector= detvector > lockvector;  
   % detvector(fileset.chrom_li:fileset.chrom_ri)= detvector(fileset.chrom_li:fileset.chrom_ri) > lockvector(fileset.chrom_li:fileset.chrom_ri);  
 
   % FINNER LSTE VINDUER
   locked=cat(2,CL.locked); lockpos=find(locked);
   CLL=CL(lockpos); % Lste topper
   a=sum(cat(2,CL.locked)); % Antall lste topper

   % FINNER ULSTE VINDUER
   CLU=findpeaks(detvector); % Finner ulste topper CLU
   b=size(cat(2,CLU.nr)); b=b(2); % Antall topper i CLU
 
   % Concatenation
   %CL=[CLL CLU];  
   if length(CLL)==0
       CL=CLU;
   else
       n_cll=length(CLL); n_clu=length(CLU); fn=fieldnames(CLU); n_fields=length(fn); 
       for cluno=1:n_clu
           for fieldno=1:n_fields
               CLL(cluno+n_cll).(fn{fieldno})=CLU(cluno).(fn{fieldno});
           end
       end
       CL=CLL;     
   end
   
   
   if a+b>0
      % Sortering
      means=cat(2,CL.maxp); [s,sv]=sort(means); nv=1:a+b; CL(nv)=CL(sv); 
      arr=(1:a+b); arr=num2cell(arr); [CL(:).nr]=deal(arr{:});
   
      % REFINE
      CLO=CL; % Tar vare p CL i CL old
      c=size(cat(2,CL.nr)); c=c(2); % Antall topper i CLU
      if c>0, [CL]=refine(CL); end
      
      % Forhindrer at lste ekspanderer:
      locked=cat(2,CL.locked); 
      lockpos=find(locked);
      if isempty(lockpos)==0; 
         CL(lockpos)=CLO(lockpos); 
      end
      
      % FILTER, BREDDE VED HALVE HYDEN
      whhmin=3; % min bredde ved halve hyden
      CL=whhfilter(CL); 
      c=size({CL.nr}); fileset.global_nuclusters=c(2);
   else
      fileset.global_nuclusters=0;
   end   
  
   if stat<3, stat=3; end   
   fileset.global_currentcl=0;
   qq_plot_peakchrom(0); update
end  

% ---------------------- LOCK VISIBLE ------------------
if an==8 & stat<=2
    qq_message(1,'|r|No Peaks')
    qq_plot_peakchrom(0); update
end

if an==8 & stat>2
   % FINNER ALLE ULSTE INNEN VINDUET OG LSER
   maxp=cat(2,CL.maxp);
   locked=cat(2,CL.locked);
   a=find(fileset.chrom_li<maxp(:) & maxp(:)<fileset.chrom_ri & locked(:)==0);   % finner alle ulste med max mellom fileset.chrom_li og RI 
   if isempty(a)==0
      [CL(a).locked]=deal(1); % Lser 
      lockvector=updlock(CL,n_scans);       % Oppdaterer lockvector   
      qq_plot_peakchrom(0); update; % Oppdater vindu
   end
end

% ---------------------- LOCK ALL ------------------
if an==8.1 & stat<=2
    qq_message(1,'|r|No Peaks')
end

if an==8.1 & stat>2
   locked=cat(2,CL.locked);
   a=find(locked(:)==0);
   if isempty(a)==0
      [CL(a).locked]=deal(1); % Lser 
      lockvector=updlock(CL,n_scans);      % Oppdaterer lockvector   
      qq_plot_peakchrom(0); update
   end  
end

% ---------------------- UNLOCK VISIBLE ------------------
if an==8.2 & stat<2
    qq_message(1,'|r|No Peaks')
end

if an==8.2 & stat>2
   % FINNER ALLE LSTE INNEN VINDUET OG LSER OPP
   maxp=cat(2,CL.maxp);
   locked=cat(2,CL.locked);
   a=find(fileset.chrom_li<maxp(:) & maxp(:)<fileset.chrom_ri & locked(:)==1);   % finner alle ulste med max mellom fileset.chrom_li og RI 
   if isempty(a)==0
      [CL(a).locked]=deal(0); % Lser opp
      lockvector=updlock(CL,n_scans);      % Oppdaterer lockvector  
      qq_plot_peakchrom(0); update; % Oppdater vindu
   end
end

% ---------------------- UNLOCK ALL ------------------
if an==8.3 & stat<2
    qq_message(1,'|r|No Peaks')
end

if an==8.3 & stat>2
   locked=cat(2,CL.locked);
   a=find(locked(:)==1);
   if isempty(a)==0
      [CL(a).locked]=deal(0); % Lser opp
      lockvector=updlock(CL,n_scans); 
      qq_plot_peakchrom(0); update;
   end  
end

% ---------------------- LOCK SELECTED -------------------
if an==8.4 & stat<=2
    qq_message(1,'|r|No Peaks')
end

if an==8.4 & stat>2 & fileset.global_currentcl>0
   if CL(fileset.global_currentcl).locked==0;
      CL(fileset.global_currentcl).locked=1;
      lockvector(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp)=1;
   end
   qq_plot_peakchrom(0); update;
end

% ---------------------- UNLOCK SELECTED -------------------
if an==8.5 & stat<=2
    qq_message(1,'|r|No Peaks')
end

if an==8.5 & stat>2 & fileset.global_currentcl>0
   if CL(fileset.global_currentcl).locked==1;
      CL(fileset.global_currentcl).locked=0;
      lockvector(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp)=0;
   end
   qq_plot_peakchrom(0); update;
end

% ---------------------- EST RANK ----------------------
if an>=15 & an<16 & stat<=2
    qq_message(1,'|r|No Peaks')
end
% Update all
if an==15 & stat>2
   % Oppdaterer rank for alle ulste + lste med rank 0.
   CLO=CL; % Tar vare p CL
   npeaks=size(cat(2,CL.nr)); npeaks=npeaks(2); % Antall topper i CL
   for i1=1:npeaks
      estrank=qq_rang(XBL(CL(i1).startp:CL(i1).endp,:),0); % Finner rank-vektor
      if CL(i1).locked==0 %| CL(i1).rank==0  
         CL(i1).rank=estrank;
      end 
   end
end
% Estimate selectded
if an==15.1 & stat>2 & fileset.global_currentcl>0 
    CL(fileset.global_currentcl).rank=qq_rang(XBL(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp,:),0);
end
% rank down
if an==15.2 & stat>2 & fileset.global_currentcl>0 & CL(fileset.global_currentcl).rank>1
    CL(fileset.global_currentcl).rank= CL(fileset.global_currentcl).rank-1;
end
% rank up
if an==15.3 & stat>2 & fileset.global_currentcl>0
   CL(fileset.global_currentcl).rank= CL(fileset.global_currentcl).rank+1;
end  
% updates
if an>=15.0 && an<=15.3
   qq_plot_peakchrom(0); update;    
end

% ---------------------- SELECT PEAK -------------------
if an>=16 & an<17 & stat<=2
    qq_message(1,'|r|No Peaks')
end

% Finner topp ved hjelp av ginput
if an==16 & stat>2
   position=ginput(1);position=position(1);
   index=find(fileset.rt<position);index=max(index);
   start=cat(2,CL.startp); low=find(start<index); low=max(low); 
   if isempty(low), low=0; end
   slutt=cat(2,CL.endp); high=find(slutt>index);high=min(high); 
   if isempty(high), high=0; end
   if low==high;
      fileset.global_currentcl=low;
   else
      qq_message(1,'|r|No Peak')
      fileset.global_currentcl=0; 
   end
end

if an==16.1 & stat>2 & fileset.global_currentcl>1
   fileset.global_currentcl=fileset.global_currentcl-1;            % Selected -1
end
if an==16.2 & stat>2 & fileset.global_currentcl<fileset.global_nuclusters 
   fileset.global_currentcl=fileset.global_currentcl+1;            % Selected +1
end
if an==16.3 & stat>2 fileset.global_currentcl=get(gco,'UserData'); end

% Oppdaterer vindu
if an>15.9 & an<16.4 & fileset.global_currentcl>0
    cp=round((CL(fileset.global_currentcl).startp+CL(fileset.global_currentcl).endp)*0.5);
    range=fileset.chrom_ri-fileset.chrom_li; 
    fileset.chrom_li=floor(cp-(range/2)); fileset.chrom_ri=fileset.chrom_li+range;
    if fileset.chrom_li<1; fileset.chrom_li=1; fileset.chrom_ri=fileset.chrom_li+range; end 
    if fileset.chrom_ri>length(fileset.rt); fileset.chrom_ri=length(fileset.rt); fileset.chrom_li=fileset.chrom_ri-range; end      
    qq_plot_scale(100); 
    update;
end

% ---------------------- DELETE/SPLITT SELECTED ----------------
% MESSAGES
if an>=17 & an <18 & fileset.global_currentcl==0; qq_message(1,'|r|Nothing selected'); end

if an==17 & stat>2 & fileset.global_currentcl>0 & CL(fileset.global_currentcl).locked==1
   qq_message(1,'|r|Locked')
   if fileset.global_currentcl<fileset.global_nuclusters, fileset.global_currentcl=fileset.global_currentcl+1; an=17.9; end 
   % (setter an til 17.9 for  unng sletting av neste topp)
end

% DELETE
if an==17 & stat>2 & fileset.global_currentcl>0 & fileset.global_currentcl<=fileset.global_nuclusters & CL(fileset.global_currentcl).locked==0
   %lockvector(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp)=0; % Lser opp
   detvector(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp)=0; % frigir
   CL(fileset.global_currentcl)=[]; fileset.global_nuclusters=fileset.global_nuclusters-1;
   if fileset.global_currentcl>fileset.global_nuclusters, fileset.global_currentcl=0; end   
   % Retter clusternumre
   if fileset.global_nuclusters>1, arr=(1:fileset.global_nuclusters); arr=num2cell(arr); [CL(:).nr]=deal(arr{:}); end 
   if fileset.global_nuclusters==1, [CL(1).nr]=1; end
end

% SPLITT
if an==17.1 & stat>2 & fileset.global_currentcl>0
    lockvector(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp)=0; % Lser opp
    loctic=fileset.chrom_tic2(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp); % Lokal TIC
    [valleyx, valleyy] = valley(loctic,1);
    splitp=valleyx+CL(fileset.global_currentcl).startp-1;
    splitupd=1;
end

% ---------------------- MANUAL SPLIT ------------------------
if an==17.2
    [xp,yp]=ginput(1);lower=find(fileset.rt<xp); splitp=max(lower);
    selclu=[];
    for x=1:length(CL) if CL(x).startp<splitp & CL(x).endp>splitp selclu=x; end; end
    if isempty(selclu) 
        qq_message(1,'|r|Outside peak region'); splitupd=0;
    else
        splitupd=1; fileset.global_currentcl=selclu;        
    end   
end

if (an==17.1|an==17.2) & splitupd==1;
    % Oppdaterer CL
    CLN=emptyCL; 
    CLN(1).startp=CL(fileset.global_currentcl).startp; CLN(1).endp=splitp; % Nye topper, frste
    CLN(2).startp=splitp; CLN(2).endp=CL(fileset.global_currentcl).endp;   % Nye topper, siste
    for i1=1:2
        maximum(i1)=max(fileset.chrom_tic2(CLN(i1).startp:CLN(i1).endp));
        maxp(i1)=find(maximum(i1)==fileset.chrom_tic2(CLN(i1).startp:CLN(i1).endp)); maxp(i1)=min(maxp(i1));
        CLN(i1).maxp=maxp(i1)+CLN(i1).startp;
        CLN(i1).locked=0; CLN(i1).rank=0; CLN(i1).quantified=0; CLN(i1).inresults=0;
    end
    CLN=whhfilter(CLN); [d,n_cln]=size({CLN.nr}); % n_cln: antall topper i CLN etter whhfilter
    CL(fileset.global_currentcl)=[];
    fileset.global_nuclusters=fileset.global_nuclusters-1;
    lecl=length(CL); fn=fieldnames(CLN);
    for p=1:n_cln
        for x=1:length(fn)
            CL(lecl+p).(fn{x})=CLN(p).(fn{x});
        end
    end
    fileset.global_nuclusters=fileset.global_nuclusters+n_cln;

    % Sortering
    means=cat(2,CL.maxp); [s,sv]=sort(means); nv=1:fileset.global_nuclusters; 
    CL(nv)=CL(sv); arr=(1:fileset.global_nuclusters); arr=num2cell(arr); 
    [CL(:).nr]=deal(arr{:});
    % oppdaterer fileset.global_currentcl til strste topp
    % if maximum(2)>maximum(1), fileset.global_currentcl=fileset.global_currentcl+1; end
end

if an==17.3
    moveborder
    lockvector(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp)=0;
end

if an>=17 & an <18 qq_plot_peakchrom(0); update; end



% ---------------------- QUANTIFY SELCTED -----------------------
if an==20.4
    qq_quantcall2(0)
end

% ------------------- KEYPRESS ------------------- 
if an==96
    kp=double(get(gcf,'CurrentCharacter'));
    if kp==28 | kp==29 qq_plot_scale(1.35); end %   
    if kp==30 qq_peakcall(16.2); end
    if kp==31 qq_peakcall(16.1); end
end

% ---------------------- ACCEPT -----------------------
if an==97 & stat>2                                                        
   fileset.chrom_li=1;fileset.chrom_ri=n_scans;                                                  
   
   [d,fileset.global_nuclusters]=size({CL.nr}); 
   for i1=1:fileset.global_nuclusters, CL(i1).locked=1; end
   lockvector=updlock(CL,n_scans);
   fileset.peak_lockvector=lockvector;
   % beregn cluvector
   fileset.cluvector=zeros(1,length(fileset.rt));
   for i1=1:fileset.global_nuclusters
      fileset.cluvector(CL(i1).startp:CL(i1).endp)=CL(i1).nr;
   end
   
   % Overlapfilter
   CL=overlapfilter(CL);
   
   if maincall; % Return to mainwin
       fileset.global_currentcl=0; qq_closewin;  %qq_maincall(300);  
   end
   
   if maincall==0 % Return to quantwin
       qq_closewin; %qq_quantcall(301);
   end
end 

% ---------------------- RESET ------------------------
if an==98 & stat>0   
   a=size({CL_r.nr}); a=a(2);
   if a>0
      CL=CL_r;
      stat=3;
      npeaks=size({CL.nr});npeaks=npeaks(2);
      lockvector=updlock(CL,n_scans);
      fileset.peak_lockvector=lockvector;
   else
      CL=emptyCL; 
      CL_r=CL;
      lockvector=zeros(1,n_scans);  % Evt hent lockvector fra et annet sted hvis omrder er lst
      stat=1;
   end
   fileset.chrom_li=1;fileset.chrom_ri=n_scans;                                                  
   detvector=zeros(1,n_scans); 
   %plotupd=1; 
   qq_plot_peakchrom(0); update; 
end 

% ---------------------- CLOSE ------------------------
if an==99  
   %------ RESETTER DATA -------
   a=size({CL_r.nr}); a=a(2);
   if a>0
      CL=CL_r; stat=3; npeaks=size({CL.nr});npeaks=npeaks(2);
      lockvector=updlock(CL,n_scans);
      fileset.peak_lockvector=lockvector;
   else
      CL=emptyCL; CL_r=CL; stat=1;
      lockvector=zeros(1,n_scans);  % Evt hent lockvector fra et annet sted hvis omrder er lst
   end
   
   if maincall;
       % -------- LUKKER ---------
       [d,fileset.global_nuclusters]=size({CL.nr}); 
       fileset.global_currentcl=0;
       qq_closewin; %qq_maincall(301);
   end
   if maincall==0 % Hvis call fra quantcall
       [d,fileset.global_nuclusters]=size({CL.nr}); 
       qq_closewin, %qq_quantcall(301);
   end
end

% ---------------------- CALL FRA BATCHCALL -----------------------
if an==101
    %disp('----- PEAKCALL: CALL FRA BATCHCALL -----')
    CL=findpeaks(detvector);
    [CL,detvector] = refine(CL);
    fileset.global_nuclusters=length(CL);
    
    fileset.peak_lockvector=updlock(CL,length(fileset.rt));
   
    fileset.cluvector=zeros(1,length(fileset.rt));
    for i1=1:fileset.global_nuclusters
       fileset.cluvector(CL(i1).startp:CL(i1).endp)=CL(i1).nr;
    end
    CL=overlapfilter(CL);
    fileset.global_currentcl=0;   
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                      %
%                        SUBFUNCTIONS                  %
%                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------- MOVEBORDER --------
function moveborder
global fileset CL

nclusters=length(CL);
[xp,yp]=ginput(1);

selpos=max(find(fileset.chrom_plotlab<xp));

if selpos<CL(fileset.global_currentcl).maxp
    if fileset.global_currentcl>1
        lowlim=CL(fileset.global_currentcl-1).endp+1;
    else
        lowlim=1;
    end
    highlim=CL(fileset.global_currentcl).maxp-1;
    if selpos>highlim selpos=highlim; end
    if selpos<lowlim selpos=lowlim; end
    CL(fileset.global_currentcl).startp=selpos;
end

if selpos>CL(fileset.global_currentcl).maxp
    if fileset.global_currentcl<nclusters
        highlim=CL(fileset.global_currentcl+1).startp-1;
    else
        highlim=length(fileset.chrom_plotlab);
    end
    lowlim=CL(fileset.global_currentcl).maxp+1;
    if selpos>highlim selpos=highlim; end
    if selpos<lowlim selpos=lowlim; end
    CL(fileset.global_currentcl).endp=selpos;
end

CL(fileset.global_currentcl).locked=0; % unlocks peak
filesetpeak_lockvector(lowlim:highlim)=0; % Unlocks entire area
fileset.cluvector(lowlim:highlim)=0; % Zeroes entire area
fileset.cluvector(CL(fileset.global_currentcl).startp:CL(fileset.global_currentcl).endp)=1; % Adds peak to cluvector


%%% -------- SUBFUNCTION BLFINDTRES ---------
function treshold=blfindtres(TIC,trpl)
% Bestemmer treshold til gjennomsnittet+20*stdav til de 10 laveste % av TIC
% Plotter hvis trpl=1

%disp('--- BLFINDTRES ---')

dim=size(TIC);dim=dim(2);
sTIC=sort(TIC);
zcount=round(dim/10);
sTIC=sTIC(1:zcount);
treshold=mean(sTIC)+10*std(sTIC);  

if trpl==1
   %subplot(2,1,1) 
   subplot('position',[0 0.5 1 0.5]);
   plot(TIC); 
   line([0 dim], [treshold treshold],'color','r')
end


%%% -------- SUBFUNCTION detect ---------
function [detvector]=detect(TIC,treshold)
% Returnerer binr vektor med verdi 0 hvis under treshold
% og 1 hvis over treshold

detvector=TIC>treshold;

%Setter siste til 0 (unngr at topp starter p siste scan)
detvector(length(detvector))=0;
%dim=size(detvector);dim=dim(2); detvector(dim)=0;


% ----------- SUBFUNCTION findpeaks ------------

function CLU=findpeaks(detvector)
% function CLU=findpeaks(detvector,wtic)
% PV=[(1:npeaks)' peakstart' peakmax' peakslutt'];

global fileset

npeaks=0;
if any(detvector)  % Dersom detvector inneholder annet enn 0.
   
   %disp('------------- TOPP DETEKTERT ------------')
   dim=length(detvector);

   % FINNER BL START, SLUTT OG ANTALL BL
   difdet=diff(detvector);
   difddet=[0 difdet];

   % "lukking" av baselinevinduer
   % Sjekk om frste slutt er lavere enn frste start og om siste start er
   % hyere enn siste slutt
   start_p=find(difdet==1);
   slutt_p=find(difdet==-1);
   if length(start_p)~=length(slutt_p)
       % Fjerner frste slutt
       if slutt_p(1)<start_p(1) slutt_p(1)=[]; end 
       % Fjerner siste start
       if start_p(length(start_p))>slutt_p(length(slutt_p)) start_p(length(start_p))=[]; end
   end
   
   % Finner vektorer for peakstart og peakslutt
   PV(:,2)=start_p';  % Start PV(:,2)
   PV(:,4)=slutt_p'; % Slutt PV(:,4)
   npeaks=size(PV);npeaks=npeaks(1);

   % Kalkuler max
   for i1=1:npeaks
      maxval=max(fileset.chrom_tic2(PV(i1,2):PV(i1,4)));
      maxp=find(fileset.chrom_tic2(PV(i1,2):PV(i1,4))==maxval); 
      PV(i1,3)=maxp(1)+PV(i1,2)-1; 
   end

   % TailFilter, Fjerner tails (topper der start eller slutt = max) 
   ai=find(PV(:,3)==PV(:,2) | PV(:,3)==PV(:,4));
   %if ai, disp('-------- Tail filter -------'), end
   PV(ai,:)=[];
   npeaks=size(PV);npeaks=npeaks(1);   % Retter npeaks etter tailfilter

   % Legger til toppnr.
   PV(:,1)=(1:npeaks)';
   PV(:,6)=zeros(1,npeaks)';
end % if detvector
  
if npeaks>0; % Dersom topper
   %disp('------ TOPP FINNES -------')
   CLU=emptyCL;
   CLU(npeaks).nr=PV(npeaks,1); % Definerer CL
   % Fyller ut verdier
   arr=PV(:,1); arr=num2cell(arr); [CLU(:).nr]    =deal(arr{:});
   arr=PV(:,2); arr=num2cell(arr); [CLU(:).startp]=deal(arr{:});
   arr=PV(:,3); arr=num2cell(arr); [CLU(:).maxp]  =deal(arr{:});
   arr=PV(:,4); arr=num2cell(arr); [CLU(:).endp]  =deal(arr{:});
   arr=PV(:,5); arr=num2cell(arr); [CLU(:).locked]=deal(arr{:});
   arr=PV(:,6); arr=num2cell(arr); [CLU(:).rank]  =deal(arr{:});  
   % arr=PV(:,6); arr=num2cell(arr); 
   [CLU(:).whh] =deal([]);  
   [CLU(:).quantified] = deal(0);  
   [CLU(:).inresults]= deal(0);
   [CLU(:).areas] = deal([]); 
   [CLU(:).C_vol] = deal([]);
   [CLU(:).C_int] = deal([]);
   [CLU(:).blpos] = deal([]);

   
else  % hvis ikke noen detektert

   %disp('------- INGEN TOPP --------')
   CLU=emptyCL;
end


% ----------- SUBFUNCTION refine ------------
function [CL,detvector] = refine(CL)
global metset fileset 
metset.dummy=0;

npeaks=size({CL.nr});npeaks=npeaks(2);
dim=size(fileset.chrom_tic2);dim=dim(2);

% Finner min mellom start og frste topp
minval=min(fileset.chrom_tic2(1:CL(1).startp));
minp=find(fileset.chrom_tic2(1:CL(1).startp) == minval); minpos(1)=minp(1);
% Finner min mellom topper
for i1=1:npeaks-1
   minval=min(fileset.chrom_tic2(CL(i1).endp:CL(i1+1).startp));
   minp=find(fileset.chrom_tic2(CL(i1).endp:CL(i1+1).startp) == minval);  
   minpos(i1+1)=minp(1);
   minpos(i1+1)=minpos(i1+1)+CL(i1).endp-1;
end
% Finner min mellom siste topp slutt
minval=min(fileset.chrom_tic2(CL(npeaks).endp:dim));
minp=find(fileset.chrom_tic2(CL(npeaks).endp:dim) == minval); 
minpos(npeaks+1)=minp(1); %                                                   
minpos(npeaks+1)=minpos(npeaks+1)+CL(npeaks).endp-1;

% Ekspanderer topper til min mellom toppene, finner max
for i1=1:npeaks
   CL(i1).startp=minpos(i1);
   CL(i1).endp=minpos(i1+1); 
end

% Kontraherer topper til minnima
% Settings for base

if isfield(metset,'peak_leftbase'), ltres=metset.peak_leftbase; 
else, ltres=1; end 
if isfield(metset,'peak_rightbase'), rtres=metset.peak_rightbase; 
else, rtres=1; end
for i1=1:npeaks
   % Beregner treshold relativt til toppens max
   leftmin=fileset.chrom_tic2(CL(i1).maxp)*ltres/100; % treshold tv % av peakmax
   rightmin=fileset.chrom_tic2(CL(i1).maxp)*rtres/100; % treshold th % av peakmax  
   % kontraherer tv
   leftminpos=find(fileset.chrom_tic2(CL(i1).startp:CL(i1).maxp) <= leftmin);
   if isempty(leftminpos) == 0
      CL(i1).startp=max(leftminpos)+CL(i1).startp-1;
   end
   % kontraherer th
   rightminpos=find(fileset.chrom_tic2(CL(i1).maxp:CL(i1).endp) <= rightmin); 
   if isempty(rightminpos) == 0
      CL(i1).endp=min(rightminpos)+CL(i1).maxp-1;
   end   
end

% Legger p nummerering 
arr=num2cell(1:npeaks); [CL(:).nr]=deal(arr{:});

% Kalkulerer ny detvector
detvector=zeros(1,dim);
for i1=1:npeaks
   detvector(CL(i1).startp:CL(i1).endp)=1;
end


% ----------- SUBFUNCTIONS whhfilter ------------

function CL=whhfilter(CL)
global metset fileset

if isfield(metset,'peak_minwhh')
    whhtres=metset.peak_minwhh;
else
    whhtres=2;
end

% Beregner whh og sletter topper under whh-treshold.

npeaks=size({CL.nr});npeaks=npeaks(2); % Oppdaterer n-peaks
% Beregner bredde ved halve hyden og sletter topper under treshold
for i1=1:npeaks
   hh=fileset.chrom_tic2(CL(i1).maxp)*0.5; % halve hyden
   over=find(fileset.chrom_tic2(CL(i1).startp:CL(i1).endp) >= hh);
   CL(i1).whh=max(over)-min(over)+1;
   if isempty(CL(i1).whh) CL(i1).whh=1; end
end
whh=cat(2,CL.whh); delete=find(whh<whhtres); CL(delete)=[]; %  Sletter

% Oppdaterer topp-numre
c=size({CL.nr});nupeaks=c(2);
arr=(1:nupeaks); 
arr=num2cell(arr); 
[CL(:).nr]=deal(arr{:});

% ------------------- VALLEY -------------------

function [valleyx, valleyy] = valley(tic,nmin);

%function [valleyx, valleyy] = valley(tic,nmin);
%
% Bestemmer nmin valleys i et kromatogram
% Returnerer x-posisjoner (valleyx) og y-verdier (valleyy) til alle valleys
% tic er en rekkevektor som inneholder kromatogrammet
% Fungerer ved  bestemme nmin+1 lokale maksima og finner s min-verdiene mellom disse
% Er det flere enn nmin+1 maxima smoothes kromatogrammet, dette gjentas til korrekt antall.
% Smoothingvinduet kes for hver iterasjon med 'ffaktor' * antall iterasjoner. 
% Bestemmes feil minima kan det vre en ide  redusere ffaktor.

ffaktor=0.5;
nmax=nmin+1;
dim=size(tic);dim=dim(2);
oldtic=tic;

konvergens=0; niter=0; fdim=1;
while konvergens<1

   dtic=diff(tic);    % Frstederiverte

   fortegn=sign(dtic);% Konverterer til fortegnsvektor

   d=0;e=0; fdim=2;
   clear lokmin lokminy lokmax lokmaxy
   for i=1:dim-2
      if fortegn(i+1)<fortegn(i)   % Hvis fortegn skifter negativt (da er man p peakmax)
         d=d+1;
         lokmax(d)=i+1;
         lokmaxy(d)=oldtic(i+1);
      end
   end
   
   e=e+niter*ffaktor;
   fdim=fdim+floor(e);   % ker dimensjonen p filteret for hver iterasjon
   tic=smooth(tic,fdim); % Smoothing
   
   % Konvergenstest
   if d < nmax+1
      konvergens=1;
   end
   
   % Max 200 iterasjoner
   niter=niter+1;
   if niter ==200
      konvergens=2;
   end
   
end % while

z=size(lokmax);z=z(2);
if z<nmax
   lokmax(nmax)=dim;
   lokmaxy(nmax)=oldtic(dim);
end

for i=1:nmax-1
   valleyy(i)=min(oldtic(lokmax(i):lokmax(i+1)));
   mp=find(oldtic==valleyy(i)); mp=mp(1);
   valleyx(i)=mp;
end

% ------------------- OVERLAPFILTER -------------------
function CL=overlapfilter(CL)

% Fjerner overlap mellom 'adjoining' peaks

[m,n]=size(CL);
if n>1
    for x=1:n-1
        if CL(x).endp>=CL(x+1).startp CL(x+1).startp=CL(x+1).startp+1; end
    end
end



% ------------------- SMOOTH -------------------
function nytic=smooth(tic,fdim)
% fdim er dimensjon p filter

% Smoothing
b=ones(1,fdim)*1/fdim;     % Vektor med filter, fdim siste pkt er vektet likt.
ticflip=(fliplr(tic));
smooth1=filter(b,1,ticflip);
smooth1=fliplr(smooth1);
smooth2=filter(b,1,tic);
nytic=(smooth1/2)+(smooth2/2);


% ----------- DIVERSE SMFUNKSJONER ------------
function PV=dump(CL)

npeaks=size({CL.nr});npeaks=npeaks(2); % Oppdaterer n-peaks

if npeaks>0
   PV(:,1)=cat(1,CL.nr);
   PV(:,2)=cat(1,CL.startp);
   PV(:,3)=cat(1,CL.maxp);
   PV(:,4)=cat(1,CL.endp);
   PV(:,5)=cat(1,CL.locked);
   PV(:,6)=cat(1,CL.rank);
   %PV(:,7)=cat(1,CL.whh);
end

function CL=emptyCL
CL=struct('nr',[],...
   'startp',[],...
   'maxp',[],...
   'endp',[],...
   'locked',[],...
   'rank',[],...
   'whh',[],...
   'quantified',[],...
   'inresults',[],...
   'n_analytes',[],...
   'areas',[],...
   'C',[],...
   'S',[],... 
   'C_vol',[],...
   'C_int',[],...
   'blpos',[]);

CL(1)=[];

function lockvector=updlock(CL,n_scans)
% Oppdaterer lockvector
locked=cat(2,CL.locked); a=find(locked);
CLL=CL(a);
npeaks=size({CLL.nr});npeaks=npeaks(2);
lockvector=zeros(1,n_scans);
for i1=1:npeaks 
   lockvector(CLL(i1).startp:CLL(i1).endp)=1; 
end


% -------------- UPDATE CHROMATOGRAM ------------
function update
global fileset CL

tag=['PeakRect' num2str(fileset.global_currentcl)];
h=findobj('Tag','PeakRect');
hh=findobj(h,'UserData',fileset.global_currentcl);
set(h,'LineWidth',1,'EdgeColor',[0 0 0]); set(hh,'LineWidth',3,'EdgeColor','r');
if isfield(fileset,'global_currentcl')
    h=findobj('Tag','PnTxt'); set(h,'String',num2str(fileset.global_currentcl));
end
% updates rank
str=''; 
if fileset.global_currentcl>0 && isempty(CL(fileset.global_currentcl).rank)==0 && CL(fileset.global_currentcl).rank>0 
    str=num2str(CL(fileset.global_currentcl).rank); 
end
set(findobj('Tag','RankTxt'),'String',str)


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height
o=0.45; 

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='PeakWin'; winpar{2}='Q: Peaks';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% RESTET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Reset','Pushbutton',colors.reset,[x(2) y(20) bw bh*1.5],'qq_peakcall(98)',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_peakcall(99)',3,'');
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(3) y(20) bw bh*1.5],'qq_peakcall(97)',3,'');
% FRAME
p=p+1;[ui{p,1:7}] = deal('','frame',colors.bc,[x(5)+o-bw/10 y(19)-bh/5 bw*4+bw/10 bh*8+bh/10],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Selected Peaks','text',colors.bc,[x(5)+o y(14) bw*3 bh],'',3,'');
% SMOOTH
%p=p+1;[ui{p,1:7}] = deal('Smooth','Pushbutton',colors.bc,[x(8)+o y(13) bw bh],'qq_peakcall(2.4)',2,'');
% TRESHOLD
p=p+1;[ui{p,1:7}] = deal('Calc.Tresh.','Pushbutton',colors.btn{3},[x(1) y(13) bw bh],'qq_peakcall(5.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('','Slider',colors.btn{3},[x(2) y(13) bw*2 bh],'qq_peakcall(5.2)',2,'TresholdSlider');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(4) y(13) bw/2 bh],'qq_peakcall(5.3)',2,'TresholdEdit');
p=p+1;[ui{p,1:7}] = deal('Lock','CheckBox',colors.bc,[x(4)+bw*0.6 y(13) bw/2 bh],'',2,'TresholdLock');
% DETECT
p=p+1;[ui{p,1:7}] = deal('Detect Peaks','Pushbutton',colors.btn{1},[x(1) y(14) bw bh],'qq_peakcall(7)',2,'');
% LOCK
p=p+1;[ui{p,1:7}] = deal('Lock All','Pushbutton',colors.btn{7},[x(1) y(15) bw bh],'qq_peakcall(8.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Unlock All','Pushbutton',colors.btn{7},[x(2) y(15) bw bh],'qq_peakcall(8.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Lock Visible','Pushbutton',colors.btn{7},[x(3) y(15) bw bh],'qq_peakcall(8)',2,'');
p=p+1;[ui{p,1:7}] = deal('Unlock Vis.','Pushbutton',colors.btn{7},[x(4) y(15) bw bh],'qq_peakcall(8.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Lock Selct.','Pushbutton',colors.btn{7},[x(5)+o y(15) bw bh],'qq_peakcall(8.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('Unlock Selct.','Pushbutton',colors.btn{7},[x(6)+o y(15) bw bh],'qq_peakcall(8.5)',2,'');
% RANK
p=p+1;[ui{p,1:7}] = deal('Est. Rank','Pushbutton',colors.btn{6},[x(1) y(16) bw bh],'qq_peakcall(15)',2,'');
p=p+1;[ui{p,1:7}] = deal('Rank','Pushbutton',colors.btn{6},[x(5)+o y(16) bw bh],'qq_peakcall(15.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.btn{6},[x(6)+o y(16) bw/3 bh],'qq_peakcall(15.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.btn{6},[x(6)+o+bw*2/3 y(16) bw/3 bh],'qq_peakcall(15.3)',4,'');
p=p+1;[ui{p,1:7}] = deal(' ','text',colors.btn{6},[x(6)+o+bw*1/3 y(16) bw/3 bh],'',3,'RankTxt');
% DELETE/SPLITT
p=p+1;[ui{p,1:7}] = deal('Delete Selct','Pushbutton',colors.reset,[x(5)+o y(17) bw bh],'qq_peakcall(17)',2,'');
p=p+1;[ui{p,1:7}] = deal('Splitt Selct','Pushbutton',colors.reset,[x(6)+o y(17) bw bh],'qq_peakcall(17.1)',2,'');
% SELECT PEAK
p=p+1;[ui{p,1:7}] = deal('Select Peak','Pushbutton',colors.bc,[x(5)+o y(19) bw bh*1.5],'qq_peakcall(16)',2,'');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.bc,[x(6)+o y(19) bw/3 bh*1.5],'qq_peakcall(16.1)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.bc,[x(6)+o+bw*2/3 y(19) bw/3 bh*1.5],'qq_peakcall(16.2)',4,'');
p=p+1;[ui{p,1:7}] = deal(' ','text',colors.bc,[x(6)+o+bw/3 y(19) bw/3 bh*1.2],'',3,'PnTxt');
% QUANT SELECTED
p=p+1;[ui{p,1:7}] = deal('Quantify','Pushbutton',colors.btn{5},[x(7)+bw/4+o y(19) bw*0.75 bh],'qq_peakcall(20.4)',2,'');

updfcn='qq_peakcall(100)';
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_peakcall(96)')

h=findobj('Tag','TresholdSlider'); set(h,'Value',15,'Max',100,'TooltipString','Adjust Treshold');
h=findobj('Tag','WindowSlider'); set(h,'Value',50,'Max',100,'SliderStep',[0.02 0.20]);
h=findobj('Tag','PnTxt'); set(h,'HorizontalAlignment','center');
h=findobj('Tag','RankTxt'); set(h,'HorizontalAlignment','center');  
























