function qq_plot_ionchrom(an)

% function qq_plot_mainchrom(an)
% Plots TIC in mainwindow
% an==0: Autoselect plot (depends on available data)
% an==1; TIC of X and XR
% an==2...

% SJEKK FOR PLOTSCALE
h=findobj(gcf,'Tag','Plotcontrol'); if isempty(h) qq_plot_scale; end

if nargin<1 an=0; end

if an==0 an=1; end % TEMP

if an==1 plottic; end


% -------------- SUBFUNCTION PLOTTIC -------------------
function plottic

%disp('--- qq_chrom / plottic ---')

global XR XBL fileset metset

%switch metset.global_plotscale
%    case 1; fileset.chrom_plotlab=fileset.rt;
%    case 2; fileset.chrom_plotlab=fileset.results_rivect;
%    case 3; fileset.chrom_plotlab=1:length(fileset.rt)
%end

if isfield(fileset,'chrom_plotlab')==0 fileset.chrom_plotlab=fileset.rt; end

fileset.chrom_tic5=max(XBL,[],2);
fileset.chrom_tic6=min(XBL,[],2);

%subplot('position',[0 0.5 1 0.5])
subplot('position',positions.largeplot)
plot(fileset.chrom_plotlab, XBL,'-','linewidt',0.5)
%scale; yscale
set(gca,'Tag','Mainchrom','UserData','Ion Chromatogram')
qq_copyfigure
% Set slider
%sp=fileset.chrom_cent/length(fileset.rt); sh=findobj(gcf,'Tag','Plotslider'); set(sh,'Value',sp*100);
