function qq_retindex_edit(an)

global metset fileset locset
global olddata % change to persistent

qq_message(2)

if an==1 && isfield(metset,'results_ridata')
    openwin; olddata=metset.results_ridata;
    if metset.results_currentcalibr>0
        entries; plotupd; 
    else
        qq_message(1,'|r|Calibration not selected')
    end
    filesupd;
end
if an==1 && ~isfield(metset,'results_ridata')
    qq_message(1,'|r|No calibration to edit')
end
 
% ADD
if an==2.1
   calmat=metset.results_ridata{metset.results_currentcalibr,1};
   [m,n]=size(calmat); calmat(:,n+1)=0;
   metset.results_ridata{metset.results_currentcalibr,1}=calmat;
end
% DELETE
if an==2.2
    calmat=metset.results_ridata{metset.results_currentcalibr,1};
    entry=get(gcbo,'UserData'); calmat(:,entry)=[]; 
    metset.results_ridata{metset.results_currentcalibr,1}=calmat;
end
if an>2.0 & an <3.0
    entries; plotupd
end

% MEMORY FILES
if an>3 & an<4
    n_files=length(metset.results_ridata);
    MemList=findobj('Tag','MemFilesList');
    metset.results_currentcalibr=get(MemList,'Value');
end
% SELECT FILE
if an==3.1
    memfiles=metset.results_ridata(:,2); currentname=memfiles{metset.results_currentcalibr};
    entries; plotupd; filesupd;
end
% Duplicate
if an==3.2
    metset.results_ridata{n_files+1,1}=metset.results_ridata{metset.results_currentcalibr,1};
    metset.results_ridata{n_files+1,2}=metset.results_ridata{metset.results_currentcalibr,2};
    metset.results_ridata{n_files+1,3}=metset.results_ridata{metset.results_currentcalibr,3};    
    metset.results_ridata{n_files+1,4}=metset.results_ridata{metset.results_currentcalibr,4};     
    filesupd
end
% DELETE
if an==3.3
    metset.results_ridata(metset.results_currentcalibr,:)=[];
    if metset.results_currentcalibr>n_files-1 
        metset.results_currentcalibr=metset.results_currentcalibr-1; 
    end
    filesupd; entries; plotupd;
end

% RENAME
if an==4.1
    CurrentEdit=findobj('Tag','CurrentEdit');
    fname=get(CurrentEdit,'String');
    metset.results_ridata{metset.results_currentcalibr,2}=fname;
    filesupd
end
    
% EDIT
if an>5 & an<6 calmat=metset.results_ridata{metset.results_currentcalibr,1}; end
% Edit Rt
if an==5.1 entry=get(gcbo,'UserData'); val=str2double(get(gcbo,'String')); calmat(1,entry)=val; end
% Edit Ri
if an==5.2 entry=get(gcbo,'UserData'); val=str2double(get(gcbo,'String')); calmat(2,entry)=val; end
% Update
if an>5 & an<6 metset.results_ridata{metset.results_currentcalibr,1}=calmat; plotupd; entries; end
    
% SEARCH CRITERIA
if an==6.1
    NScansEdit=findobj('Tag','NScansEdit'); 
    metset.results_ridata{metset.results_currentcalibr,3}=str2double(get(NScansEdit,'String'));
end
if an==6.2
    EndTimeEdit=findobj('Tag','EndTimeEdit'); 
    metset.results_ridata{metset.results_currentcalibr,4}=str2double(get(EndTimeEdit,'String'));
end

% ACCEPT/CLOSE
if an==99
    %TAG=get(gco,'Tag');
    if strmatch('AcceptBtn',get(gco,'Tag'))
        %disp('---- accept ----')
        if metset.results_currentcalibr>1 % Sorts
            ridata=metset.results_ridata{metset.results_currentcalibr,1};
            [dummy,ind]=sort(ridata(1,:)); 
            metset.results_ridata{metset.results_currentcalibr,1}=ridata(:,ind);
        end
    else
        %disp('---- close ----')
        metset.results_ridata=olddata;
    end
    qq_closewin
end


%======================================== SUBFUNCTIONS ========================================
% ------------------- filesupd ---------------------
function filesupd

global metset

MemList=findobj('Tag','MemFilesList');
DiskList=findobj('Tag','DiskFilesList');

memfiles=metset.results_ridata(:,2);
set(MemList,'String',memfiles)

if metset.results_currentcalibr>0
    set(MemList,'Value',metset.results_currentcalibr)
    currentname=memfiles{metset.results_currentcalibr};
    CurrentEdit=findobj('Tag','CurrentEdit'); 
    set(CurrentEdit,'String',currentname);

    % NScansEdit % EndTimeEdit
    NScansEdit=findobj('Tag','NScansEdit');
    EndTimeEdit=findobj('Tag','EndTimeEdit');
    set(NScansEdit,'String',num2str(metset.results_ridata{metset.results_currentcalibr,3}))
    set(EndTimeEdit,'String',num2str(metset.results_ridata{metset.results_currentcalibr,4}))
end

% ------------------- plotupd ---------------------
function plotupd
global fileset metset labels ions positions

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

plotpos=[x(6) y(19) x(10)-x(6) y(12)-y(19)];

calmat=metset.results_ridata{metset.results_currentcalibr,1};
hold off
subplot('position',plotpos); plot(0);
hold on
if isempty(calmat)==0
    plot(calmat(1,:),calmat(2,:),'or')
end
if isfield(fileset,'results_rivect')
    a=length(labels); b=length(fileset.results_rivect); vl=min(a,b);
    plot(labels(1:vl),fileset.results_rivect(1:vl));
end

% ------------------- entries ---------------------
function entries
global positions colors metset

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh*0.7;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 


%metset.results_ridata % TEMP
%metset.results_currentcalibr

ridata=metset.results_ridata{metset.results_currentcalibr,1};
n_ri=length(ridata);

h=findobj('Tag','TextEdit'); delete(h)
h=findobj('Tag','VarEdit'); delete(h)
h=findobj('Tag','TypePop'); delete(h)
h=findobj('Tag','DelButton'); delete(h)
h=findobj('Tag','AddButton'); delete(h)
h=findobj('Tag','EntNum'); delete(h)

    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.bc, ...
	    'Position',[[x(1) y(1) bw*0.45 bh]], ...
        'Style','Text',...
        'HorizontalAlignment','left',...
	    'String','Ret. time');
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.bc, ...
	    'Position',[[x(1)+bw*0.6 y(1) bw*0.45 bh]], ...
        'Style','Text',...
        'HorizontalAlignment','left',...
	    'String','Index');
if n_ri>22
    ho=bw*2.2;
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.bc, ...
	    'Position',[[x(1)+ho y(1) bw*0.45 bh]], ...
        'Style','Text',...
        'HorizontalAlignment','left',...
	    'String','Ret. time');
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.bc, ...
	    'Position',[[x(1)+bw*0.6+ho y(1) bw*0.45 bh]], ...
        'Style','Text',...
        'HorizontalAlignment','left',...
	    'String','Index');
end
    

pos=0.94; ho=0;
for p=1:n_ri
    if p==26 pos=0.94; ho=bw*2.2; end
    pos=pos-gh;    
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.bc, ...
	    'Position',[x(1)-bw/5+ho pos bw/2 eh], ...
        'Style','Text',...
        'HorizontalAlignment','left',...
	    'Tag','EntNum',...
        'String',num2str(p));
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
	    'Position',[x(1)+ho pos bw*0.55 eh], ...
        'Style','Edit',...
        'HorizontalAlignment','right',...
	    'String',num2str(ridata(1,p)),...
        'UserData',p,...
        'CallBack','qq_retindex_edit(5.1)',...
        'Tag','TextEdit');
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
	    'Position',[x(1)+bw*0.6+ho pos bw*0.55 eh], ...
        'HorizontalAlignment','right',...
        'Style','Edit',...
        'UserData',p,...
        'CallBack','qq_retindex_edit(5.2)',...
        'Tag','VarEdit',...
	    'String',num2str(ridata(2,p)));
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',colors.reset, ...
	    'Position',[x(1)+bw*1.2+ho pos bw*0.5 eh], ...
        'HorizontalAlignment','left',...
        'Tag','DelButton',...
        'UserData',p,...
        'CallBack','qq_retindex_edit(2.2)',...
        'Style','Pushbutton',...
	    'String','Delete');  
end

pos=pos-gh;
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.accept, ...
    'Position',[x(1)+bw*1.2+ho pos bw*0.5 eh], ...
    'HorizontalAlignment','left',...
    'Tag','AddButton',...
    'Style','Pushbutton',...
    'CallBack','qq_retindex_edit(2.1)',...
	'String','Add');



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;
gw=positions.gw;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='RiEditWin'; winpar{2}='Q: RI Edit';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_retindex_edit(99)',3,'CloseBtn');
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_retindex_edit(99)',3,'AcceptBtn');

p=p+1;[ui{p,1:8}] = deal('Current:  ','Text',colors.bc,[x(5) y(1)-gh/4 bw bh],'',2,'','-r');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6) y(1) bw*2 eh],'qq_retindex_edit(4.1)',2,'CurrentEdit');

p=p+1;[ui{p,1:7}] = deal('Files in memory','Text',colors.bc,[x(6) y(2) bw*1.5 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(6) y(9) bw*1.5 gh*7],'qq_retindex_edit(3.1)',2,'MemFilesList');

p=p+1;[ui{p,1:7}] = deal('Files on disk','Text',colors.bc,[x(8)+bw/2 y(2) bw*1.5 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Not implemented','Listbox',[1 1 1],[x(8)+bw/2 y(9) bw*1.5 gh*7],'',2,'DiskFilesList');

p=p+1;[ui{p,1:7}] = deal('Use','PushButton',colors.accept,[x(7)+gw/2 y(3) bw/2 bh],'qq_retindex_edit(3.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Dupl.','PushButton',colors.btn{6},[x(7)+gw/2 y(4) bw/2 bh],'qq_retindex_edit(3.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('New','PushButton',colors.btn{6},[x(7)+gw/2 y(5) bw/2 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Delete','PushButton',colors.reset,[x(7)+gw/2 y(6) bw/2 bh],'qq_retindex_edit(3.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('<- Load','PushButton',colors.btn{6},[x(7)+gw/2 y(7) bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Save ->','PushButton',colors.btn{6},[x(7)+gw/2 y(8) bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Delete','PushButton',colors.reset,[x(8) y(9) bw/2 bh],'',2,'');

p=p+1;[ui{p,1:7}] = deal('Search Criteria (Optional)','Text',colors.bc,[x(6) y(10)-gh/4 bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('N.Scans:','Text',colors.bc,[x(6) y(11) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6)+bw/2 y(11) bw eh],'qq_retindex_edit(6.1)',2,'NScansEdit');
p=p+1;[ui{p,1:7}] = deal('End time:','Text',colors.bc,[x(8) y(11) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(8)+bw/2 y(11) bw eh],'qq_retindex_edit(6.2)',2,'EndTimeEdit');

updfcn='qq_retindex_edit(100)';
h0=qq_drawwin(winpar,ui,updfcn); 
set(h0,'KeyPressFcn','qq_retindex_edit(96)')
set(h0,'CloseRequestFcn','qq_retindex_edit(99)')

h=findobj('Style','PopupMenu'); set(h,'FontName','FixedWidth','FontWeight','Normal')

drawnow









