function qq_settings(an)

global metset fileset locset

qq_message(2)

if an==1
    wintag=get(gcf,'Tag');
    openwin
    getmets
    settoggle(wintag)
    evaltoggle
end

% Togglebuttons
if an==1.1
    h=findobj('Tag','WinToggle'); set(h,'Value',0); set(gco,'Value',1); evaltoggle 
end

% Textset
if an==2.1 txtstr=get(gco,'String'); vn=get(gco,'UserData'); metset.(vn)=txtstr; end
% Numset
if an==2.2 txtstr=get(gco,'String'); num=str2double(txtstr); vn=get(gco,'UserData'); metset.(vn)=num; end    
% Intset
if an==2.25 txtstr=get(gco,'String'); num=round(str2double(txtstr)); vn=get(gco,'UserData'); metset.(vn)=num; set(gco,'String',num2str(num)); end    
% Checkbox
if an==2.3 num=get(gco,'Value'); vn=get(gco,'UserData'); metset.(vn)=num; end        
% Checkbox
if an==2.4 num=get(gco,'Value'); str=get(gco,'String'); vn=get(gco,'UserData'); metset.(vn)=str{num}; end    
% Path settings
if an==2.5 || an==2.6 res=checkdir; end
if an==2.5 && res(1)==1 txtstr=get(gco,'String'); vn=get(gco,'UserData'); locset.(vn)=txtstr; end
if an==2.6 && res(2)==1 txtstr=get(gco,'String'); vn=get(gco,'UserData'); metset.(vn)=txtstr; end

% Changes to locset
% Textset
if an==4.1 txtstr=get(gco,'String'); vn=get(gco,'UserData'); locset.(vn)=txtstr; end
% Numset
if an==4.2 txtstr=get(gco,'String'); num=str2double(txtstr); vn=get(gco,'UserData'); locset.(vn)=num; end    
% Checkbox
if an==4.3 num=get(gco,'Value'); vn=get(gco,'UserData'); locset.(vn)=num; end        
% Checkbox
if an==4.4 num=get(gco,'Value'); str=get(gco,'String'); vn=get(gco,'UserData'); locset.(vn)=str{num}; end  

% Save
if an==3.1
    fn=fieldnames(metset); n=length(fn);
    h=findobj('Tag','CurrentMethEdit'); currentmeth=get(h,'String'); pathname=[locset.path_method,'\met_',currentmeth,'.mat'];
    metset.file_method=currentmeth; 
    for x=1:n tempmet.(fn{x})=metset.(fn{x}); end
    %save(pathname,'tempmet'); old
    qq_savefile(pathname,tempmet,'-o')
end

% Load
if an==3.2
    h=findobj('Tag','MethsPop'); str=get(h,'String'); val=get(h,'Value');    
    h=findobj('Tag','CurrentMethEdit'); set(h,'String',str{val});
    currentmeth=str{val}; pathname=[locset.path_method,'\met_',currentmeth,'.mat']; 
    load(pathname);
    tempmet.dummy=[]; fn=fieldnames(tempmet); n=length(fn);
    for x=1:n metset.(fn{x})=tempmet.(fn{x}); end   
end

if an>3.0 & an<=3.9  
    getmets
    evaltoggle
    fileset.global_methodfile=currentmeth; % Setter metodenavn i fileset (riktig metode kan loades)
    h=findobj('Tag','CurrMethTxt'); set(h,'String',['Current Method: ' fileset.global_methodfile])
end

% Store local settings
if an==4
    Savesettings=locset;
    VersionPop=findobj(gcf,'Tag','SetFrEd','UserData','VersionPop');
    codes=get(VersionPop,'String'); val=get(VersionPop,'Value'); Savesettings.version=codes{val};
    qq_setlocset(Savesettings)    
end
% Select code
if an==4.5
    codes=get(gcbo,'String'); val=get(gcbo,'Value'); selectedversion=codes{val}; 
    currentversion=locset.version;
    if ~strcmp(selectedversion,currentversion) qq_message(1,['|b|New code selected. Press [Save local settings] and restart to change from ' currentversion]); end
end


% =========================================================================
%                         S U B F U N C T I O N S
% =========================================================================

function listCell=readlist(pathName)

readNext=1; lineNo=0; listCell=[];
fid = fopen(pathName,'r');
while readNext==1 && fid ~=-1
    tline=fgetl(fid);
    if isnumeric(tline) && tline==-1 
        readNext=-1; fclose(fid);
    else
        if ~isempty(tline)
            lineNo=lineNo+1;
            listCell{lineNo}=tline;
        end
    end   
end


% ------------------- Checkdir ---------------------
function res=checkdir
global locset metset
res=[1 1];

currentvar=get(gcbo,'UserData');
loch=findobj('UserData',currentvar,'CallBack','qq_settings(2.5)');
meth=findobj('UserData',currentvar,'CallBack','qq_settings(2.6)');
set(loch,'BackgroundColor',[1 1 1]);
set(meth,'BackgroundColor',[1 1 1]);

allpath=[get(loch,'String') '\' get(meth,'String')]; isall=isdir(allpath);
locpath=[get(loch,'String')]; isloc=isdir(locpath);

if isall==0 && isloc==0
    set(loch,'BackgroundColor',[1 1 0]);  set(loch,'String',locset.(currentvar)); res(1)=0;
    if isempty(meth)==0
        set(meth,'BackgroundColor',[1 1 0]);  set(meth,'String',metset.(currentvar)); res(2)=0;
    end   
end
if isall==0 && isloc==1 && isempty(meth)==0
    set(meth,'BackgroundColor',[1 1 0]); set(meth,'String',metset.(currentvar)); res(2)=0;
end 

if sum(res)<2 qq_message(1,['|r|' allpath ' Does not exist']); end


% ------------------- settoggle ---------------------
function settoggle(wintag)

wintoggles=findobj('Tag','WinToggle'); set(wintoggles,'Value',0)

%wintag % TEMP
a=0;
if strmatch(wintag,'MainWin') wintoggle=findobj(wintoggles,'String','General'); set(wintoggle,'Value',1); a=1; end
if strmatch(wintag,'LoadWin') wintoggle=findobj(wintoggles,'String','Load/Files'); set(wintoggle,'Value',1); a=1; end
if strmatch(wintag,'BlWin') wintoggle=findobj(wintoggles,'String','Baseline / Detect'); set(wintoggle,'Value',1); a=1; end
if strmatch(wintag,'PeakWin') wintoggle=findobj(wintoggles,'String','Baseline / Detect'); set(wintoggle,'Value',1); a=1; end
if strmatch(wintag,'QuantWin') wintoggle=findobj(wintoggles,'String','Quantify'); set(wintoggle,'Value',1); a=1; end
if strmatch(wintag,'ResultsWin') wintoggle=findobj(wintoggles,'String','Results'); set(wintoggle,'Value',1); a=1; end
if a==0 wintoggle=findobj(wintoggles,'String','General'); set(wintoggle,'Value',1); end
% Problem hvis ingen satt!!

% ------------------- EVALTOGGLE ---------------------
function evaltoggle
h=findobj('Tag','WinToggle'); h=findobj(h,'Value',1); str=get(h,'String');
if strmatch(str,'Load/Files') setpath; end
if strmatch(str,'General') setglobal; end
if strmatch(str,'Baseline / Detect') setpeak; end
if strmatch(str,'Quantify') setquant; end
if strmatch(str,'Results') setres; end
if strmatch(str,'Library') setlib; end
if strmatch(str,'Class Def.') setclass; end

% ------------------- getmets ---------------------
function getmets
global metset locset
%disp('---- GETMETS ----')

pathname=[locset.path_method,'\met_*'];
DD=dir(pathname); 
n=length(DD);

for x=1:n
    nam=DD(x).name;
    fn{x}=nam(5:length(nam)-4);
end

h=findobj('Tag','MethsPop');  set(h,'String',fn);
pos=strmatch(metset.file_method,fn,'exact'); if isempty(pos) pos=1; end
set(h,'Value',pos)
%disp('---- end GETMETS ----')

% ------------------- CLEARFRAME ---------------------
function clearframe
%disp('---- CLEARFRAME ----')

h=findobj('Tag','SetFrTxt'); delete(h);
h=findobj('Tag','SetFrEd'); delete(h);
h=findobj('Tag','SetFrSep'); delete(h);
h=findobj('Tag','SetFrCh'); delete(h);
h=findobj('Tag','SetFrBtn'); delete(h);
%disp('---- end CLEARFRAME ----') SetFrBtn

% ============================== SET___ =================================

% ------------------- SETPEAK ---------------------
function setpeak
global metset

clearframe;
pos=0.8;

pos=int_set(pos,'Var-Win size:','baseline_winsize','Size of VarWin window (number of scans)');
pos=num_set(pos,'Sensitivity:','baseline_sens','Baseline sensitivity (5-95)');
pos=int_set(pos,'CODA win size:','baseline_codawin','Size of CODA window (number of scans)');
pos=num_set(pos,'CODA threshold:','baseline_codathresh','CODA threshold (<1, >0)');
pos=separator(pos,1);
pos=num_set(pos,'Leftbase:','peak_leftbase','');
pos=num_set(pos,'Rightbase:','peak_rightbase','');
pos=separator(pos,1);
pos=num_set(pos,'Min WHH:','peak_minwhh','Minimum peak width at half height (number of scans)');
pos=int_set(pos,'Smooth Window:','peak_smoothwin','Size of smooth window (number of scans)');

% ------------------- SETQUANT ---------------------
function setquant
global metset

clearframe;
pos=0.8;
pos=num_set(pos,'Integration tresh:','integrate_tresh','');
pos=check_set(pos,'Fit Basel:','integrate_blfit','Autointegration: Baseline drop / Fit baseline');
pos=check_set(pos,'Fill:','integrate_fill','Integration: Show filled areas');
% ------------------- SETGLOBAL ---------------------
function setglobal
global metset locset

clearframe;

% Class
D=dir([locset.path_library,'/class_*']); % Leser klasser fra Library-dir
D=D(find(cat(2,D.isdir))); 
if isempty(D) qq_message(1,'|r|Warning: Compound classes not found. Check library path in qq_localsettings'); end
DD{1}='-'; for x=1:length(D) DD{x}=D(x).name(7:length(D(x).name)); end % Variabel for klasse-navn
pos=0.8;
pos=pop_set(pos,'Class:',DD,'global_class','Compound class');
% Columnslist
pathName=[locset.path_root '\code\' locset.version '\columnslist.csv'];
listCell=qq_readlist(pathName); if ~isempty(listCell)  metset.global_columns=listCell; end
pos=pop_set(pos,'Column:',metset.global_columns,'global_selcol','Select column');
pos=separator(pos,1);
pos=check_set(pos,'Save in Matlab v6.x format','global_saveas_v6','');
pos=check_set(pos,'Overwrite without warning','global_overwrite','Results files, reports and filters (other files are always overwritten)');
pos=check_set(pos,'Automatically create folders','global_makedir','');

% ------------------- SETPATH ---------------------
function setpath
global metset locset positions colors

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 

clearframe;

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(2) y(3) bw*2.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String','Local Settings',...
    'FontSize',12,...
    'Tag','SetFrTxt',...
    'HorizontalAlignment','Center');
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(4)+bw/2 y(3) bw*2.3 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String','Method Settings',...
    'FontSize',12,...
    'Tag','SetFrTxt',...
    'HorizontalAlignment','Center');

defaultfolders=0; if isfield(locset,'defaultfolders') && locset.defaultfolders==1 defaultfolders=1; end
pos=0.8; 
metset.path_class=['class_' metset.global_class];
folderpos(1)=pos; pos=path_set(pos,{'Q Rawdata:','path_qqraw','path_qqraw','Directory for QQ-Rawdata (Mat format)'});
folderpos(2)=pos; pos=path_set(pos,{'Results:','path_results','path_results','Stored results directory'});
folderpos(3)=pos; pos=path_set(pos,{'Reports:','path_reports','path_reports','Stored reports directory'});
folderpos(4)=pos; pos=path_set(pos,{'Libraries:','path_library','path_class','Directory for libraries (By class)','r'});
folderpos(5)=pos; pos=path_set(pos,{'Export:','path_export','path_export','Export directory'});
if defaultfolders folderpos(6)=pos; pos=text_set(pos,'Default folders','Folders set to default at start. Controlled by ''defaultfolders'' in qq_localsettings',''); end
pos=separator(pos,1);
pos=path_set(pos,{'Agilent Import:','path_agilent','path_agilent','HP/Agilent MS Chemstation format'});
pos=path_set(pos,{'CDF Import:','path_cdf','path_cdf','AIA-CDF import'});
pos=path_set(pos,{'Extricator Import:','path_prs','path_prs','Exportet mat files from PRS Extricator'});
pos=path_set(pos,{'Matlab Import:','path_matlab','path_matlab','Various mat formats'});
pos=path_set(pos,{'CSV Import:','path_csv','path_csv','Comma separated values'});
pos=path_set(pos,{'NIST library:','path_nist','','Path to NIST MS library where nistms$.exe is located'});

if defaultfolders
    for fn=1:length(folderpos)
        uicontrol('Parent',gcf,'BackgroundColor',[0 1 0],'Position',[x(2)-bw*0.15 folderpos(fn)+eh*0.3 bw*0.10 eh*0.6],'Style','Text','Tag','SetFrEd');
    end
end

% Finds code versions
D=dir([locset.path_root,'\code']); DD=D(cat(2,D.isdir));
cn=0;
for t=1:length(DD)
    if ~(strcmp(DD(t).name,'.') || strcmp(DD(t).name,'..'))
        cn=cn+1; codestr{cn}=DD(t).name;
    end
end

currentversion=strmatch(locset.version,codestr,'exact');
if isempty(currentversion) || length(currentversion)>1 currentversion=1; end

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(1) pos bw*1.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String','Code version:',...
    'Tag','SetFrTxt');

popmen = uicontrol('Parent',gcf, ...
    'BackgroundColor',[1 1 1], ...
	'Position',[x(2) pos bw eh], ...
    'HorizontalAlignment','left',...
    'Style','Popupmenu',...
    'Value',currentversion,...
    'Callback','qq_settings(4.5)',...
    'Tag','SetFrEd',...
    'UserData','VersionPop',...
	'String',codestr);

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.btn{6}, ...
	'Position',[x(3)+bw/2 pos bw bh], ...
    'Style','Pushbutton',...
	'String','Save local settings',...
    'FontSize',10,...
    'Tag','SetFrBtn',...
    'HorizontalAlignment','Center',...
    'Callback','qq_settings(4.0)');



% ------------------- SETRES ---------------------
function setres
global metset

clearframe;
pos=0.8;
pos=num_set(pos,'Homolog RI Dist:','results_homridiff','Distance in RI units between homologs');
pos=check_set(pos,'Fit peak parameters','results_peakfit','Calculate peak parameters by gaussian fit');
pos=check_set(pos,'Kurtosis = 1','results_kurt','Off allows kurtosis different from 1 (slow calculation)');
pos=num_set(pos,'Fit to peakwidth (sigma):','results_sigma','Peakwith (standard deviations) used in fitting function (=> 4)');
pos=separator(pos,1);
pos=pop_set(pos,'Spreadsheet report',metset.report_spreadsheets,'report_spreadsheet','');


% ------------------- SETLIB ---------------------
function setlib
global metset

qq_libset(1);

% ------------------- SETCLASS ---------------------
function setclass
global metset

qq_classdef(1);

% ============================= EDIT FUNCTIONS =================================

% ------------------- pop_set ---------------------
function pos=pop_set(pos,txtstr,alt_cell,vn,expl)
% pos: vert. position, txtstr: tekst, alt_cell: Celle med alternativer, vn: fieldname; expl: forklaring 
global positions colors metset

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(1) pos bw*1.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String',txtstr,...
    'Tag','SetFrTxt');
popmen = uicontrol('Parent',gcf, ...
    'BackgroundColor',[1 1 1], ...
	'Position',[x(2)+bw/2 pos bw*3 eh], ...
    'HorizontalAlignment','left',...
    'Style','Popupmenu',...
    'UserData',vn,...
    'Callback','qq_settings(2.4)',...
    'Tag','SetFrEd',...
	'String',alt_cell);
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(6) pos bw*3 eh], ...
    'HorizontalAlignment','left',...
    'Tag','SetFrTxt',...
    'Style','Text',...
	'String',expl);
pos=pos-gh;

val=strmatch(metset.(vn),alt_cell);
if isempty(val) val=1; end
set(popmen,'Value',val);

% ------------------- path_set ---------------------
function pos=path_set(pos,incell)
global positions colors metset locset

txtstr=incell{1}; locset_vn=incell{2}; metset_vn=incell{3}; expl=incell{4}; 
dstr=''; if length(incell)==5 dstr=incell{5}; end

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(1) pos bw*1.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String',txtstr,...
    'Tag','SetFrTxt');

if isfield(locset,(locset_vn))==0 locset.(locset_vn)=''; end    
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',[1 1 1], ...
	'Position',[x(2) pos bw*2.5 eh], ...
    'HorizontalAlignment','left',...
    'Style','Edit',...
    'UserData',locset_vn,...
    'Callback','qq_settings(2.5)',...
    'Tag','SetFrEd',...
	'String',locset.(locset_vn));
if dstr=='l'; set(h1,'Enable','off'); end
if isdir(locset.(locset_vn))==0 set(h1,'BackgroundColor',[1 1 0]); end

if isempty(metset_vn)==0
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[1 1 1], ...
    	'Position',[x(4)+bw/2 pos bw*2.3 eh], ...
        'HorizontalAlignment','left',...
        'Style','Edit',...
        'UserData',metset_vn,...
        'Callback','qq_settings(2.6)',...
        'Tag','SetFrEd',...
	    'String',metset.(metset_vn));    
    if dstr=='r'; set(h1,'Enable','off'); end
    if isdir([locset.(locset_vn) '\' metset.(metset_vn)])==0 set(h1,'BackgroundColor',[1 1 0]); end
end

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(7) pos bw*2.5 eh], ...
    'HorizontalAlignment','left',...
    'Tag','SetFrTxt',...
    'Style','Text',...
	'String',expl);
pos=pos-gh;

% ------------------- text_set ---------------------
function pos=text_set(pos,txtstr1,txtstr2,txtstr3)
global positions colors 

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(1) pos bw*1.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String',txtstr1,...
    'Tag','SetFrTxt');
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(2) pos bw*5 eh], ...
    'HorizontalAlignment','left',...
    'Style','Text',...
    'Tag','SetFrTxt',...
	'String',txtstr2);
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(7) pos bw*2.5 eh], ...
    'HorizontalAlignment','left',...
    'Tag','SetFrTxt',...
    'Style','Text',...
	'String',txtstr3);

pos=pos-gh;

% ------------------- num_set ---------------------
function pos=num_set(pos,txtstr,vn,expl)
global positions colors metset

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(1) pos bw*1.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String',txtstr,...
    'Tag','SetFrTxt');
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',[1 1 1], ...
	'Position',[x(2)+bw/2 pos bw/2 eh], ...
    'HorizontalAlignment','right',...
    'Style','Edit',...
    'UserData',vn,...
    'Callback','qq_settings(2.2)',...
    'Tag','SetFrEd',...
	'String',metset.(vn));
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(3)+bw/3 pos bw*5 eh], ...
    'HorizontalAlignment','left',...
    'Tag','SetFrTxt',...
    'Style','Text',...
	'String',expl);
pos=pos-gh;

% ------------------- int_set ---------------------
function pos=int_set(pos,txtstr,vn,expl)
global positions colors metset

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(1) pos bw*1.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String',txtstr,...
    'Tag','SetFrTxt');
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',[1 1 1], ...
	'Position',[x(2)+bw/2 pos bw/2 eh], ...
    'HorizontalAlignment','right',...
    'Style','Edit',...
    'UserData',vn,...
    'Callback','qq_settings(2.25)',...
    'Tag','SetFrEd',...
	'String',metset.(vn));
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(3)+bw/3 pos bw*5 eh], ...
    'HorizontalAlignment','left',...
    'Tag','SetFrTxt',...
    'Style','Text',...
	'String',expl);
pos=pos-gh;

% ------------------- check_set ---------------------
function pos=check_set(pos,txtstr,vn,expl)
global positions colors metset

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 

h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(1) pos bw*1.5 eh], ...
    'Style','Text',...
    'HorizontalAlignment','left',...
	'String',txtstr,...
    'Tag','SetFrTxt');
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(2)+bw/2 pos bw/3 eh], ...
    'HorizontalAlignment','right',...
    'Style','Checkbox',...
    'UserData',vn,...
    'Callback','qq_settings(2.3)',...
    'Value',metset.(vn),...
    'Tag','SetFrCh');
h1 = uicontrol('Parent',gcf, ...
    'BackgroundColor',colors.bc, ...
	'Position',[x(3)+bw/3 pos bw*5 eh], ...
    'HorizontalAlignment','left',...
    'Tag','SetFrTxt',...
    'Style','Text',...
	'String',expl);
pos=pos-gh;

% ------------------- Separator ---------------------
function pos=separator(pos,an)
global positions colors metset

bw=positions.bw; bh=positions.bh; eh=positions.eh; gh=positions.gh;% 
x=0.055:positions.gw:1; y=0.93:-positions.gh:0; 
pos=pos+gh/1.7;

if an==1
    h1 = uicontrol('Parent',gcf, ...
        'BackgroundColor',[0 0 0], ...
	    'Position',[x(1) pos bw*8 0.002], ...
        'Tag','SetFrSep',...
        'Style','Frame');
end
pos=pos-gh;


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global fonts positions colors metset
%disp('---- OPENWIN ----')

bw=positions.bw;
bh=positions.bh;
eh=positions.eh;
gh=positions.gh;% grid height
o2=(bw*2+(bw*2/3))/3; 
buw=bw*1.3;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % horisontalt grid

winpar{1}='SetWin'; winpar{2}='Q: Settings';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% FRAME

p=p+1;[ui{p,1:7}] = deal(['Current Method: ' metset.file_method],'Text',colors.bc,[x(1) y(2) bw*4 bh],'',3,'CurrMethTxt');
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1) y(18) bw*9 y(2)-y(18)],'',2,'');
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_classdef(99); qq_closewin',3,'');
% Load/Save Method
vp=y(20)+bh/2;
p=p+1;[ui{p,1:7}] = deal('Load Meth.','Pushbutton',colors.btn{6},[x(3) vp bw bh],'qq_settings(3.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Save Meth.','Pushbutton',colors.btn{6},[x(6) vp bw bh],'qq_settings(3.1)',2,'');

p=p+1;[ui{p,1:7}] = deal(metset.file_method,'Edit',[1 1 1],[x(7) vp bw*1.5 bh],'',2,'CurrentMethEdit');
p=p+1;[ui{p,1:7}] = deal('-','Popupmenu',[1 1 1],[x(4) vp bw*1.5 bh],'',2,'MethsPop');

o=0;   p=p+1;[ui{p,1:7}] = deal('General','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');
o=o+1; p=p+1;[ui{p,1:7}] = deal('Load/Files','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');
%o=o+1; p=p+1;[ui{p,1:7}] = deal('Baseline','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');
o=o+1; p=p+1;[ui{p,1:7}] = deal('Baseline / Detect','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');
o=o+1; p=p+1;[ui{p,1:7}] = deal('Quantify','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');
o=o+1; p=p+1;[ui{p,1:7}] = deal('Results','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');
o=o+1; p=p+1;[ui{p,1:7}] = deal('Library','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');
o=o+1; p=p+1;[ui{p,1:7}] = deal('Class Def.','Togglebutton',colors.btn{3},[x(1)+o*buw y(1) buw bh],'qq_settings(1.1)',2,'WinToggle');


updfcn='qq_settings(100)';
h0=qq_drawwin(winpar,ui,updfcn); 

%h=findobj('Tag','MethTxt'); set(h,'HorizontalAlignment','Right')
h=findobj('Style','PopupMenu'); set(h,'FontName','FixedWidth','FontWeight','Normal')

